--Color picker window, related functions

Colorwindow = Turbine.UI.Lotro.Window(); --main window
Colorwindow:SetSize( 600, 230 );
Colorwindow:SetPosition( 100, 100 );
Colorwindow:SetVisible( false );
Colorwindow:SetMouseVisible( true );
Colorwindow:SetText( "Color" );
Colorwindow:SetZOrder( 11 );

MBarbutton = Turbine.UI.Lotro.Button();
MBarbutton:SetSize( 80, 30 );
MBarbutton:SetText( "Morale Bar" );
MBarbutton:SetVisible( true );
MBarbutton:SetParent( Colorwindow );
MBarbutton:SetPosition( 15, 50 );
MBarbutton:SetEnabled( false );

PBarbutton = Turbine.UI.Lotro.Button();
PBarbutton:SetSize( 80, 30 );
PBarbutton:SetText( "Power Bar" );
PBarbutton:SetVisible( true );
PBarbutton:SetParent( Colorwindow );
PBarbutton:SetPosition( 15, 75 );


TBarbutton = Turbine.UI.Lotro.Button();
TBarbutton:SetSize( 80, 30 );
TBarbutton:SetText( "Temp. Bar" );
TBarbutton:SetVisible( true );
TBarbutton:SetParent( Colorwindow );
TBarbutton:SetPosition( 15, 100 );


MTextbutton = Turbine.UI.Lotro.Button();
MTextbutton:SetSize( 80, 30 );
MTextbutton:SetText( "Morale Text" );
MTextbutton:SetVisible( true );
MTextbutton:SetParent( Colorwindow );
MTextbutton:SetPosition( 15, 125 );


PTextbutton = Turbine.UI.Lotro.Button();
PTextbutton:SetSize( 80, 30 );
PTextbutton:SetText( "Power Text" );
PTextbutton:SetVisible( true );
PTextbutton:SetParent( Colorwindow );
PTextbutton:SetPosition( 15, 150 );

MWindow = Turbine.UI.Window();
MWindow:SetParent( Colorwindow );
MWindow:SetSize( 500, 200 );
MWindow:SetPosition( 100, 0 );
MWindow:SetVisible( true );
MWindow:SetMouseVisible( false );
MWindow:SetZOrder( 10 );

MRSB = SettingsScroll();
MRSB:SetParent( MWindow );
MRSB:SetMinimum( 0 );
MRSB:SetMaximum( 255 );
MRSB:SetSmallChange( 1 );
MRSB:SetLargeChange( 20 );
MRSB:SetPosition( 10, 50 );
MRSB.ValueChanged = function()
	rcompmbackcolor = ( MRSB:GetValue() / 255 )
	mbackcolor = Turbine.UI.Color( rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	MCP:SetBackColor( mbackcolor )
	MRSBL:SetText( "Red - "..( rcompmbackcolor * 255 ) )
end

MGSB = SettingsScroll();
MGSB:SetParent( MWindow );
MGSB:SetMinimum( 0 )
MGSB:SetMaximum( 255 )
MGSB:SetSmallChange( 1 );
MGSB:SetLargeChange( 20 );
MGSB:SetPosition( 10, 65 );
MGSB.ValueChanged = function()
	gcompmbackcolor = ( MGSB:GetValue() / 255 )
	mbackcolor = Turbine.UI.Color( rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	MCP:SetBackColor( mbackcolor )
	MGSBL:SetText( "Green - "..( gcompmbackcolor * 255 ) )
end

MBSB = SettingsScroll();
MBSB:SetParent( MWindow );
MBSB:SetMinimum( 0 )
MBSB:SetMaximum( 255 )
MBSB:SetSmallChange( 1 );
MBSB:SetLargeChange( 20 );
MBSB:SetPosition( 10, 80 );
MBSB.ValueChanged = function()
	bcompmbackcolor = ( MBSB:GetValue() / 255 )
	mbackcolor = Turbine.UI.Color( rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	MCP:SetBackColor( mbackcolor )
	MBSBL:SetText( "Blue - "..( bcompmbackcolor * 255 ) )
end

MRSBL = ScrollLabel();
MRSBL:SetPosition( 310, 50 );
MRSBL:SetParent( MWindow );
MRSBL:SetText( "Red - 255" )

MGSBL = ScrollLabel();
MGSBL:SetPosition( 310, 65 );
MGSBL:SetParent( MWindow );
MGSBL:SetText( "Green - 255" )

MBSBL = ScrollLabel();
MBSBL:SetPosition( 310, 80 );
MBSBL:SetParent( MWindow );
MBSBL:SetText( "Blue - 255" )

--

M2RSB = SettingsScroll();
M2RSB:SetParent( MWindow );
M2RSB:SetMinimum( 0 );
M2RSB:SetMaximum( 255 );
M2RSB:SetSmallChange( 1 );
M2RSB:SetLargeChange( 20 );
M2RSB:SetPosition( 10, 105 );
M2RSB.ValueChanged = function()
	rcompm2backcolor = ( M2RSB:GetValue() / 255 )
	m2backcolor = Turbine.UI.Color( rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	M2CP:SetBackColor( m2backcolor )
	M2RSBL:SetText( "Red - "..( rcompm2backcolor * 255 ) )
end

M2GSB = SettingsScroll();
M2GSB:SetParent( MWindow );
M2GSB:SetMinimum( 0 )
M2GSB:SetMaximum( 255 )
M2GSB:SetSmallChange( 1 );
M2GSB:SetLargeChange( 20 );
M2GSB:SetPosition( 10, 120 );
M2GSB.ValueChanged = function()
	gcompm2backcolor = ( M2GSB:GetValue() / 255 )
	m2backcolor = Turbine.UI.Color( rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	M2CP:SetBackColor( m2backcolor )
	M2GSBL:SetText( "Green - "..( gcompm2backcolor * 255 ) )
end

M2BSB = SettingsScroll();
M2BSB:SetParent( MWindow );
M2BSB:SetMinimum( 0 )
M2BSB:SetMaximum( 255 )
M2BSB:SetSmallChange( 1 );
M2BSB:SetLargeChange( 20 );
M2BSB:SetPosition( 10, 135 );
M2BSB.ValueChanged = function()
	bcompm2backcolor = ( M2BSB:GetValue() / 255 )
	m2backcolor = Turbine.UI.Color( rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	M2CP:SetBackColor( m2backcolor )
	M2BSBL:SetText( "Blue - "..( bcompm2backcolor * 255 ) )
end

M2RSBL = ScrollLabel();
M2RSBL:SetPosition( 310, 105 );
M2RSBL:SetParent( MWindow );
M2RSBL:SetText( "Red - 255" )

M2GSBL = ScrollLabel();
M2GSBL:SetPosition( 310, 120 );
M2GSBL:SetParent( MWindow );
M2GSBL:SetText( "Green - 255" )

M2BSBL = ScrollLabel();
M2BSBL:SetPosition( 310, 135 );
M2BSBL:SetParent( MWindow );
M2BSBL:SetText( "Blue - 255" )

--

M3RSB = SettingsScroll();
M3RSB:SetParent( MWindow );
M3RSB:SetMinimum( 0 );
M3RSB:SetMaximum( 255 );
M3RSB:SetSmallChange( 1 );
M3RSB:SetLargeChange( 20 );
M3RSB:SetPosition( 10, 160 );
M3RSB.ValueChanged = function()
	rcompm3backcolor = ( M3RSB:GetValue() / 255 )
	m3backcolor = Turbine.UI.Color( rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	M3CP:SetBackColor( m3backcolor )
	M3RSBL:SetText( "Red - "..( rcompm3backcolor * 255 ) )
end

M3GSB = SettingsScroll();
M3GSB:SetParent( MWindow );
M3GSB:SetMinimum( 0 )
M3GSB:SetMaximum( 255 )
M3GSB:SetSmallChange( 1 );
M3GSB:SetLargeChange( 20 );
M3GSB:SetPosition( 10, 175 );
M3GSB.ValueChanged = function()
	gcompm3backcolor = ( M3GSB:GetValue() / 255 )
	m3backcolor = Turbine.UI.Color( rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	M3CP:SetBackColor( m3backcolor )
	M3GSBL:SetText( "Green - "..( gcompm3backcolor * 255 ) )
end

M3BSB = SettingsScroll();
M3BSB:SetParent( MWindow );
M3BSB:SetMinimum( 0 )
M3BSB:SetMaximum( 255 )
M3BSB:SetSmallChange( 1 );
M3BSB:SetLargeChange( 20 );
M3BSB:SetPosition( 10, 190 );
M3BSB.ValueChanged = function()
	bcompm3backcolor = ( M3BSB:GetValue() / 255 )
	m3backcolor = Turbine.UI.Color( rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	M3CP:SetBackColor( m3backcolor )
	M3BSBL:SetText( "Blue - "..( bcompm3backcolor * 255 ) )
end

M3RSBL = ScrollLabel();
M3RSBL:SetPosition( 310, 160 );
M3RSBL:SetParent( MWindow );
M3RSBL:SetText( "Red - 255" )

M3GSBL = ScrollLabel();
M3GSBL:SetPosition( 310,175 );
M3GSBL:SetParent( MWindow );
M3GSBL:SetText( "Green - 255" )

M3BSBL = ScrollLabel();
M3BSBL:SetPosition( 310, 190 );
M3BSBL:SetParent( MWindow );
M3BSBL:SetText( "Blue - 255" )

MCP = Turbine.UI.Control();
MCP:SetSize( 30, 30 );
MCP:SetParent( MWindow );
MCP:SetVisible( true );
MCP:SetMouseVisible( false );
MCP:SetPosition( 400, 55 );
MCP:SetBackColor( red );

M2CP = Turbine.UI.Control();
M2CP:SetSize( 30, 30 );
M2CP:SetParent( MWindow );
M2CP:SetVisible( true );
M2CP:SetMouseVisible( false );
M2CP:SetPosition( 400, 110 );
M2CP:SetBackColor( red );

M3CP = Turbine.UI.Control();
M3CP:SetSize( 30, 30 );
M3CP:SetParent( MWindow );
M3CP:SetVisible( true );
M3CP:SetMouseVisible( false );
M3CP:SetPosition( 400, 165 );
M3CP:SetBackColor( red );

MCPL = Turbine.UI.Label();
MCPL:SetSize( 80, 20 );
MCPL:SetMouseVisible( false );
MCPL:SetVisible( true );
MCPL:SetParent( MWindow );
MCPL:SetText( "Normal" );
MCPL:SetPosition( 440, 60 );

M2CPL = Turbine.UI.Label();
M2CPL:SetSize( 80, 20 );
M2CPL:SetMouseVisible( false );
M2CPL:SetVisible( true );
M2CPL:SetParent( MWindow );
M2CPL:SetText( "Low" );
M2CPL:SetPosition( 440, 115 );

M3CPL = Turbine.UI.Label();
M3CPL:SetSize( 80, 20 );
M3CPL:SetMouseVisible( false );
M3CPL:SetVisible( true );
M3CPL:SetParent( MWindow );
M3CPL:SetText( "Critical" );
M3CPL:SetPosition( 440, 170 );

--END OF MORALE OPTIONS---------------------------------------------------------------------------

PWindow = Turbine.UI.Window();
PWindow:SetParent( Colorwindow );
PWindow:SetSize( 500, 200 );
PWindow:SetPosition( 100, 0 );
PWindow:SetVisible( false );
PWindow:SetMouseVisible( false );
PWindow:SetZOrder( 10 );


PRSB = SettingsScroll();
PRSB:SetParent( PWindow );
PRSB:SetMinimum( 0 );
PRSB:SetMaximum( 255 );
PRSB:SetSmallChange( 1 );
PRSB:SetLargeChange( 20 );
PRSB:SetPosition( 10, 50 );
PRSB.ValueChanged = function()
	rcomppbackcolor = ( PRSB:GetValue() / 255 )
	pbackcolor = Turbine.UI.Color( rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	PCP:SetBackColor( pbackcolor )
	PRSBL:SetText( "Red - "..( rcomppbackcolor * 255 ) )
end

PGSB = SettingsScroll();
PGSB:SetParent( PWindow );
PGSB:SetMinimum( 0 )
PGSB:SetMaximum( 255 )
PGSB:SetSmallChange( 1 );
PGSB:SetLargeChange( 20 );
PGSB:SetPosition( 10, 65 );
PGSB.ValueChanged = function()
	gcomppbackcolor = ( PGSB:GetValue() / 255 )
	pbackcolor = Turbine.UI.Color( rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	PCP:SetBackColor( pbackcolor )
	PGSBL:SetText( "Green - "..( gcomppbackcolor * 255 ) )
end

PBSB = SettingsScroll();
PBSB:SetParent( PWindow );
PBSB:SetMinimum( 0 )
PBSB:SetMaximum( 255 )
PBSB:SetSmallChange( 1 );
PBSB:SetLargeChange( 20 );
PBSB:SetPosition( 10, 80 );
PBSB.ValueChanged = function()
	bcomppbackcolor = ( PBSB:GetValue() / 255 )
	pbackcolor = Turbine.UI.Color( rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	PCP:SetBackColor( pbackcolor )
	PBSBL:SetText( "Blue - "..( bcomppbackcolor * 255 ) )
end

PRSBL = ScrollLabel();
PRSBL:SetPosition( 310, 50 );
PRSBL:SetParent( PWindow );
PRSBL:SetText( "Red - 255" )

PGSBL = ScrollLabel();
PGSBL:SetPosition( 310, 65 );
PGSBL:SetParent( PWindow );
PGSBL:SetText( "Green - 255" )

PBSBL = ScrollLabel();
PBSBL:SetPosition( 310, 80 );
PBSBL:SetParent( PWindow );
PBSBL:SetText( "Blue - 255" )

--

P2RSB = SettingsScroll();
P2RSB:SetParent( PWindow );
P2RSB:SetMinimum( 0 );
P2RSB:SetMaximum( 255 );
P2RSB:SetSmallChange( 1 );
P2RSB:SetLargeChange( 20 );
P2RSB:SetPosition( 10, 105 );
P2RSB.ValueChanged = function()
	rcompp2backcolor = ( P2RSB:GetValue() / 255 )
	p2backcolor = Turbine.UI.Color( rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	P2CP:SetBackColor( p2backcolor )
	P2RSBL:SetText( "Red - "..( rcompp2backcolor * 255 ) )
end

P2GSB = SettingsScroll();
P2GSB:SetParent( PWindow );
P2GSB:SetMinimum( 0 )
P2GSB:SetMaximum( 255 )
P2GSB:SetSmallChange( 1 );
P2GSB:SetLargeChange( 20 );
P2GSB:SetPosition( 10, 120 );
P2GSB.ValueChanged = function()
	gcompp2backcolor = ( P2GSB:GetValue() / 255 )
	p2backcolor = Turbine.UI.Color( rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	P2CP:SetBackColor( p2backcolor )
	P2GSBL:SetText( "Green - "..( gcompp2backcolor * 255 ) )
end

P2BSB = SettingsScroll();
P2BSB:SetParent( PWindow );
P2BSB:SetMinimum( 0 )
P2BSB:SetMaximum( 255 )
P2BSB:SetSmallChange( 1 );
P2BSB:SetLargeChange( 20 );
P2BSB:SetPosition( 10, 135 );
P2BSB.ValueChanged = function()
	bcompp2backcolor = ( P2BSB:GetValue() / 255 )
	p2backcolor = Turbine.UI.Color( rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	P2CP:SetBackColor( p2backcolor )
	P2BSBL:SetText( "Blue - "..( bcompp2backcolor * 255 ) )
end

P2RSBL = ScrollLabel();
P2RSBL:SetPosition( 310, 105 );
P2RSBL:SetParent( PWindow );
P2RSBL:SetText( "Red - 255" )

P2GSBL = ScrollLabel();
P2GSBL:SetPosition( 310, 120 );
P2GSBL:SetParent( PWindow );
P2GSBL:SetText( "Green - 255" )

P2BSBL = ScrollLabel();
P2BSBL:SetPosition( 310, 135 );
P2BSBL:SetParent( PWindow );
P2BSBL:SetText( "Blue - 255" )

--

P3RSB = SettingsScroll();
P3RSB:SetParent( PWindow );
P3RSB:SetMinimum( 0 );
P3RSB:SetMaximum( 255 );
P3RSB:SetSmallChange( 1 );
P3RSB:SetLargeChange( 20 );
P3RSB:SetPosition( 10, 160 );
P3RSB.ValueChanged = function()
	rcompp3backcolor = ( P3RSB:GetValue() / 255 )
	p3backcolor = Turbine.UI.Color( rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	P3CP:SetBackColor( p3backcolor )
	P3RSBL:SetText( "Red - "..( rcompp3backcolor * 255 ) )
end

P3GSB = SettingsScroll();
P3GSB:SetParent( PWindow );
P3GSB:SetMinimum( 0 )
P3GSB:SetMaximum( 255 )
P3GSB:SetSmallChange( 1 );
P3GSB:SetLargeChange( 20 );
P3GSB:SetPosition( 10, 175 );
P3GSB.ValueChanged = function()
	gcompp3backcolor = ( P3GSB:GetValue() / 255 )
	p3backcolor = Turbine.UI.Color( rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	P3CP:SetBackColor( p3backcolor )
	P3GSBL:SetText( "Green - "..( gcompp3backcolor * 255 ) )
end

P3BSB = SettingsScroll();
P3BSB:SetParent( PWindow );
P3BSB:SetMinimum( 0 )
P3BSB:SetMaximum( 255 )
P3BSB:SetSmallChange( 1 );
P3BSB:SetLargeChange( 20 );
P3BSB:SetPosition( 10, 190 );
P3BSB.ValueChanged = function()
	bcompp3backcolor = ( P3BSB:GetValue() / 255 )
	p3backcolor = Turbine.UI.Color( rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	P3CP:SetBackColor( p3backcolor )
	P3BSBL:SetText( "Blue - "..( bcompp3backcolor * 255 ) )
end

P3RSBL = ScrollLabel();
P3RSBL:SetPosition( 310, 160 );
P3RSBL:SetParent( PWindow );
P3RSBL:SetText( "Red - 255" )

P3GSBL = ScrollLabel();
P3GSBL:SetPosition( 310,175 );
P3GSBL:SetParent( PWindow );
P3GSBL:SetText( "Green - 255" )

P3BSBL = ScrollLabel();
P3BSBL:SetPosition( 310, 190 );
P3BSBL:SetParent( PWindow );
P3BSBL:SetText( "Blue - 255" )

PCP = Turbine.UI.Control();
PCP:SetSize( 30, 30 );
PCP:SetParent( PWindow );
PCP:SetVisible( true );
PCP:SetMouseVisible( false );
PCP:SetPosition( 400, 55 );
PCP:SetBackColor( red );

P2CP = Turbine.UI.Control();
P2CP:SetSize( 30, 30 );
P2CP:SetParent( PWindow );
P2CP:SetVisible( true );
P2CP:SetMouseVisible( false );
P2CP:SetPosition( 400, 110 );
P2CP:SetBackColor( red );

P3CP = Turbine.UI.Control();
P3CP:SetSize( 30, 30 );
P3CP:SetParent( PWindow );
P3CP:SetVisible( true );
P3CP:SetMouseVisible( false );
P3CP:SetPosition( 400, 165 );
P3CP:SetBackColor( red );

PCPL = Turbine.UI.Label();
PCPL:SetSize( 80, 20 );
PCPL:SetMouseVisible( false );
PCPL:SetVisible( true );
PCPL:SetParent( PWindow );
PCPL:SetText( "Normal" );
PCPL:SetPosition( 440, 60 );

P2CPL = Turbine.UI.Label();
P2CPL:SetSize( 80, 20 );
P2CPL:SetMouseVisible( false );
P2CPL:SetVisible( true );
P2CPL:SetParent( PWindow );
P2CPL:SetText( "Low" );
P2CPL:SetPosition( 440, 115 );

P3CPL = Turbine.UI.Label();
P3CPL:SetSize( 80, 20 );
P3CPL:SetMouseVisible( false );
P3CPL:SetVisible( true );
P3CPL:SetParent( PWindow );
P3CPL:SetText( "Critical" );
P3CPL:SetPosition( 440, 170 );

--END OF POWER OPTIONS-----------------------------------------------------------

TWindow = Turbine.UI.Window();
TWindow:SetParent( Colorwindow );
TWindow:SetSize( 500, 200 );
TWindow:SetPosition( 100, 0 );
TWindow:SetVisible( false );
TWindow:SetMouseVisible( false );
TWindow:SetZOrder( 10 );

TRSB = SettingsScroll();
TRSB:SetParent( TWindow );
TRSB:SetMinimum( 0 );
TRSB:SetMaximum( 255 );
TRSB:SetSmallChange( 1 );
TRSB:SetLargeChange( 20 );
TRSB:SetPosition( 10, 50 );
TRSB.ValueChanged = function()
	rcomptbackcolor = ( TRSB:GetValue() / 255 )
	tbackcolor = Turbine.UI.Color( rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
	TCP:SetBackColor( tbackcolor )
	MBarT:SetBackColor( tbackcolor )
	TRSBL:SetText( "Red - "..( rcomptbackcolor * 255 ) )
end

TGSB = SettingsScroll();
TGSB:SetParent( TWindow );
TGSB:SetMinimum( 0 )
TGSB:SetMaximum( 255 )
TGSB:SetSmallChange( 1 );
TGSB:SetLargeChange( 20 );
TGSB:SetPosition( 10, 65 );
TGSB.ValueChanged = function()
	gcomptbackcolor = ( TGSB:GetValue() / 255 )
	tbackcolor = Turbine.UI.Color( rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
	TCP:SetBackColor( tbackcolor )
	MBarT:SetBackColor( tbackcolor )
	TGSBL:SetText( "Green - "..( gcomptbackcolor * 255 ) )
end

TBSB = SettingsScroll();
TBSB:SetParent( TWindow );
TBSB:SetMinimum( 0 )
TBSB:SetMaximum( 255 )
TBSB:SetSmallChange( 1 );
TBSB:SetLargeChange( 20 );
TBSB:SetPosition( 10, 80 );
TBSB.ValueChanged = function()
	bcomptbackcolor = ( TBSB:GetValue() / 255 )
	tbackcolor = Turbine.UI.Color( rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
	TCP:SetBackColor( tbackcolor )
	MBarT:SetBackColor( tbackcolor )
	TBSBL:SetText( "Blue - "..( bcomptbackcolor * 255 ) )
end

TRSBL = ScrollLabel();
TRSBL:SetPosition( 310, 50 );
TRSBL:SetParent( TWindow );
TRSBL:SetText( "Red - 255" )

TGSBL = ScrollLabel();
TGSBL:SetPosition( 310, 65 );
TGSBL:SetParent( TWindow );
TGSBL:SetText( "Green - 255" )

TBSBL = ScrollLabel();
TBSBL:SetPosition( 310, 80 );
TBSBL:SetParent( TWindow );
TBSBL:SetText( "Blue - 255" )

TCP = Turbine.UI.Control();
TCP:SetSize( 30, 30 );
TCP:SetParent( TWindow );
TCP:SetVisible( true );
TCP:SetMouseVisible( false );
TCP:SetPosition( 400, 55 );
TCP:SetBackColor( red );

TCPL = Turbine.UI.Label();
TCPL:SetSize( 80, 20 );
TCPL:SetMouseVisible( false );
TCPL:SetVisible( true );
TCPL:SetParent( TWindow );
TCPL:SetText( "Temp." );
TCPL:SetPosition( 440, 60 );

--END OF TEMPORARY OPTIONS--------------------------------------------------------------------


MTWindow = Turbine.UI.Window();
MTWindow:SetParent( Colorwindow );
MTWindow:SetSize( 500, 200 );
MTWindow:SetPosition( 100, 0 );
MTWindow:SetVisible( false );
MTWindow:SetMouseVisible( false );
MTWindow:SetZOrder( 10 );

MTRSB = SettingsScroll();
MTRSB:SetParent( MTWindow );
MTRSB:SetMinimum( 0 );
MTRSB:SetMaximum( 255 );
MTRSB:SetSmallChange( 1 );
MTRSB:SetLargeChange( 20 );
MTRSB:SetPosition( 10, 50 );
MTRSB.ValueChanged = function()
	rcompmgreen = ( MTRSB:GetValue() / 255 )
	mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
	MTCP:SetBackColor( mgreen )
	MTRSBL:SetText( "Red - "..( rcompmgreen * 255 ) )
	MRealLabel:SetForeColor( mgreen )
	MSlashLabel:SetForeColor( mgreen )
	MMaxLabel:SetForeColor( mgreen )
	MPercLabel:SetForeColor( mgreen )
	MPercLabel2:SetForeColor( mgreen )
end

MTGSB = SettingsScroll();
MTGSB:SetParent( MTWindow );
MTGSB:SetMinimum( 0 )
MTGSB:SetMaximum( 255 )
MTGSB:SetSmallChange( 1 );
MTGSB:SetLargeChange( 20 );
MTGSB:SetPosition( 10, 65 );
MTGSB.ValueChanged = function()
	gcompmgreen = ( MTGSB:GetValue() / 255 )
	mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
	MTCP:SetBackColor( mgreen )
	MTGSBL:SetText( "Green - "..( gcompmgreen * 255 ) )
	MRealLabel:SetForeColor( mgreen )
	MSlashLabel:SetForeColor( mgreen )
	MMaxLabel:SetForeColor( mgreen )
	MPercLabel:SetForeColor( mgreen )
	MPercLabel2:SetForeColor( mgreen )
end

MTBSB = SettingsScroll();
MTBSB:SetParent( MTWindow );
MTBSB:SetMinimum( 0 )
MTBSB:SetMaximum( 255 )
MTBSB:SetSmallChange( 1 );
MTBSB:SetLargeChange( 20 );
MTBSB:SetPosition( 10, 80 );
MTBSB.ValueChanged = function()
	bcompmgreen = ( MTBSB:GetValue() / 255 )
	mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
	MTCP:SetBackColor( mgreen )
	MTBSBL:SetText( "Blue - "..( bcompmgreen * 255 ) )
	MRealLabel:SetForeColor( mgreen )
	MSlashLabel:SetForeColor( mgreen )
	MMaxLabel:SetForeColor( mgreen )
	MPercLabel:SetForeColor( mgreen )
	MPercLabel2:SetForeColor( mgreen )
end

MTRSBL = ScrollLabel();
MTRSBL:SetPosition( 310, 50 );
MTRSBL:SetParent( MTWindow );
MTRSBL:SetText( "Red - 255" )

MTGSBL = ScrollLabel();
MTGSBL:SetPosition( 310, 65 );
MTGSBL:SetParent( MTWindow );
MTGSBL:SetText( "Green - 255" )

MTBSBL = ScrollLabel();
MTBSBL:SetPosition( 310, 80 );
MTBSBL:SetParent( MTWindow );
MTBSBL:SetText( "Blue - 255" )

MTCP = Turbine.UI.Control();
MTCP:SetSize( 30, 30 );
MTCP:SetParent( MTWindow );
MTCP:SetVisible( true );
MTCP:SetMouseVisible( false );
MTCP:SetPosition( 400, 55 );
MTCP:SetBackColor( red );

MTCPL = Turbine.UI.Label();
MTCPL:SetSize( 80, 20 );
MTCPL:SetMouseVisible( false );
MTCPL:SetVisible( true );
MTCPL:SetParent( MTWindow );
MTCPL:SetText( "Morale" );
MTCPL:SetPosition( 440, 60 );

TTRSB = SettingsScroll();
TTRSB:SetParent( MTWindow );
TTRSB:SetMinimum( 0 );
TTRSB:SetMaximum( 255 );
TTRSB:SetSmallChange( 1 );
TTRSB:SetLargeChange( 20 );
TTRSB:SetPosition( 10, 105 );
TTRSB.ValueChanged = function()
	rcomppurple = ( TTRSB:GetValue() / 255 )
	purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
	TTCP:SetBackColor( purple )
	TTRSBL:SetText( "Red - "..( rcomppurple * 255 ) )
	TMRealLabel:SetForeColor( purple )
	TMSlashLabel:SetForeColor( purple )
	TMMaxLabel:SetForeColor( purple )
	TMPercLabel:SetForeColor( purple )
	TMPercLabel2:SetForeColor( purple )
end

TTGSB = SettingsScroll();
TTGSB:SetParent( MTWindow );
TTGSB:SetMinimum( 0 )
TTGSB:SetMaximum( 255 )
TTGSB:SetSmallChange( 1 );
TTGSB:SetLargeChange( 20 );
TTGSB:SetPosition( 10, 120 );
TTGSB.ValueChanged = function()
	gcomppurple = ( TTGSB:GetValue() / 255 )
	purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
	TTCP:SetBackColor( purple )
	TTGSBL:SetText( "Green - "..( gcomppurple * 255 ) )
	TMRealLabel:SetForeColor( purple )
	TMSlashLabel:SetForeColor( purple )
	TMMaxLabel:SetForeColor( purple )
	TMPercLabel:SetForeColor( purple )
	TMPercLabel2:SetForeColor( purple )
end

TTBSB = SettingsScroll();
TTBSB:SetParent( MTWindow );
TTBSB:SetMinimum( 0 )
TTBSB:SetMaximum( 255 )
TTBSB:SetSmallChange( 1 );
TTBSB:SetLargeChange( 20 );
TTBSB:SetPosition( 10, 135 );
TTBSB.ValueChanged = function()
	bcomppurple = ( TTBSB:GetValue() / 255 )
	purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
	TTCP:SetBackColor( purple )
	TTBSBL:SetText( "Blue - "..( bcomppurple * 255 ) )
	TMRealLabel:SetForeColor( purple )
	TMSlashLabel:SetForeColor( purple )
	TMMaxLabel:SetForeColor( purple )
	TMPercLabel:SetForeColor( purple )
	TMPercLabel2:SetForeColor( purple )
end

TTRSBL = ScrollLabel();
TTRSBL:SetPosition( 310, 105 );
TTRSBL:SetParent( MTWindow );
TTRSBL:SetText( "Red - 255" )

TTGSBL = ScrollLabel();
TTGSBL:SetPosition( 310, 120 );
TTGSBL:SetParent( MTWindow );
TTGSBL:SetText( "Green - 255" )

TTBSBL = ScrollLabel();
TTBSBL:SetPosition( 310, 135 );
TTBSBL:SetParent( MTWindow );
TTBSBL:SetText( "Blue - 255" )

TTCP = Turbine.UI.Control();
TTCP:SetSize( 30, 30 );
TTCP:SetParent( MTWindow );
TTCP:SetVisible( true );
TTCP:SetMouseVisible( false );
TTCP:SetPosition( 400, 110 );
TTCP:SetBackColor( red );

TTCPL = Turbine.UI.Label();
TTCPL:SetSize( 80, 20 );
TTCPL:SetMouseVisible( false );
TTCPL:SetVisible( true );
TTCPL:SetParent( MTWindow );
TTCPL:SetText( "Temp." );
TTCPL:SetPosition( 440, 115 );

--END OF MORALE TEXT OPTIONS------------------------------------------------------------------

PTWindow = Turbine.UI.Window();
PTWindow:SetParent( Colorwindow );
PTWindow:SetSize( 500, 200 );
PTWindow:SetPosition( 100, 0 );
PTWindow:SetVisible( false );
PTWindow:SetMouseVisible( false );
PTWindow:SetZOrder( 10 );

PTRSB = SettingsScroll();
PTRSB:SetParent( PTWindow );
PTRSB:SetMinimum( 0 );
PTRSB:SetMaximum( 255 );
PTRSB:SetSmallChange( 1 );
PTRSB:SetLargeChange( 20 );
PTRSB:SetPosition( 10, 50 );
PTRSB.ValueChanged = function()
	rcomppblue = ( PTRSB:GetValue() / 255 )
	pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )
	PTCP:SetBackColor( pblue )
	PTRSBL:SetText( "Red - "..( rcomppblue * 255 ) )
	PRealLabel:SetForeColor( pblue )
	PSlashLabel:SetForeColor( pblue )
	PMaxLabel:SetForeColor( pblue )
	PPercLabel:SetForeColor( pblue )
	PPercLabel2:SetForeColor( pblue )
end

PTGSB = SettingsScroll();
PTGSB:SetParent( PTWindow );
PTGSB:SetMinimum( 0 )
PTGSB:SetMaximum( 255 )
PTGSB:SetSmallChange( 1 );
PTGSB:SetLargeChange( 20 );
PTGSB:SetPosition( 10, 65 );
PTGSB.ValueChanged = function()
	gcomppblue = ( PTGSB:GetValue() / 255 )
	pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )
	PTCP:SetBackColor( pblue )
	PTGSBL:SetText( "Green - "..( gcomppblue * 255 ) )
	PRealLabel:SetForeColor( pblue )
	PSlashLabel:SetForeColor( pblue )
	PMaxLabel:SetForeColor( pblue )
	PPercLabel:SetForeColor( pblue )
	PPercLabel2:SetForeColor( pblue )
end

PTBSB = SettingsScroll();
PTBSB:SetParent( PTWindow );
PTBSB:SetMinimum( 0 )
PTBSB:SetMaximum( 255 )
PTBSB:SetSmallChange( 1 );
PTBSB:SetLargeChange( 20 );
PTBSB:SetPosition( 10, 80 );
PTBSB.ValueChanged = function()
	bcomppblue = ( PTBSB:GetValue() / 255 )
	pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )
	PTCP:SetBackColor( pblue )
	PTBSBL:SetText( "Blue - "..( bcomppblue * 255 ) )
	PRealLabel:SetForeColor( pblue )
	PSlashLabel:SetForeColor( pblue )
	PMaxLabel:SetForeColor( pblue )
	PPercLabel:SetForeColor( pblue )
	PPercLabel2:SetForeColor( pblue )
end

PTRSBL = ScrollLabel();
PTRSBL:SetPosition( 310, 50 );
PTRSBL:SetParent( PTWindow );
PTRSBL:SetText( "Red - 255" )

PTGSBL = ScrollLabel();
PTGSBL:SetPosition( 310, 65 );
PTGSBL:SetParent( PTWindow );
PTGSBL:SetText( "Green - 255" )

PTBSBL = ScrollLabel();
PTBSBL:SetPosition( 310, 80 );
PTBSBL:SetParent( PTWindow );
PTBSBL:SetText( "Blue - 255" )

PTCP = Turbine.UI.Control();
PTCP:SetSize( 30, 30 );
PTCP:SetParent( PTWindow );
PTCP:SetVisible( true );
PTCP:SetMouseVisible( false );
PTCP:SetPosition( 400, 55 );
PTCP:SetBackColor( red );

PTCPL = Turbine.UI.Label();
PTCPL:SetSize( 80, 20 );
PTCPL:SetMouseVisible( false );
PTCPL:SetVisible( true );
PTCPL:SetParent( PTWindow );
PTCPL:SetText( "Power" );
PTCPL:SetPosition( 440, 60 );

--END OF POWER TEXT OPTIONS--------------------------------------------------------------------

MBarbutton.MouseClick = function()
	MBarbutton:SetEnabled( false )
	PBarbutton:SetEnabled( true )
	TBarbutton:SetEnabled( true )
	MTextbutton:SetEnabled( true )
	PTextbutton:SetEnabled( true )
	MWindow:SetVisible( true )
	PWindow:SetVisible( false )
	TWindow:SetVisible( false )
	MTWindow:SetVisible( false )
	PTWindow:SetVisible( false )
end

PBarbutton.MouseClick = function()
	MBarbutton:SetEnabled( true )
	PBarbutton:SetEnabled( false )
	TBarbutton:SetEnabled( true )
	MTextbutton:SetEnabled( true )
	PTextbutton:SetEnabled( true )
	MWindow:SetVisible( false )
	PWindow:SetVisible( true )
	TWindow:SetVisible( false )
	MTWindow:SetVisible( false )
	PTWindow:SetVisible( false )
end

TBarbutton.MouseClick = function()
	MBarbutton:SetEnabled( true )
	PBarbutton:SetEnabled( true )
	TBarbutton:SetEnabled( false )
	MTextbutton:SetEnabled( true )
	PTextbutton:SetEnabled( true )
	MWindow:SetVisible( false )
	PWindow:SetVisible( false )
	TWindow:SetVisible( true )
	MTWindow:SetVisible( false )
	PTWindow:SetVisible( false )
end

MTextbutton.MouseClick = function()
	MBarbutton:SetEnabled( true )
	PBarbutton:SetEnabled( true )
	TBarbutton:SetEnabled( true )
	MTextbutton:SetEnabled( false )
	PTextbutton:SetEnabled( true )
	MWindow:SetVisible( false )
	PWindow:SetVisible( false )
	TWindow:SetVisible( false )
	MTWindow:SetVisible( true )
	PTWindow:SetVisible( false )
end

PTextbutton.MouseClick = function()
	MBarbutton:SetEnabled( true )
	PBarbutton:SetEnabled( true )
	TBarbutton:SetEnabled( true )
	MTextbutton:SetEnabled( true )
	PTextbutton:SetEnabled( false )
	MWindow:SetVisible( false )
	PWindow:SetVisible( false )
	TWindow:SetVisible( false )
	MTWindow:SetVisible( false )
	PTWindow:SetVisible( true )
end