-- Control Initialization and Config

local displayWidth, displayHeight = Turbine.UI.Display.GetSize();

red = Turbine.UI.Color( 1, 0, 0 );
green = Turbine.UI.Color( 0, 1, 0 );
blue = Turbine.UI.Color( 0, 0, 1 );
black = Turbine.UI.Color( 0, 0, 0 );
yellow = Turbine.UI.Color( 1, .8, 0 );
white = Turbine.UI.Color( 1, 1, 1 );
mbackcolor = Turbine.UI.Color( 0, 0.24705882352941176470588235294118, 0.72941176470588235294117647058824, 0.27843137254901960784313725490196 )
mbackcolor2 = Turbine.UI.Color( 0, 1, 0.89411764705882352941176470588235, 0.29803921568627450980392156862745 )
mbackcolor3 = Turbine.UI.Color( 0, 1, 0.18823529411764705882352941176471, 0.21568627450980392156862745098039 )
pbackcolor = Turbine.UI.Color( 0, 0.28235294117647058823529411764706, 0, 0.8039215686274509803921568627451 )
pbackcolor2 = Turbine.UI.Color( 0, 0.44705882352941176470588235294118, 0.67843137254901960784313725490196, 1 )
pbackcolor3 = Turbine.UI.Color( 0, 0.06666666666666666666666666666667, 0.87450980392156862745098039215686, 1 )
tbackcolor = Turbine.UI.Color( 1, 1, 0.14901960784313725490196078431373, 0.95686274509803921568627450980392 )
mgreen = Turbine.UI.Color( 0, .7, 0 );
purple = Turbine.UI.Color( 1, 0, .8 );
pblue = Turbine.UI.Color( 0, 0, .7 );

WarningClass = class( Turbine.UI.Lotro.Window );
function WarningClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetMouseVisible( false )
	self:SetSize( 80, 40 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

WarningClass2 = class( Turbine.UI.Lotro.Window );
function WarningClass2:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetMouseVisible( false )
	self:SetSize( 220, 40 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

CDClass = class( Turbine.UI.Lotro.Window );
function CDClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetMouseVisible( false )
	self:SetSize( 70, 40 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

QSGClass = class( Turbine.UI.Window )
function QSGClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetSize( 32, 32 )
	self:SetMouseVisible( false )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

BarWinClass = class( Turbine.UI.Window )
function BarWinClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetSize( 200, 50 )
	self:SetMouseVisible( false )
	self:SetOpacity( .3 )
	self:SetZOrder( 1 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

TextWinClass = class( Turbine.UI.Window )
function TextWinClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetSize( 117, 10 )
	self:SetMouseVisible( false )
	self:SetOpacity( 1 )
	self:SetZOrder( 2 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

MeterWinClass = class( Turbine.UI.Window )
function MeterWinClass:Constructor()
	Turbine.UI.Window.Constructor( self )
	self:SetVisible( false )
	self:SetSize( 255, 30 )
	self:SetMouseVisible( false )
	self:SetOpacity( .3 )
	self:SetZOrder( 1 )
	self.DragStart = function()
		self.PosX = self:GetLeft()
		self.PosY = self:GetTop()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self.XOffset = ( ( MousePosX - self.PosX ) )
		self.YOffset = ( ( MousePosY - self.PosY ) )
	end
	self.Drag = function()
		MousePosX = Turbine.UI.Display.GetMouseX()
		MousePosY = Turbine.UI.Display.GetMouseY()
		self:SetLeft( ( MousePosX - self.XOffset ) )
		self:SetTop( ( MousePosY - self.YOffset ) )
	end
	self.MouseDown = function()
		self:DragStart()
		if Optoverride == "1"
		then self.Dragging = "1"
		end
	end
	self.MouseUp = function()
		if Optoverride == "1"
		then self.Dragging = "0"
		end
	end
end

--Main Window

Primwin = Turbine.UI.Window();
Primwin:SetSize( 450, 250 );
Primwin:SetPosition( ( displayWidth * .5 -225 ), ( displayHeight * .5 - 125 ) );
Primwin:SetWantsUpdates( true );
Primwin:SetOpacity( 1 );
Primwin:SetWantsKeyEvents( true )
Primwin:SetVisible( false )
Primwin:SetMouseVisible( false )

--Morale and Power Bars

MBarWin = BarWinClass()
MBarWin:SetPosition( 20 + Primwin:GetLeft(), 10 + Primwin:GetTop() );
MBarWin:SetBackground( "CajePlugins/HUDPlus/Resources/LeftBack.tga" );

PBarWin = BarWinClass();
PBarWin:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() );
PBarWin:SetBackground( "CajePlugins/HUDPlus/Resources/RightBack.tga" );

MBar = Turbine.UI.Control();
MBar:SetParent( MBarWin );
MBar:SetSize( 200, 50 );
MBar:SetVisible( false );
MBar:SetMouseVisible( false );
MBar:SetZOrder( 0 );
MBar:SetOpacity( .3 );
MBar:SetBackColor( mbackcolor );
MBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );

MBar2 = Turbine.UI.Control();
MBar2:SetParent( MBar );
MBar2:SetSize( 200, 50 );
MBar2:SetVisible( true );
MBar2:SetMouseVisible( false );
MBar2:SetZOrder( 0 );
MBar2:SetOpacity( 1 );
MBar2:SetBackColor( mbackcolor2 );
MBar2:SetBackColorBlendMode( Turbine.UI.BlendMode.Color );

MBarT = Turbine.UI.Control();
MBarT:SetParent( MBarWin );
MBarT:SetSize( 200, 50 );
MBarT:SetVisible( true );
MBarT:SetMouseVisible( false );
MBarT:SetZOrder( 1 );
MBarT:SetOpacity( .3 );
MBarT:SetBackColor( tbackcolor );
MBarT:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );

PBar = Turbine.UI.Control();
PBar:SetParent( PBarWin );
PBar:SetSize( 200, 50 );
PBar:SetVisible( false );
PBar:SetMouseVisible( false );
PBar:SetZOrder( 0 );
PBar:SetOpacity( .3 );
PBar:SetBackColor( pbackcolor );
PBar:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );

PBar2 = Turbine.UI.Control();
PBar2:SetParent( PBar );
PBar2:SetSize( 200, 50 );
PBar2:SetVisible( true );
PBar2:SetMouseVisible( false );
PBar2:SetZOrder( 0 );
PBar2:SetOpacity( 1 );
PBar2:SetBackColor( pbackcolor2 );
PBar2:SetBackColorBlendMode( Turbine.UI.BlendMode.Color );

MBarRail = Turbine.UI.Window();
MBarRail:SetSize( 200, 50 );
MBarRail:SetPosition( 20 + Primwin:GetLeft() , 10 + Primwin:GetTop() );
MBarRail:SetVisible( false );
MBarRail:SetMouseVisible( false );
MBarRail:SetOpacity( .3 );
MBarRail:SetZOrder( 2 );
MBarRail:SetBackground( "CajePlugins/HUDPlus/Resources/LeftRail.tga" );

PBarRail = Turbine.UI.Window();
PBarRail:SetSize( 200, 50 );
PBarRail:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() );
PBarRail:SetVisible( false );
PBarRail:SetMouseVisible( false );
PBarRail:SetOpacity( .3 );
PBarRail:SetZOrder( 1 );
PBarRail:SetBackground( "CajePlugins/HUDPlus/Resources/RightRail.tga" );

--Text Indicators

MTWin = TextWinClass();
MTWin:SetPosition( 95 + Primwin:GetLeft(), 40 + Primwin:GetTop() )

PTWin = TextWinClass();
PTWin:SetPosition( 225 + Primwin:GetLeft(), 40 + Primwin:GetTop() )

MRealLabel = Turbine.UI.Label();
MRealLabel:SetParent( MTWin );
MRealLabel:SetSize( 30, 10 );
MRealLabel:SetText( "N/A" );
MRealLabel:SetPosition( 0, 0 );
MRealLabel:SetMouseVisible( false )
MRealLabel:SetZOrder( 2 )
MRealLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
MRealLabel:SetForeColor( mgreen );
MRealLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
MRealLabel:SetOutlineColor( black )

PRealLabel = Turbine.UI.Label();
PRealLabel:SetParent( PTWin );
PRealLabel:SetSize( 30, 10 );
PRealLabel:SetMouseVisible( false );
PRealLabel:SetText( "N/A" );
PRealLabel:SetPosition( 45, 0 );
PRealLabel:SetZOrder( 2 );
PRealLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
PRealLabel:SetForeColor( pblue );
PRealLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
PRealLabel:SetOutlineColor( black )

--__________________________________

MSlashLabel = Turbine.UI.Label();
MSlashLabel:SetParent( MTWin );
MSlashLabel:SetMouseVisible( false )
MSlashLabel:SetSize( 30, 10 );
MSlashLabel:SetText( "/" );
MSlashLabel:SetPosition( 35, 0 );
MSlashLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
MSlashLabel:SetForeColor( mgreen );
MSlashLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
MSlashLabel:SetOutlineColor( black )

PSlashLabel = Turbine.UI.Label();
PSlashLabel:SetParent( PTWin );
PSlashLabel:SetSize( 30, 10 );
PSlashLabel:SetMouseVisible( false );
PSlashLabel:SetText( "/" );
PSlashLabel:SetPosition( 80, 0 );
PSlashLabel:SetZOrder( 2 );
PSlashLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
PSlashLabel:SetForeColor( pblue );
PSlashLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
PSlashLabel:SetOutlineColor( black )

--_________________________________

MMaxLabel = Turbine.UI.Label();
MMaxLabel:SetParent( MTWin );
MMaxLabel:SetMouseVisible( false )
MMaxLabel:SetSize( 30, 10 );
MMaxLabel:SetText( "N/A" );
MMaxLabel:SetPosition( 40, 0 );
MMaxLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
MMaxLabel:SetForeColor( mgreen );
MMaxLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
MMaxLabel:SetOutlineColor( black )

PMaxLabel = Turbine.UI.Label();
PMaxLabel:SetParent( PTWin );
PMaxLabel:SetSize( 30, 10 );
PMaxLabel:SetMouseVisible( false );
PMaxLabel:SetText( "N/A" );
PMaxLabel:SetPosition( 85, 0 );
PMaxLabel:SetZOrder( 2 );
PMaxLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
PMaxLabel:SetForeColor( pblue );
PMaxLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
PMaxLabel:SetOutlineColor( black )

--________________________________

MPercLabel = Turbine.UI.Label();
MPercLabel:SetParent( MTWin );
MPercLabel:SetMouseVisible( false )
MPercLabel:SetSize( 20, 10 );
MPercLabel:SetText( "N/A" );
MPercLabel:SetZOrder( 2 );
MPercLabel:SetPosition( 85, 0 );
MPercLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
MPercLabel:SetForeColor( mgreen );
MPercLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
MPercLabel:SetOutlineColor( black )

PPercLabel = Turbine.UI.Label();
PPercLabel:SetParent( PTWin );
PPercLabel:SetSize( 20, 10 );
PPercLabel:SetMouseVisible( false );
PPercLabel:SetText( "N/A" );
PPercLabel:SetZOrder( 2 );
PPercLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
PPercLabel:SetForeColor( pblue );
PPercLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
PPercLabel:SetOutlineColor( black )

--________________________________

MPercLabel2 = Turbine.UI.Label();
MPercLabel2:SetParent( MTWin );
MPercLabel2:SetMouseVisible( false )
MPercLabel2:SetSize( 10, 10 );
MPercLabel2:SetText( "%" );
MPercLabel2:SetZOrder( 3 );
MPercLabel2:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
MPercLabel2:SetForeColor( mgreen );
MPercLabel2:SetFontStyle( Turbine.UI.FontStyle.Outline )
MPercLabel2:SetOutlineColor( black )

PPercLabel2 = Turbine.UI.Label();
PPercLabel2:SetParent( PTWin );
PPercLabel2:SetSize( 10, 10 );
PPercLabel2:SetOpacity( 1 );
PPercLabel2:SetMouseVisible( false );
PPercLabel2:SetText( "%" );
PPercLabel2:SetZOrder( 3 );
PPercLabel2:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
PPercLabel2:SetForeColor( pblue );
PPercLabel2:SetFontStyle( Turbine.UI.FontStyle.Outline )
PPercLabel2:SetOutlineColor( black )

--Quickslots

MQSG = QSGClass();
MQSG:SetPosition( 100 + Primwin:GetLeft() , 70 + Primwin:GetTop() );

PQSG = QSGClass();
PQSG:SetPosition( 305 + Primwin:GetLeft() , 70 + Primwin:GetTop() );

MQSG2 = QSGClass();
MQSG2:SetPosition( 0, 0 );
MQSG2:SetVisible( true )
MQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/MQSG.tga" )
MQSG2:SetParent( MQSG )
MQSG2:SetZOrder( 5 )

PQSG2 = QSGClass();
PQSG2:SetPosition( 0, 0 );
PQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/PQSG.tga" )
PQSG2:SetParent( PQSG )
PQSG2:SetZOrder( 5 )
PQSG2:SetVisible( true )

--____________________________________

MQS = Turbine.UI.Lotro.Quickslot();
MQS:SetVisible( true );
MQS:SetSize( 32, 32 );
MQS:SetMouseVisible( true );
MQS:SetParent( MQSG );
MQS:SetPosition( 0, 0 );

PQS = Turbine.UI.Lotro.Quickslot();
PQS:SetVisible( true );
PQS:SetSize( 32, 32 );
PQS:SetMouseVisible( true );
PQS:SetParent( PQSG );
PQS:SetPosition( 0, 0 );

--_____________________________________

WQSG = QSGClass();
WQSG:SetPosition( 140 + Primwin:GetLeft(), 70 + Primwin:GetTop() );

DQSG = QSGClass();
DQSG:SetPosition( 180 + Primwin:GetLeft(), 70 + Primwin:GetTop() );

WQSG2 = QSGClass();
WQSG2:SetPosition( 0, 0 );
WQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/WQSG.tga" )
WQSG2:SetParent( WQSG )
WQSG2:SetZOrder( 5 )
WQSG2:SetVisible( true )

DQSG2 = QSGClass();
DQSG2:SetPosition( 0, 0 );
DQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/DQSG.tga" )
DQSG2:SetParent( DQSG )
DQSG2:SetZOrder( 2 )
DQSG2:SetVisible( true )

--_____________________________________

WQS = Turbine.UI.Lotro.Quickslot();
WQS:SetVisible( false );
WQS:SetSize( 32, 32 );
WQS:SetMouseVisible( true );
WQS:SetParent( WQSG );
WQS:SetPosition( 0, 0 );

DQS = Turbine.UI.Lotro.Quickslot();
DQS:SetVisible( false );
DQS:SetSize( 32, 32 );
DQS:SetMouseVisible( true );
DQS:SetParent( DQSG );
DQS:SetPosition( 0, 0 );

--____________________________________

PoQSG = QSGClass();
PoQSG:SetPosition( 225 + Primwin:GetLeft(), 70 + Primwin:GetTop() );

FQSG = QSGClass();
FQSG:SetPosition( 265 + Primwin:GetLeft() , 70 + Primwin:GetTop() );

PoQSG2 = QSGClass();
PoQSG2:SetPosition( 0, 0 );
PoQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/PoQSG.tga" )
PoQSG2:SetParent( PoQSG )
PoQSG2:SetZOrder( 5 )
PoQSG2:SetVisible( true )

FQSG2 = QSGClass();
FQSG2:SetPosition( 0, 0 );
FQSG2:SetBackground( "CajePlugins/HUDPlus/Resources/FQSG.tga" );
FQSG2:SetParent( FQSG )
FQSG2:SetZOrder( 5 )
FQSG2:SetVisible( true )

--____________________________________

PoQS = Turbine.UI.Lotro.Quickslot();
PoQS:SetVisible( false );
PoQS:SetSize( 32, 32 );
PoQS:SetMouseVisible( true );
PoQS:SetParent( PoQSG );
PoQS:SetPosition( 0, 0 );

FQS = Turbine.UI.Lotro.Quickslot();
FQS:SetVisible( false );
FQS:SetSize( 32, 32 );
FQS:SetMouseVisible( true );
FQS:SetParent( FQSG );
FQS:SetPosition( 0, 0 );

--Morale and Power Indicators

MWarn = WarningClass();
MWarn:SetLeft( 180 + Primwin:GetLeft() );
MWarn:SetTop( -40 + Primwin:GetTop() );
MWarn:SetBackground( "CajePlugins/HUDPlus/Resources/MWarn.tga" );

PWarn = WarningClass();
PWarn:SetLeft( 180 + Primwin:GetLeft() );
PWarn:SetTop( 100 + Primwin:GetTop() );
PWarn:SetBackground( "CajePlugins/HUDPlus/Resources/PWarn.tga" );

DHitWarn = WarningClass2();
DHitWarn:SetLeft( 110 + Primwin:GetLeft() )
DHitWarn:SetTop( 150 + Primwin:GetTop() )
DHitWarn:SetBackground( "CajePlugins/HUDPlus/Resources/DHitWarn.tga" )

PanicCD = CDClass()
PanicCD:SetLeft( 90 + Primwin:GetLeft() )
PanicCD:SetTop( -40 + Primwin:GetTop() )
PanicCD:SetBackground( "CajePlugins/HUDPlus/Resources/PanicCDRdy.tga" )

BubbleCD = CDClass()
BubbleCD:SetSize( 70, 40 );
BubbleCD:SetLeft( 280 + Primwin:GetLeft() )
BubbleCD:SetTop( -40 + Primwin:GetTop() )
BubbleCD:SetBackground( "CajePlugins/HUDPlus/Resources/BubbleCDRdy.tga" )

CorrCD = CDClass()
CorrCD:SetLeft( 280 + Primwin:GetLeft() )
CorrCD:SetTop( 105 + Primwin:GetTop() )
CorrCD:SetBackground( "CajePlugins/HUDPlus/Resources/CorruptionCDRdy.tga" )

IntCD = CDClass()
IntCD:SetLeft( 90 + Primwin:GetLeft() )
IntCD:SetTop( 105 + Primwin:GetTop() )
IntCD:SetBackground( "CajePlugins/HUDPlus/Resources/InterruptCDRdy.tga" )

C1CD = CDClass()
C1CD:SetLeft( 20 + Primwin:GetLeft() )
C1CD:SetTop( 105 + Primwin:GetTop() )
C1CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )

C2CD = CDClass()
C2CD:SetLeft( 360 + Primwin:GetLeft() )
C2CD:SetTop( 105 + Primwin:GetTop() )
C2CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )

MQL = Turbine.UI.Label();
MQL:SetParent( MQSG2 );
MQL:SetSize( 30, 30 );
MQL:SetPosition( 7, 7 );
MQL:SetForeColor( black );
MQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
MQL:SetMouseVisible( false )
MQL:SetZOrder( 10 )

PQL = Turbine.UI.Label();
PQL:SetParent( PQSG2 );
PQL:SetSize( 30, 30 );
PQL:SetPosition( 7, 7 );
PQL:SetForeColor( black );
PQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
PQL:SetMouseVisible( false )
PQL:SetZOrder( 10 )

DQL = Turbine.UI.Label();
DQL:SetParent( DQSG2 );
DQL:SetSize( 30, 30 );
DQL:SetPosition( 7, 7 );
DQL:SetForeColor( black );
DQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
DQL:SetMouseVisible( false )
DQL:SetZOrder( 10 )

FQL = Turbine.UI.Label();
FQL:SetParent( FQSG2 );
FQL:SetSize( 30, 30 );
FQL:SetPosition( 7, 7 );
FQL:SetForeColor( black );
FQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
FQL:SetMouseVisible( false )
FQL:SetZOrder( 10 )

WQL = Turbine.UI.Label();
WQL:SetParent( WQSG2 );
WQL:SetSize( 30, 30 );
WQL:SetPosition( 7, 7 );
WQL:SetForeColor( black );
WQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
WQL:SetMouseVisible( false )
WQL:SetZOrder( 10 )

PoQL = Turbine.UI.Label();
PoQL:SetParent( PoQSG2 );
PoQL:SetSize( 30, 30 );
PoQL:SetPosition( 7, 7 );
PoQL:SetForeColor( black );
PoQL:SetFont( Turbine.UI.Lotro.Font.TrajanProBold16 )
PoQL:SetMouseVisible( false )
PoQL:SetZOrder( 10 )

--Temporary Morale text indicators

TTWin = TextWinClass();
TTWin:SetPosition( 95 + Primwin:GetLeft(), 53 + Primwin:GetTop() )

TMRealLabel = Turbine.UI.Label();
TMRealLabel:SetParent( TTWin );
TMRealLabel:SetSize( 30, 10 );
TMRealLabel:SetMouseVisible( false );
TMRealLabel:SetVisible( true )
TMRealLabel:SetText( "N/A" );
TMRealLabel:SetPosition( 0, 0 );
TMRealLabel:SetZOrder( 2 );
TMRealLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
TMRealLabel:SetForeColor( purple );
TMRealLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
TMRealLabel:SetOutlineColor( black )

--__________________________________

TMSlashLabel = Turbine.UI.Label();
TMSlashLabel:SetParent( TTWin );
TMSlashLabel:SetSize( 30, 10 );
TMSlashLabel:SetVisible( true );
TMSlashLabel:SetMouseVisible( false );
TMSlashLabel:SetText( "/" );
TMSlashLabel:SetPosition( 35, 0 );
TMSlashLabel:SetZOrder( 2 );
TMSlashLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
TMSlashLabel:SetForeColor( purple );
TMSlashLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
TMSlashLabel:SetOutlineColor( black )

--_________________________________

TMMaxLabel = Turbine.UI.Label();
TMMaxLabel:SetParent( TTWin );
TMMaxLabel:SetSize( 30, 10 );
TMMaxLabel:SetVisible( true );
TMMaxLabel:SetMouseVisible( false );
TMMaxLabel:SetText( "N/A" );
TMMaxLabel:SetPosition( 40, 0 );
TMMaxLabel:SetZOrder( 2 );
TMMaxLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
TMMaxLabel:SetForeColor( purple );
TMMaxLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
TMMaxLabel:SetOutlineColor( black )

--________________________________

TMPercLabel = Turbine.UI.Label();
TMPercLabel:SetParent( TTWin );
TMPercLabel:SetSize( 20, 10 );
TMPercLabel:SetVisible( true );
TMPercLabel:SetMouseVisible( false );
TMPercLabel:SetText( "N/A" );
TMPercLabel:SetZOrder( 2 );
TMPercLabel:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
TMPercLabel:SetForeColor( purple );
TMPercLabel:SetFontStyle( Turbine.UI.FontStyle.Outline )
TMPercLabel:SetOutlineColor( black )
TMPercLabel:SetPosition( 85, 0 );

--________________________________

TMPercLabel2 = Turbine.UI.Label();
TMPercLabel2:SetParent( TTWin );
TMPercLabel2:SetSize( 10, 10 );
TMPercLabel2:SetVisible( true );
TMPercLabel2:SetMouseVisible( false );
TMPercLabel2:SetText( "%" );
TMPercLabel2:SetZOrder( 3 );
TMPercLabel2:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
TMPercLabel2:SetForeColor( purple );
TMPercLabel2:SetFontStyle( Turbine.UI.FontStyle.Outline )
TMPercLabel2:SetOutlineColor( black )
TMPercLabel2:SetPosition( 99, 0 );