import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"
import "CajePlugins.HUDPlus.Controls"
import "CajePlugins.HUDPlus.OptionsMenu"
import "CajePlugins.HUDPlus.Meter"
import "CajePlugins.HUDPlus.Color"

LoadTime = Turbine.Engine.GetLocalTime()
QSLoadTime = ( LoadTime + 120 )

HUDVis = "1"
HUDVischanging = "0"

MousePosX = Turbine.UI.Display.GetMouseX()
MousePosY = Turbine.UI.Display.GetMouseY()

LOADED = "0"

MLastPot = "0"
PLastPot = "0"
PoLastPot = "0"
DLastPot = "0"
FLastPot = "0"
WLastPot = "0"

LFading = "1"
MWarnFlashOut = "0"
MWarnFlashIn = "0"
PWarnFlashOut = "0"
PWarnFlashIn = "0"

HUDPlus = Turbine.Plugin
version = Plugins["HUDPlus"]:GetVersion();
Turbine.Shell.WriteLine( "HUDPlus "..version.." by Caje" )

Player = Turbine.Gameplay.LocalPlayer.GetInstance();
StartMorale = Player:GetMorale()

function HUDPlus:SaveData()
	HUDPlusData = { }
	HUDPlusData.CritLevel = ( CriticalScroll:GetValue() / 100 )
	HUDPlusData.LowLevel = ( LowScroll:GetValue() / 100 )
	HUDPlusData.PCritLevel = ( PCriticalScroll:GetValue() / 100 )
	HUDPlusData.PLowLevel = ( PLowScroll:GetValue() / 100 )
	HUDPlusData.DLevel = ( DHitScroll:GetValue() )
	HUDPlusData.quickslots = quickslots
	HUDPlusData.Bars = Bars
	HUDPlusData.Meter = Meter
	HUDPlusData.Moralewarn = Moralewarn
	HUDPlusData.Powerwarn = Powerwarn
	HUDPlusData.PancD = PanCD
	HUDPlusData.BubCD = BubCD
	HUDPlusData.Text = Text
	HUDPlusData.CorruptionCD = CorruptionCD
	HUDPlusData.InterruptCD = InterruptCD
	HUDPlusData.DHitWarning = DHitWarning
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.IndOnly = IndOnly
	HUDPlusData.MWopT = MWopT
	HUDPlusData.PWopT = PWopT
	HUDPlusData.DHopT = DHopT
	HUDPlusData.BopT = BopT
	HUDPlusData.MopT = MopT
	HUDPlusData.MData = MShortcut:GetData()
	HUDPlusData.PData = PShortcut:GetData()
	HUDPlusData.DData = DShortcut:GetData()
	HUDPlusData.WData = WShortcut:GetData()
	HUDPlusData.FData = FShortcut:GetData()
	HUDPlusData.PoData = PoShortcut:GetData()
	HUDPlusData.MType = MShortcut:GetType()
	HUDPlusData.PType = PShortcut:GetType()
	HUDPlusData.DType = DShortcut:GetType()
	HUDPlusData.WType = WShortcut:GetType()
	HUDPlusData.FType = FShortcut:GetType()
	HUDPlusData.PoType = PoShortcut:GetType()
	HUDPlusData.Panskill = Pantext:GetText()
	HUDPlusData.Corskill = Cortext:GetText()
	HUDPlusData.Intskill = Inttext:GetText()
	HUDPlusData.Bubskill = Bubtext:GetText()
	HUDPlusData.C1skill = C1text:GetText()
	HUDPlusData.C2skill = C2text:GetText()
	HUDPlusData.PanicCD = PanScroll:GetValue()
	HUDPlusData.CorCD = CorScroll:GetValue()
	HUDPlusData.IntCD = IntScroll:GetValue()
	HUDPlusData.BubbCD = BubScroll:GetValue()
	HUDPlusData.C1CD = C1Scroll:GetValue()
	HUDPlusData.C2CD = C2Scroll:GetValue()
	HUDPlusData.OOCcrit = OOCcrit
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.MWarnX = MWarn:GetLeft()
	HUDPlusData.MWarnY = MWarn:GetTop()
	HUDPlusData.PWarnX = PWarn:GetLeft()
	HUDPlusData.PWarnY = PWarn:GetTop()
	HUDPlusData.DHitWarnX = DHitWarn:GetLeft()
	HUDPlusData.DHitWarnY = DHitWarn:GetTop()
	HUDPlusData.PanicCDX = PanicCD:GetLeft()
	HUDPlusData.PanicCDY = PanicCD:GetTop()
	HUDPlusData.BubbleCDX = BubbleCD:GetLeft()
	HUDPlusData.BubbleCDY = BubbleCD:GetTop()
	HUDPlusData.CorrCDX = CorrCD:GetLeft()
	HUDPlusData.CorrCDY = CorrCD:GetTop()
	HUDPlusData.IntCDX = IntCD:GetLeft()
	HUDPlusData.IntCDY = IntCD:GetTop()
	HUDPlusData.C1CDX = C1CD:GetLeft()
	HUDPlusData.C1CDY = C1CD:GetTop()
	HUDPlusData.C2CDX = C2CD:GetLeft()
	HUDPlusData.C2CDY = C2CD:GetTop()
	HUDPlusData.loadwithman = loadwithman

	HUDPlusData.MQSGX = MQSG:GetLeft()
	HUDPlusData.MQSGY = MQSG:GetTop()
	HUDPlusData.PQSGX = PQSG:GetLeft()
	HUDPlusData.PQSGY = PQSG:GetTop()
	HUDPlusData.DQSGX = DQSG:GetLeft()
	HUDPlusData.DQSGY = DQSG:GetTop()
	HUDPlusData.WQSGX = WQSG:GetLeft()
	HUDPlusData.WQSGY = WQSG:GetTop()
	HUDPlusData.FQSGX = FQSG:GetLeft()
	HUDPlusData.FQSGY = FQSG:GetTop()
	HUDPlusData.PoQSGX = PoQSG:GetLeft()
	HUDPlusData.PoQSGY = PoQSG:GetTop()
	HUDPlusData.MBarX = MBarWin:GetLeft()
	HUDPlusData.MBarY = MBarWin:GetTop()
	HUDPlusData.PBarX = PBarWin:GetLeft()
	HUDPlusData.PBarY = PBarWin:GetTop()
	HUDPlusData.MTWinX = MTWin:GetLeft()
	HUDPlusData.MTWinY = MTWin:GetTop()
	HUDPlusData.PTWinX = PTWin:GetLeft()
	HUDPlusData.PTWinY = PTWin:GetTop()
	HUDPlusData.TTWinX = TTWin:GetLeft()
	HUDPlusData.TTWinY = TTWin:GetTop()
	HUDPlusData.MeterBarX = MeterWin:GetLeft()
	HUDPlusData.MeterBarY = MeterWin:GetTop()

	HUDPlus:SaveData2()

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlus", HUDPlusData )
end

function HUDPlus:SaveFlags()
	HUDPlusFlags = { }
	HUDPlusFlags.MLastPot = MLastPot
	HUDPlusFlags.PLastPot = PLastPot
	HUDPlusFlags.DLastPot = DLastPot
	HUDPlusFlags.WLastPot = WLastPot
	HUDPlusFlags.FLastPot = FLastPot
	HUDPlusFlags.PoLastPot = PoLastPot

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlusF", HUDPlusFlags )
end

function HUDPlus:SaveData2()
	HUDPlusData2 = { }
	--COLOR--------------------------------------------------------------------------------

	HUDPlusData2.rcompmbackcolor = rcompmbackcolor
	HUDPlusData2.gcompmbackcolor = gcompmbackcolor
	HUDPlusData2.bcompmbackcolor = bcompmbackcolor

	HUDPlusData2.rcompm2backcolor = rcompm2backcolor
	HUDPlusData2.gcompm2backcolor = gcompm2backcolor
	HUDPlusData2.bcompm2backcolor = bcompm2backcolor

	HUDPlusData2.rcompm3backcolor = rcompm3backcolor
	HUDPlusData2.gcompm3backcolor = gcompm3backcolor
	HUDPlusData2.bcompm3backcolor = bcompm3backcolor

	HUDPlusData2.rcomppbackcolor = rcomppbackcolor
	HUDPlusData2.gcomppbackcolor = gcomppbackcolor
	HUDPlusData2.bcomppbackcolor = bcomppbackcolor

	HUDPlusData2.rcompp2backcolor = rcompp2backcolor
	HUDPlusData2.gcompp2backcolor = gcompp2backcolor
	HUDPlusData2.bcompp2backcolor = bcompp2backcolor

	HUDPlusData2.rcompp3backcolor = rcompp3backcolor
	HUDPlusData2.gcompp3backcolor = gcompp3backcolor
	HUDPlusData2.bcompp3backcolor = bcompp3backcolor

	HUDPlusData2.rcomptbackcolor = rcomptbackcolor
	HUDPlusData2.gcomptbackcolor = gcomptbackcolor
	HUDPlusData2.bcomptbackcolor = bcomptbackcolor

	HUDPlusData2.rcompmgreen = rcompmgreen
	HUDPlusData2.gcompmgreen = gcompmgreen
	HUDPlusData2.bcompmgreen = bcompmgreen

	HUDPlusData2.rcomppurple = rcomppurple
	HUDPlusData2.gcomppurple = gcomppurple
	HUDPlusData2.bcomppurple = bcomppurple

	HUDPlusData2.rcomppblue = rcomppblue
	HUDPlusData2.gcomppblue = gcomppblue
	HUDPlusData2.bcomppblue = bcomppblue

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlus2", HUDPlusData2 )
end

function Primwin:LoadDefaults()
	Loadtime = Turbine.Engine.GetGameTime()
	Fadetime = Loadtime + 4
	CritLevelT = .2
	LowLevelT = .5
	PLowLevelT = .4
	PCritLevelT = .2
	LowScroll:SetValue ( 50 )
	PLowScroll:SetValue( 40 )
	CriticalScroll:SetMaximum( 50 )
	CriticalScroll:SetValue( 20 )
	PCriticalScroll:SetMaximum( 40 )
	PCriticalScroll:SetValue( 20 )
	LowScrollLabel:SetText( "50% - Low" )
	PLowScrollLabel:SetText( "40% - Low" )
	CriticalScrollLabel:SetText( "20% - Critical" )
	PCriticalScrollLabel:SetText( "20% - Critical" )
	DHitLevel = 3000
	DHitScroll:SetValue( 3000 )
	DHitScrollLabel:SetText( "3000 - Hit Size" )
	AWarnFading = "0"

	quickslots = "1"
	QScheck:SetChecked( true )
	Barcheck:SetChecked( true )
	Bars = "1" 
	Moralewarn = "1"
	MWarncheck:SetChecked( true )
	Powerwarn = "1"
	PWarncheck:SetChecked( true )
	DHitWarncheck:SetChecked( true )
	InterruptCDcheck:SetChecked( true )
	PanCDcheck:SetChecked( true )
	BubCDcheck:SetChecked( true )
	Textcheck:SetChecked( true )
	CorruptionCDcheck:SetChecked( true )
	C1check:SetChecked( false )
	C2check:SetChecked( false )
	IndOnlycheck:SetChecked( false )
	IndOnly = "0" 
	DHitWarning = "1"
	InterruptCD = "1"
	CorruptionCD = "1"
	PanCD = "1"
	BubCD = "1"
	Text = "1"
	Cus1CD = "0"
	Cus2CD = "0"

	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
	CurFervour = ChmpAtts:GetFervor()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailCHMP.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
	CurFocus = HntAtts:GetFocus()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
	CurAtt = RKAtts:GetAttunement()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	else
	Meter = "1"
	MeterCheck:SetEnabled( false )
	MeterCheck:SetChecked( false )
	end

	MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PShortcut ) )
	FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )
	MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PMShortcut ) )
	FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )

	MShortcut = MQSO:GetShortcut()
	PShortcut = PQSO:GetShortcut()
	FShortcut = FQSO:GetShortcut()
	DShortcut = DQSO:GetShortcut()
	WShortcut = WQSO:GetShortcut()
	PoShortcut = PoQSO:GetShortcut()

	BOSLabel:SetText( "30% Bar Opacity" )
	BopF = ( 30 )
	BopT = ( .3 )
	BOS:SetValue( 30 )

	MOSLabel:SetText( "30% Opacity" )
	MopF = ( 30 )
	MopT = ( .3 )
	MOS:SetValue( 30 )

	MWOSLabel:SetText( "100% Opacity" )
	MWopF = ( 100 )
	MWopT = ( 1 )
	MWOS:SetValue( 100 )
	MWarn:SetOpacity( 1 )

	PWOSLabel:SetText( "100% Opacity" )
	PWopF = ( 100 )
	PWopT = ( 1 )
	PWOS:SetValue( 100 )
	PWarn:SetOpacity( 1 )

	DHOSLabel:SetText( "100% Opacity" )
	DHopF = ( 100 )
	DHopT = ( 1 )
	DHOS:SetValue( 100 )
	DHitWarn:SetOpacity( 1 )

	PSL:SetText( "0" )
	PanScroll:SetValue( 0 )
	
	BSL:SetText( "0" )
	BubScroll:SetValue( 0 )

	ISL:SetText( "0" )
	IntScroll:SetValue( 0 )

	CSL:SetText( "0" )
	CorScroll:SetValue( 0 )

	C1SL:SetText( "0" )
	C1Scroll:SetValue( 0 )

	C2SL:SetText( "0" )
	C2Scroll:SetValue( 0 )

	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
	Pantext:SetText( "N/A" )
	Cortext:SetText( "N/A" )
	Bubtext:SetText( "N/A" )
	Inttext:SetText( "N/A" )
	C1text:SetText( "N/A" )
	C2text:SetText( "N/A" )
	PanCDing = "0"
	BubCDing = "0"
	CorrCDing = "0"
	IntCDing = "0"
	Cus1CDing = "0"
	Cus2CDing = "0"

	OOCcrit = "Out of Combat"
	OOClabel1:SetText( OOCcrit )

	Managercheck:SetChecked( false )
	loadwithman = "0"

	rcompmbackcolor = 0.24705882352941176470588235294118
	gcompmbackcolor = 0.72941176470588235294117647058824
	bcompmbackcolor = 0.27843137254901960784313725490196

	rcompm2backcolor = 1
	gcompm2backcolor = 0.89411764705882352941176470588235
	bcompm2backcolor = 0.29803921568627450980392156862745

	rcompm3backcolor = 1
	gcompm3backcolor = 0.18823529411764705882352941176471
	bcompm3backcolor = 0.21568627450980392156862745098039

	rcomppbackcolor = 0.28235294117647058823529411764706
	gcomppbackcolor = 0
	bcomppbackcolor = 0.8039215686274509803921568627451

	rcompp2backcolor = 0.44705882352941176470588235294118
	gcompp2backcolor = 0.67843137254901960784313725490196
	bcompp2backcolor = 1
	
	rcompp3backcolor = 0.06666666666666666666666666666667
	gcompp3backcolor = 0.87450980392156862745098039215686
	bcompp3backcolor = 1

	rcomptbackcolor = 1
	gcomptbackcolor = 0.14901960784313725490196078431373
	bcomptbackcolor = 0.95686274509803921568627450980392

	rcompmgreen = 0
	gcompmgreen = .7
	bcompmgreen = 0
	
	rcomppurple = 1
	gcomppurple = 0
	bcomppurple = .8
	
	rcomppblue = 0
	gcomppblue = 0
	bcomppblue = .7

	mbackcolor = Turbine.UI.Color( 0, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	mbackcolor2 = Turbine.UI.Color( 0, rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	mbackcolor3 = Turbine.UI.Color( 0, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	pbackcolor = Turbine.UI.Color( 0, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	pbackcolor2 = Turbine.UI.Color( 0, rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	pbackcolor3 = Turbine.UI.Color( 0, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	tbackcolor = Turbine.UI.Color( 1, rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
	mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
	purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
	pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )

	MRSB:SetValue( rcompmbackcolor * 255 )
	MRSBL:SetText( "Red - "..(rcompmbackcolor * 255) )
	MGSB:SetValue( gcompmbackcolor * 255 )
	MGSBL:SetText( "Green - "..(gcompmbackcolor * 255) )
	MBSB:SetValue( bcompmbackcolor * 255 )
	MBSBL:SetText( "Blue - "..(bcompmbackcolor * 255) )

	M2RSB:SetValue( rcompm2backcolor * 255 )
	M2RSBL:SetText( "Red - "..(rcompm2backcolor * 255) )
	M2GSB:SetValue( gcompm2backcolor * 255 )
	M2GSBL:SetText( "Green - "..(gcompm2backcolor * 255) )
	M2BSB:SetValue( bcompm2backcolor * 255 )
	M2BSBL:SetText( "Blue - "..(bcompm2backcolor * 255) )

	M3RSB:SetValue( rcompm3backcolor * 255 )
	M3RSBL:SetText( "Red - "..(rcompm3backcolor * 255) )
	M3GSB:SetValue( gcompm3backcolor * 255 )
	M3GSBL:SetText( "Green - "..(gcompm3backcolor * 255) )
	M3BSB:SetValue( bcompm3backcolor * 255 )
	M3BSBL:SetText( "Blue - "..(bcompm3backcolor * 255) )

	PRSB:SetValue( rcomppbackcolor * 255 )
	PRSBL:SetText( "Red - "..(rcomppbackcolor * 255) )
	PGSB:SetValue( gcomppbackcolor * 255 )
	PGSBL:SetText( "Green - "..(gcomppbackcolor * 255) )
	PBSB:SetValue( bcomppbackcolor * 255 )
	PBSBL:SetText( "Blue - "..(bcomppbackcolor * 255) )

	P2RSB:SetValue( rcompp2backcolor * 255 )
	P2RSBL:SetText( "Red - "..(rcompp2backcolor * 255) )
	P2GSB:SetValue( gcompp2backcolor * 255 )
	P2GSBL:SetText( "Green - "..(gcompp2backcolor * 255) )
	P2BSB:SetValue( bcompp2backcolor * 255 )
	P2BSBL:SetText( "Blue - "..(bcompp2backcolor * 255) )

	P3RSB:SetValue( rcompp3backcolor * 255 )
	P3RSBL:SetText( "Red - "..(rcompm3backcolor * 255) )
	P3GSB:SetValue( gcompp3backcolor * 255 )
	P3GSBL:SetText( "Green - "..(gcompp3backcolor * 255) )
	P3BSB:SetValue( bcompp3backcolor * 255 )
	P3BSBL:SetText( "Blue - "..(bcompp3backcolor * 255) )

	TRSB:SetValue( rcomptbackcolor * 255 )
	TRSBL:SetText( "Red - "..(rcomptbackcolor * 255) )
	TGSB:SetValue( gcomptbackcolor * 255 )
	TGSBL:SetText( "Green - "..(gcomptbackcolor * 255) )
	TBSB:SetValue( bcomptbackcolor * 255 )
	TBSBL:SetText( "Blue - "..(bcomptbackcolor * 255) )
	TCP:SetBackColor( tbackcolor )
	MBarT:SetBackColor( tbackcolor )

	MTRSB:SetValue( rcompmgreen * 255 )
	MTRSBL:SetText( "Red - "..(rcompmgreen * 255) )
	MTGSB:SetValue( gcompmgreen * 255 )
	MTGSBL:SetText( "Green - "..(gcompmgreen * 255) )
	MTBSB:SetValue( bcompmgreen * 255 )
	MTBSBL:SetText( "Blue - "..(bcompmgreen * 255) )
	MTCP:SetBackColor( mgreen )
	MRealLabel:SetForeColor( mgreen )
	MSlashLabel:SetForeColor( mgreen )
	MMaxLabel:SetForeColor( mgreen )
	MPercLabel:SetForeColor( mgreen )
	MPercLabel2:SetForeColor( mgreen )

	TTRSB:SetValue( rcomppurple * 255 )
	TTRSBL:SetText( "Red - "..(rcomppurple * 255) )
	TTGSB:SetValue( gcomppurple * 255 )
	TTGSBL:SetText( "Green - "..(gcomppurple * 255) )
	TTBSB:SetValue( bcomppurple * 255 )
	TTBSBL:SetText( "Blue - "..(bcomppurple * 255) )
	TTCP:SetBackColor( purple )
	TMRealLabel:SetForeColor( purple )
	TMSlashLabel:SetForeColor( purple )
	TMMaxLabel:SetForeColor( purple )
	TMPercLabel:SetForeColor( purple )
	TMPercLabel2:SetForeColor( purple )

	PTRSB:SetValue( rcomppblue * 255 )
	PTRSBL:SetText( "Red - "..(rcomppblue * 255) )
	PTGSB:SetValue( gcomppblue * 255 )
	PTGSBL:SetText( "Green - "..(gcomppblue * 255) )
	PTBSB:SetValue( bcomppblue * 255 )
	PTBSBL:SetText( "Blue - "..(bcomppblue * 255) )
	PTCP:SetBackColor( pblue )
	PRealLabel:SetForeColor( pblue )
	PSlashLabel:SetForeColor( pblue )
	PMaxLabel:SetForeColor( pblue )
	PPercLabel:SetForeColor( pblue )
	PPercLabel2:SetForeColor( pblue )
end

Primwin:LoadDefaults()

function HUDPlus:LoadData()
	PlayerClass = Player:GetClass()
	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
	CurFervour = ChmpAtts:GetFervor()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailCHMP.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
	CurFocus = HntAtts:GetFocus()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
	CurAtt = RKAtts:GetAttunement()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	else
	Meter = "0"
	MeterCheck:SetEnabled( false )
	MeterCheck:SetChecked( false )
	end
	if loadwithman == "0" or LOADED == "0" then
	PanCDing = "0"
	BubCDing = "0"
	CorrCDing = "0"
	IntCDing = "0"
	Cus1CDing = "0"
	Cus2CDing = "0"
	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
		Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlus", 
		function ( HUDPlusData )
			if HUDPlusData ~= nil then

			CritLevelT = HUDPlusData.CritLevel
			LowLevelT = HUDPlusData.LowLevel
			PCritLevelT = HUDPlusData.PCritLevel
			PLowLevelT = HUDPlusData.PLowLevel
			DHitLevel = HUDPlusData.DLevel

			LowScroll:SetValue ( LowLevelT * 100 )
			PLowScroll:SetValue( PLowLevelT * 100 )
			CriticalScroll:SetMaximum( LowLevelT * 100 )
			PCriticalScroll:SetMaximum( PLowLevelT * 100 )
			CriticalScroll:SetValue( CritLevelT * 100 )
			PCriticalScroll:SetValue( PCritLevelT * 100 )
			LowScrollLabel:SetText( ( LowLevelT * 100 ).."% - Low" )
			PLowScrollLabel:SetText( ( PLowLevelT * 100 ).."% - Low" )
			CriticalScrollLabel:SetText( ( CritLevelT * 100).."% - Critical" )
			PCriticalScrollLabel:SetText( ( PCritLevelT * 100).."% - Critical" )
			DHitScroll:SetValue( DHitLevel )
			DHitScrollLabel:SetText( DHitLevel.." - Hit Size" )
			AWarnFading = "0"

			quickslots = HUDPlusData.quickslots
			Bars = HUDPlusData.Bars
			Meter = HUDPlusData.Meter
			Moralewarn = HUDPlusData.Moralewarn
			Powerwarn = HUDPlusData.Powerwarn
			PanCD = HUDPlusData.PancD
			BubCD = HUDPlusData.BubCD
			Text = HUDPlusData.Text
			CorruptionCD = HUDPlusData.CorruptionCD
			InterruptCD = HUDPlusData.InterruptCD
			DHitWarning = HUDPlusData.DHitWarning
			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus1CD
			IndOnly = HUDPlusData.IndOnly

			if quickslots == "1" then
			QScheck:SetChecked( true )
			else QScheck:SetChecked( false )
			end
			if Bars == "1" then
			Barcheck:SetChecked( true )
			else Barcheck:SetChecked( false )
			end
			if Meter == "1" then
			MeterCheck:SetChecked( true )
			else MeterCheck:SetChecked( false )
			Meter = "0"
			end
			if Moralewarn == "1" then
			MWarncheck:SetChecked( true )
			else MWarncheck:SetChecked( false )
			end
			if Powerwarn == "1" then
			PWarncheck:SetChecked( true ) 
			else PWarncheck:SetChecked( false )
			end
			if DHitWarning == "1" then
			DHitWarncheck:SetChecked( true )
			else DHitWarncheck:SetChecked( false )
			end
			if InterruptCD == "1" then
			InterruptCDcheck:SetChecked( true )
			else InterruptCDcheck:SetChecked( false )
			end
			if PanCD == "1" then
			PanCDcheck:SetChecked( true )
			else PanCDcheck:SetChecked( false )
			end
			if BubCD == "1" then
			BubCDcheck:SetChecked( true )
			else BubCDcheck:SetChecked( false )
			end
			if Text == "1" then
			Textcheck:SetChecked( true )
			else Textcheck:SetChecked( false )
			end
			if CorruptionCD == "1" then
			CorruptionCDcheck:SetChecked( true )
			else CorruptionCDcheck:SetChecked( false )
			end
			if Cus1CD == "1" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "1" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end
			if IndOnly == "1" then
			IndOnlycheck:SetChecked( true )
			else IndOnlycheck:SetChecked( false )
			end

			MWopT = HUDPlusData.MWopT
			PWopT = HUDPlusData.PWopT
			DHopT = HUDPlusData.DHopT
			BopT = HUDPlusData.BopT
			MopT = HUDPlusData.MopT

			BOSLabel:SetText( (BopT * 100).."% Bar Opacity" )
			BopF = ( BopT * 100 )
			BOS:SetValue( BopF )

			MOSLabel:SetText( (MopT * 100).."% Opacity" )
			MopF = ( MopT * 100 )
			MOS:SetValue( MopF )

			MWOSLabel:SetText( ( MWopT * 100 ).."% Opacity" )
			MWopF = ( MWopT * 100 )
			MWOS:SetValue( MWopF )
			MWarn:SetOpacity( MWopF )

			PWOSLabel:SetText( (PWopT * 100).."% Opacity" )
			PWopF = ( PWopT * 100 )
			PWOS:SetValue( PWopF )
			PWarn:SetOpacity( PWopF )

			DHOSLabel:SetText( (DHopT * 100).."% Opacity" )
			DHopF = ( DHopT * 100 )
			DHOS:SetValue( DHopF )
			DHitWarn:SetOpacity( DHopF )

			MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )

			Pantext:SetText( HUDPlusData.Panskill )
			Cortext:SetText( HUDPlusData.Corskill )
			Inttext:SetText( HUDPlusData.Intskill )
			Bubtext:SetText( HUDPlusData.Bubskill )
			C1text:SetText( HUDPlusData.C1skill )
			C2text:SetText( HUDPlusData.C2skill )

			PanScroll:SetValue( HUDPlusData.PanicCD )
			CorScroll:SetValue( HUDPlusData.CorCD )
			IntScroll:SetValue( HUDPlusData.IntCD )
			BubScroll:SetValue( HUDPlusData.BubbCD )
			C1Scroll:SetValue( HUDPlusData.C1CD )
			C2Scroll:SetValue( HUDPlusData.C2CD )
			PSL:SetText( HUDPlusData.PanicCD )
			BSL:SetText( HUDPlusData.BubbCD )
			ISL:SetText( HUDPlusData.IntCD )
			CSL:SetText( HUDPlusData.CorCD )
			C1SL:SetText( HUDPlusData.C1CD )
			C2SL:SetText( HUDPlusData.C2CD )

			OOCcrit = HUDPlusData.OOCcrit
			OOClabel1:SetText( OOCcrit )

			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus2CD
			if Cus1CD == "1" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "1" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end

			MData = HUDPlusData.MData
			PData = HUDPlusData.PData
			DData = HUDPlusData.DData
			WData = HUDPlusData.WData
			FData = HUDPlusData.FData
			PoData = HUDPlusData.PoData
			MType = HUDPlusData.MType
			PType = HUDPlusData.PType
			DType = HUDPlusData.DType
			WType = HUDPlusData.WType
			FType = HUDPlusData.FType
			PoType = HUDPlusData.PoType
			
			loadwithman = HUDPlusData.loadwithman

				if loadwithman == "1" then
				Managercheck:SetChecked( true )
				else Managercheck:SetChecked( false )
				end
			if loadwithman == "0" then
				MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
				MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			end

			MWarn:SetLeft( HUDPlusData.MWarnX )
			MWarn:SetTop( HUDPlusData.MWarnY )
			PWarn:SetLeft( HUDPlusData.PWarnX )
			PWarn:SetTop( HUDPlusData.PWarnY )
			DHitWarn:SetLeft( HUDPlusData.DHitWarnX )
			DHitWarn:SetTop( HUDPlusData.DHitWarnY )
			PanicCD:SetLeft( HUDPlusData.PanicCDX )
			PanicCD:SetTop( HUDPlusData.PanicCDY )
			BubbleCD:SetLeft( HUDPlusData.BubbleCDX )
			BubbleCD:SetTop( HUDPlusData.BubbleCDY )
			IntCD:SetLeft( HUDPlusData.IntCDX )
			IntCD:SetTop( HUDPlusData.IntCDY )
			CorrCD:SetLeft( HUDPlusData.CorrCDX )
			CorrCD:SetTop( HUDPlusData.CorrCDY )
			C1CD:SetLeft( HUDPlusData.C1CDX )
			C1CD:SetTop( HUDPlusData.C1CDY )
			C2CD:SetLeft( HUDPlusData.C2CDX )
			C2CD:SetTop( HUDPlusData.C2CDY )

			MQSG:SetLeft( HUDPlusData.MQSGX )
			MQSG:SetTop( HUDPlusData.MQSGY )
			PQSG:SetLeft( HUDPlusData.PQSGX )
			PQSG:SetTop( HUDPlusData.PQSGY )
			FQSG:SetLeft( HUDPlusData.FQSGX )
			FQSG:SetTop( HUDPlusData.FQSGY )
			DQSG:SetLeft( HUDPlusData.DQSGX )
			DQSG:SetTop( HUDPlusData.DQSGY )
			WQSG:SetLeft( HUDPlusData.WQSGX )
			WQSG:SetTop( HUDPlusData.WQSGY )
			PoQSG:SetLeft( HUDPlusData.PoQSGX )
			PoQSG:SetTop( HUDPlusData.PoQSGY )

			MBarWin:SetLeft( HUDPlusData.MBarX )
			MBarRail:SetLeft( HUDPlusData.MBarX )
			MBarWin:SetTop( HUDPlusData.MBarY )
			MBarRail:SetTop( HUDPlusData.MBarY )
			PBarWin:SetLeft( HUDPlusData.PBarX )
			PBarRail:SetLeft( HUDPlusData.PBarX )
			PBarWin:SetTop( HUDPlusData.PBarY )
			PBarRail:SetTop( HUDPlusData.PBarY )

			MTWin:SetTop( HUDPlusData.MTWinY )
			MTWin:SetLeft( HUDPlusData.MTWinX )
			PTWin:SetLeft( HUDPlusData.PTWinX )
			PTWin:SetTop( HUDPlusData.PTWinY )
			TTWin:SetLeft( HUDPlusData.TTWinX )
			TTWin:SetTop( HUDPlusData.TTWinY )

			MeterWin:SetLeft( HUDPlusData.MeterBarX )
			MeterRail:SetLeft( HUDPlusData.MeterBarX )
			MeterWin:SetTop( HUDPlusData.MeterBarY )
			MeterRail:SetTop( HUDPlusData.MeterBarY )

			HUDPlus:LoadData2()

			else Primwin:LoadDefaults()
			end
		end
		);
	end
end

function HUDPlus:LoadData2()
	Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlus2", 
	function ( HUDPlusData2 )
			if HUDPlusData2 ~= nil then
			--COLOR------------------------------------------------------------------------------------------------

			rcompmbackcolor = HUDPlusData2.rcompmbackcolor
			gcompmbackcolor = HUDPlusData2.gcompmbackcolor
			bcompmbackcolor = HUDPlusData2.bcompmbackcolor

			rcompm2backcolor = HUDPlusData2.rcompm2backcolor
			gcompm2backcolor = HUDPlusData2.gcompm2backcolor
			bcompm2backcolor = HUDPlusData2.bcompm2backcolor

			rcompm3backcolor = HUDPlusData2.rcompm3backcolor
			gcompm3backcolor = HUDPlusData2.gcompm3backcolor
			bcompm3backcolor = HUDPlusData2.bcompm3backcolor

			rcomppbackcolor = HUDPlusData2.rcomppbackcolor
			gcomppbackcolor = HUDPlusData2.gcomppbackcolor
			bcomppbackcolor = HUDPlusData2.bcomppbackcolor

			rcompp2backcolor = HUDPlusData2.rcompp2backcolor
			gcompp2backcolor = HUDPlusData2.gcompp2backcolor
			bcompp2backcolor = HUDPlusData2.bcompp2backcolor
	
			rcompp3backcolor = HUDPlusData2.rcompp3backcolor
			gcompp3backcolor = HUDPlusData2.gcompp3backcolor
			bcompp3backcolor = HUDPlusData2.bcompp3backcolor

			rcomptbackcolor = HUDPlusData2.rcomptbackcolor
			gcomptbackcolor = HUDPlusData2.gcomptbackcolor
			bcomptbackcolor = HUDPlusData2.bcomptbackcolor

			rcompmgreen = HUDPlusData2.rcompmgreen
			gcompmgreen = HUDPlusData2.gcompmgreen
			bcompmgreen = HUDPlusData2.bcompmgreen
	
			rcomppurple = HUDPlusData2.rcomppurple
			gcomppurple = HUDPlusData2.gcomppurple
			bcomppurple = HUDPlusData2.bcomppurple
	
			rcomppblue = HUDPlusData2.rcomppblue
			gcomppblue = HUDPlusData2.gcomppblue
			bcomppblue = HUDPlusData2.bcomppblue

			mbackcolor = Turbine.UI.Color( 0, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
			mbackcolor2 = Turbine.UI.Color( 0, rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
			mbackcolor3 = Turbine.UI.Color( 0, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
			pbackcolor = Turbine.UI.Color( 0, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
			pbackcolor2 = Turbine.UI.Color( 0, rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
			pbackcolor3 = Turbine.UI.Color( 0, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
			tbackcolor = Turbine.UI.Color( 1, rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
			mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
			purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
			pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )

			MRSB:SetValue( rcompmbackcolor * 255 )
			MRSBL:SetText( "Red - "..(math.floor( rcompmbackcolor * 255) ) )
			MGSB:SetValue( gcompmbackcolor * 255 )
			MGSBL:SetText( "Green - "..( math.floor(gcompmbackcolor * 255) ) )
			MBSB:SetValue( bcompmbackcolor * 255 )
			MBSBL:SetText( "Blue - "..(math.floor(bcompmbackcolor * 255) ) )

			M2RSB:SetValue( rcompm2backcolor * 255 )
			M2RSBL:SetText( "Red - "..(math.floor(rcompm2backcolor * 255) ) )
			M2GSB:SetValue( gcompm2backcolor * 255 )
			M2GSBL:SetText( "Green - "..( math.floor(gcompm2backcolor * 255) ) )
			M2BSB:SetValue( bcompm2backcolor * 255 )
			M2BSBL:SetText( "Blue - "..( math.floor(bcompm2backcolor * 255) ) )

			M3RSB:SetValue( rcompm3backcolor * 255 )
			M3RSBL:SetText( "Red - "..( math.floor(rcompm3backcolor * 255) ) )
			M3GSB:SetValue( gcompm3backcolor * 255 )
			M3GSBL:SetText( "Green - "..( math.floor(gcompm3backcolor * 255) ) )
			M3BSB:SetValue( bcompm3backcolor * 255 )
			M3BSBL:SetText( "Blue - "..(math.floor(bcompm3backcolor * 255) ) )

			PRSB:SetValue( rcomppbackcolor * 255 )
			PRSBL:SetText( "Red - "..( math.floor(rcomppbackcolor * 255) ) )
			PGSB:SetValue( gcomppbackcolor * 255 )
			PGSBL:SetText( "Green - "..( math.floor(gcomppbackcolor * 255) ) )
			PBSB:SetValue( bcomppbackcolor * 255 )
			PBSBL:SetText( "Blue - "..( math.floor(bcomppbackcolor * 255) ) )

			P2RSB:SetValue( rcompp2backcolor * 255 )
			P2RSBL:SetText( "Red - "..( math.floor(rcompp2backcolor * 255) ) )
			P2GSB:SetValue( gcompp2backcolor * 255 )
			P2GSBL:SetText( "Green - "..( math.floor(gcompp2backcolor * 255) ) )
			P2BSB:SetValue( bcompp2backcolor * 255 )
			P2BSBL:SetText( "Blue - "..( math.floor(bcompp2backcolor * 255) ) )

			P3RSB:SetValue( rcompp3backcolor * 255 )
			P3RSBL:SetText( "Red - "..( math.floor(rcompm3backcolor * 255) ) )
			P3GSB:SetValue( gcompp3backcolor * 255 )
			P3GSBL:SetText( "Green - "..( math.floor(gcompp3backcolor * 255) ) )
			P3BSB:SetValue( bcompp3backcolor * 255 )
			P3BSBL:SetText( "Blue - "..( math.floor(bcompp3backcolor * 255) ) )

			TRSB:SetValue( rcomptbackcolor * 255 )
			TRSBL:SetText( "Red - "..( math.floor(rcomptbackcolor * 255) ) )
			TGSB:SetValue( gcomptbackcolor * 255 )
			TGSBL:SetText( "Green - "..( math.floor(gcomptbackcolor * 255) ) )
			TBSB:SetValue( bcomptbackcolor * 255 )
			TBSBL:SetText( "Blue - "..( math.floor(bcomptbackcolor * 255) ) )
			TCP:SetBackColor( tbackcolor )
			MBarT:SetBackColor( tbackcolor )

			MTRSB:SetValue( rcompmgreen * 255 )
			MTRSBL:SetText( "Red - "..( math.floor(rcompmgreen * 255) ) )
			MTGSB:SetValue( gcompmgreen * 255 )
			MTGSBL:SetText( "Green - "..( math.floor(gcompmgreen * 255) ) )
			MTBSB:SetValue( bcompmgreen * 255 )
			MTBSBL:SetText( "Blue - "..( math.floor(bcompmgreen * 255) ) )
			MTCP:SetBackColor( mgreen )
			MRealLabel:SetForeColor( mgreen )
			MSlashLabel:SetForeColor( mgreen )
			MMaxLabel:SetForeColor( mgreen )
			MPercLabel:SetForeColor( mgreen )
			MPercLabel2:SetForeColor( mgreen )

			TTRSB:SetValue( rcomppurple * 255 )
			TTRSBL:SetText( "Red - "..( math.floor(rcomppurple * 255) ) )
			TTGSB:SetValue( gcomppurple * 255 )
			TTGSBL:SetText( "Green - "..( math.floor(gcomppurple * 255) ) )
			TTBSB:SetValue( bcomppurple * 255 )
			TTBSBL:SetText( "Blue - "..( math.floor(bcomppurple * 255) ) )
			TTCP:SetBackColor( purple )
			TMRealLabel:SetForeColor( purple )
			TMSlashLabel:SetForeColor( purple )
			TMMaxLabel:SetForeColor( purple )
			TMPercLabel:SetForeColor( purple )
			TMPercLabel2:SetForeColor( purple )

			PTRSB:SetValue( rcomppblue * 255 )
			PTRSBL:SetText( "Red - "..( math.floor(rcomppblue * 255) ) )
			PTGSB:SetValue( gcomppblue * 255 )
			PTGSBL:SetText( "Green - "..( math.floor(gcomppblue * 255) ) )
			PTBSB:SetValue( bcomppblue * 255 )
			PTBSBL:SetText( "Blue - "..( math.floor(bcomppblue * 255) ) )
			PTCP:SetBackColor( pblue )
			PRealLabel:SetForeColor( pblue )
			PSlashLabel:SetForeColor( pblue )
			PMaxLabel:SetForeColor( pblue )
			PPercLabel:SetForeColor( pblue )
			PPercLabel2:SetForeColor( pblue )
			end
	end
	);
end

function HUDPlus:LoadFlags()
	Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlusF", 
	function ( HUDPlusFlags )
	if HUDPlusFlags ~= nil then
	MLastPot = HUDPlusFlags.MLastPot
	PLastPot = HUDPlusFlags.PLastPot
	DLastPot = HUDPlusFlags.DLastPot
	WLastPot = HUDPlusFlags.WLastPot
	PoLastPot = HUDPlusFlags.PoLastPot
	FLastPot = HUDPlusFlags.FLastPot
	end
	end
	);
end

HUDPlus:LoadFlags();

function Primwin:RecenterControls()
	MWarn:SetLeft( 180 + Primwin:GetLeft() );
	MWarn:SetTop( -40 + Primwin:GetTop() );
	PWarn:SetLeft( 180 + Primwin:GetLeft() );
	PWarn:SetTop( 100 + Primwin:GetTop() );
	DHitWarn:SetLeft( 110 + Primwin:GetLeft() )
	DHitWarn:SetTop( 150 + Primwin:GetTop() )
	PanicCD:SetLeft( 90 + Primwin:GetLeft() )
	PanicCD:SetTop( -40 + Primwin:GetTop() )
	BubbleCD:SetLeft( 280 + Primwin:GetLeft() )
	BubbleCD:SetTop( -40 + Primwin:GetTop() )
	CorrCD:SetLeft( 280 + Primwin:GetLeft() )
	CorrCD:SetTop( 105 + Primwin:GetTop() )
	IntCD:SetLeft( 90 + Primwin:GetLeft() )
	IntCD:SetTop( 105 + Primwin:GetTop() )
	C1CD:SetLeft( 20 + Primwin:GetLeft() )
	C1CD:SetTop( 105 + Primwin:GetTop() )
	C2CD:SetLeft( 360 + Primwin:GetLeft() )
	C2CD:SetTop( 105 + Primwin:GetTop() )
	WQSG:SetPosition( 140 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	DQSG:SetPosition( 180 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	MQSG:SetPosition( 100 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	PQSG:SetPosition( 305 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	PoQSG:SetPosition( 225 + Primwin:GetLeft(), 70 + Primwin:GetTop() )
	FQSG:SetPosition( 265 + Primwin:GetLeft() , 70 + Primwin:GetTop() )
	MBarRail:SetPosition( 20 + Primwin:GetLeft() , 10 + Primwin:GetTop() )
	PBarRail:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	MBarWin:SetPosition( 20 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	PBarWin:SetPosition( 220 + Primwin:GetLeft(), 10 + Primwin:GetTop() )
	MeterWin:SetPosition( 90 + Primwin:GetLeft(), 195 + Primwin:GetTop() );
	MeterRail:SetPosition( 90 + Primwin:GetLeft() , 195 + Primwin:GetTop() );

	MTWin:SetPosition( 95 + Primwin:GetLeft(), 40 + Primwin:GetTop() )
	PTWin:SetPosition( 225 + Primwin:GetLeft(), 40 + Primwin:GetTop() )
	TTWin:SetPosition( 95 + Primwin:GetLeft(), 53 + Primwin:GetTop() )
end

HUDPlus:LoadData()

--HUD Functions

function MBar:ScanMorale()
	MaxM = ( Player:GetMaxMorale() )
	CurM = ( Player:GetMorale() )
	MPerc = ( CurM / MaxM )
	BarPerc = ( ( CurM ) / ( MaxM + Player:GetMaxTemporaryMorale() ) )
	CurTemp = Player:GetTemporaryMorale()
	CurTempMax = Player:GetMaxTemporaryMorale()
	TempPerc2 = ( CurTemp / ( MaxM + Player:GetMaxTemporaryMorale() ) )
	TempPerc = ( CurTemp / CurTempMax )
	if MPerc <= CritLevelT then
	MStat = "Critical"
	elseif MPerc <= LowLevelT then
	MStat = "Low"
	elseif MPerc >= LowLevelT then 
	MStat = "Normal"
	end
	if MPerc == 1 then
	MFull = "1"
	else MFull = "0"
	end
	MBar:SetLeft( 200 - ( MBarWin:GetWidth() * ( BarPerc ) ) )
	MBarT:SetLeft( ( TempPerc2 * 200 ) - 200 )
	if MPerc <= LowLevelT then
	mbackcolor3 = Turbine.UI.Color( 1, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	mbackcolor = Turbine.UI.Color( 0, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	MBar:SetBackColor( mbackcolor3 )
	elseif MPerc >= LowLevelT then
	mbackcolor3 = Turbine.UI.Color( 0, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	mbackcolor = Turbine.UI.Color( 1, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	MBar:SetBackColor( mbackcolor )
	end
	if ( 1 - MPerc ) <= LowLevelT then
	mbackcolor2 = Turbine.UI.Color( 1 - MPerc / LowLevelT , rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	MBar2:SetBackColor( mbackcolor2 )
	elseif MPerc <= CritLevelT then
	mbackcolor2 = Turbine.UI.Color( 0 , rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	MBar2:SetBackColor( mbackcolor2 )
	elseif ( 1 - MPerc ) >= LowLevelT then
	mbackcolor2 = Turbine.UI.Color( MPerc - LowLevelT / CritLevelT - LowLevelT , rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	MBar2:SetBackColor( mbackcolor2 )
	end
end

function PBar:ScanPower()
	MaxP = Player:GetMaxPower()
	CurP = Player:GetPower()
	PPerc = ( CurP / MaxP )
	if PPerc <= PCritLevelT then
	PStat = "Critical"
	elseif PPerc <= PLowLevelT then
	PStat = "Low"
	elseif PPerc >= PLowLevelT then 
	PStat = "Normal"
	end
	if PPerc == 1 then
	PFull = "1"
	else PFull = "0"
	end
	PBar:SetLeft( ( PBarWin:GetWidth() * ( PPerc ) ) - 200)
	if PPerc <= PLowLevelT then
	pbackcolor3 = Turbine.UI.Color( 1, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	pbackcolor = Turbine.UI.Color( 0, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	PBar:SetBackColor( pbackcolor3 )
	elseif PPerc >= PLowLevelT then
	pbackcolor3 = Turbine.UI.Color( 0, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	pbackcolor = Turbine.UI.Color( 1, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	PBar:SetBackColor( pbackcolor )
	end
	if ( 1 - PPerc ) <= PLowLevelT then
	pbackcolor2 = Turbine.UI.Color( 1 - PPerc / PLowLevelT , rcompp2backcolor, gcompp2backcolor , bcompp2backcolor )
	PBar2:SetBackColor( pbackcolor2 )
	elseif PPerc <= PCritLevelT then
	pbackcolor2 = Turbine.UI.Color( 0 , rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	PBar2:SetBackColor( pbackcolor2 )
	elseif ( 1 - PPerc ) >= PLowLevelT then
	pbackcolor2 = Turbine.UI.Color( PPerc - PLowLevelT / PCritLevelT - PLowLevelT , rcompp2backcolor , gcompp2backcolor, bcompp2backcolor )
	PBar2:SetBackColor( pbackcolor2 )
	end
end

function MRealLabel:ScanMorale()
	MRealLabel:SetText( CurM )
	MMaxLabel:SetText( MaxM )
	MPercLabel:SetText( ( MPerc * 100 ) )
	if MaxM <= 10 then
	MMaxLabel:SetWidth( 7 )
	elseif MaxM <= 100 then
	MMaxLabel:SetWidth( 15 )
	elseif MaxM <= 1000 then
	MMaxLabel:SetWidth( 20 )
	elseif MaxM >= 10000 then
	MMaxLabel:SetWidth( 35 )
	elseif MaxM >= 1000 then
	MMaxLabel:SetWidth( 28 )
	end

	if CurM <= 10 then
	MRealLabel:SetWidth( 7 )
	elseif CurM <= 100 then
	MRealLabel:SetWidth( 15 )
	elseif CurM <= 1000 then
	MRealLabel:SetWidth( 20 )
	elseif CurM >= 10000 then
	MRealLabel:SetWidth( 35 )
	elseif CurM >= 1000 then
	MRealLabel:SetWidth( 28 )
	end

	if MPerc < .1 then
	MPercLabel:SetWidth( 7 )
	MPercLabel2:SetLeft( 99 )
	elseif MPerc < 1 
	then MPercLabel2:SetLeft( 104 )
	MPercLabel:SetWidth( 15 )
	elseif MPerc == 1 then
	MPercLabel2:SetLeft( 107 )
	MPercLabel:SetWidth( 20 )
	end

	if CurTempMax >= 0 then
	TMRealLabel:SetText( CurTemp )
	TMMaxLabel:SetText( CurTempMax )
	TMPercLabel:SetText( ( TempPerc * 100 ) )
	end

	if CurTempMax <= 10 then
	TMMaxLabel:SetWidth( 7 )
	elseif CurTempMax <= 100 then
	TMMaxLabel:SetWidth( 15 )
	elseif CurTempMax <= 1000 then
	TMMaxLabel:SetWidth( 20 )
	elseif CurTempMax >= 10000 then
	TMMaxLabel:SetWidth( 35 )
	elseif CurTempMax >= 1000 then
	TMMaxLabel:SetWidth( 28 )
	end

	if CurTemp <= 10 then
	TMRealLabel:SetWidth( 7 )
	elseif CurTemp <= 100 then
	TMRealLabel:SetWidth( 15 )
	elseif CurTemp <= 1000 then
	TMRealLabel:SetWidth( 20 )
	elseif CurTemp >= 10000 then
	TMRealLabel:SetWidth( 35 )
	elseif CurTemp >= 1000 then
	TMRealLabel:SetWidth( 28 )
	end

	if TempPerc < .1 then
	TMPercLabel:SetWidth( 7 )
	TMPercLabel2:SetLeft( 99 )
	elseif TempPerc < 1 
	then TMPercLabel2:SetLeft( 104 )
	TMPercLabel:SetWidth( 15 )
	elseif TempPerc == 1 then
	TMPercLabel2:SetLeft( 107 )
	TMPercLabel:SetWidth( 20 )
	end

	if CurTempMax > 0 and Text == "1" then
	TTWin:SetVisible( true )
	elseif CurTempMax == 0 or Text == "0" then
	TTWin:SetVisible( false )
	end
end

function PRealLabel:ScanPower()
	PRealLabel:SetText( CurP )
	PMaxLabel:SetText( MaxP )
	PPercLabel:SetText( ( PPerc * 100 ) )
	if MaxP <= 10 then
	PMaxLabel:SetWidth( 5 )
	elseif MaxP <= 100 then
	PMaxLabel:SetWidth( 15 )
	elseif MaxP <= 1000 then
	PMaxLabel:SetWidth( 20 )
	elseif MaxP >= 10000 then
	PMaxLabel:SetWidth( 35 )
	elseif MaxP >= 1000 then
	PMaxLabel:SetWidth( 28 )
	end

	if CurP <= 10 then
	PRealLabel:SetWidth( 5 )
	elseif CurP <= 100 then
	PRealLabel:SetWidth( 15 )
	elseif CurP <= 1000 then
	PRealLabel:SetWidth( 20 )
	elseif CurP >= 10000 then
	PRealLabel:SetWidth( 35 )
	elseif CurP >= 1000 then
	PRealLabel:SetWidth( 28 )
	end

	if PPerc < .1 then
	PPercLabel:SetWidth( 7 )
	PPercLabel2:SetLeft( 14 )
	elseif PPerc < 1 
	then PPercLabel2:SetLeft( 19 )
	PPercLabel:SetWidth( 15 )
	elseif PPerc == 1 then
	PPercLabel2:SetLeft( 22 )
	PPercLabel:SetWidth( 20 )
	end
end

function MQSG:ScanMorale()
	if MStat == "Normal" then
	MQSG:SetVisible( false )
	MQS:SetVisible( false )	
	elseif MStat == "Low" or MStat == "Critical" then
	MQSG:SetVisible( true )
	MQS:SetVisible( true )
	end
	if MStat == "Normal" and MWarn:IsVisible() == true and MWarnFading ~= "1" then
	MWarn:FadeStart()
	MWarnFlashOut = "0"
	MWarnFlashIn = "0"
	elseif MStat == "Low" then
	MWarn:SetVisible( true )
	MWarnFlashOut = "0"
	MWarnFlashIn = "0"
	elseif MStat == "Critical" then
	MWarn:FlashOutStart()
	MWarn:SetVisible( true )
	end
end

function PQSG:ScanPower()
	if PStat == "Normal" then
	PQSG:SetVisible( false )
	PQS:SetVisible( false )
	elseif PStat == "Low" or PStat == "Critical" then
	PQSG:SetVisible( true )
	PQS:SetVisible( true )
	end
	if PStat == "Normal" and PWarn:IsVisible() == true and PWarnFading ~= "1" then
	PWarn:FadeStart()
	PWarnFlashOut = "0"
	PWarnFlashIn = "0"
	elseif PStat == "Low" then
	PWarn:SetVisible( true )
	PWarnFlashOut = "0"
	PWarnFlashIn = "0"
	elseif PStat == "Critical" then
	PWarn:FlashOutStart()
	PWarn:SetVisible( true )
	end
end

function Primwin:ScanEffects()
	Wounds = 0
	Diseases = 0
	Fears = 0
	Poisons = 0
	EffectList = Player:GetEffects()
	for i = 1, EffectList:GetCount() do
	Effect = EffectList:Get( i )
	Category = Effect:GetCategory()
		if Category == ( Turbine.Gameplay.EffectCategory.Wound ) and Effect:IsCurable() == true then
		Wounds = Wounds + 1 
		elseif Category == ( Turbine.Gameplay.EffectCategory.Disease ) and Effect:IsCurable() == true then
		Diseases = Diseases + 1
		elseif Category == ( Turbine.Gameplay.EffectCategory.Poison ) and Effect:IsCurable() == true then
		Poisons = Poisons + 1
		elseif Category == ( Turbine.Gameplay.EffectCategory.Fear ) and Effect:IsCurable() == true then
		Fears = Fears + 1
		end
	end
	if Diseases > 0 then
	DQSG:SetVisible( true )
	DQS:SetVisible( true )
	elseif Diseases == 0 then
	DQSG:SetVisible( false )
	DQS:SetVisible( false )
	end
	if Poisons > 0 then
	PoQSG:SetVisible( true )
	PoQS:SetVisible( true )
	elseif Poisons == 0 then
	PoQSG:SetVisible( false )
	PoQS:SetVisible( false )
	end
	if Fears > 0 then
	FQSG:SetVisible( true )
	FQS:SetVisible( true )
	elseif Fears == 0 then
	FQSG:SetVisible( false )
	FQS:SetVisible( false )
	end
	if Wounds > 0 then
	WQSG:SetVisible( true )
	WQS:SetVisible( true )
	elseif Wounds == 0 then
	WQSG:SetVisible( false )
	WQS:SetVisible( false )
	end
end

function DHitWarn:ScanMorale()
	Morale = Player:GetMorale()
	MoraleDif = ( Morale - StartMorale )
	StartMorale = Player:GetMorale()
	if MoraleDif < ( DHitLevel * -1 ) then
		DHitWarn:SetVisible( true )
		DVistime = LocTime
		DDistime = DVistime + 3
	end
	if DVistime ~= 0 and DDistime == LocTime then
	DHitWarn:FadeStart()
	end

end

function DHitWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	DP0 = FrameTime
	DP1 = FrameTime + .05
	DP2 = FrameTime + .1
	DP3 = FrameTime + .15
	DP4 = FrameTime + .2
	DP5 = FrameTime + .25
	DP6 = FrameTime + .3
	DP7 = FrameTime + .35
	DP8 = FrameTime + .4
	DP9 = FrameTime + .45
	DP10 = FrameTime + .5
	DHitWarnFading = "1"
	DHitWarn:SetOpacity( 1 * DHopT )
end

function DHitWarn:FadeOut()
	if FrameTime > DP0 and FrameTime < DP1 then
	DHitWarn:SetOpacity( .9 * DHopT )
	elseif FrameTime > DP1 and FrameTime < DP2 then
	DHitWarn:SetOpacity( .8 * DHopT )
	elseif FrameTime > DP2 and FrameTime < DP3 then
	DHitWarn:SetOpacity( .7 * DHopT )
	elseif FrameTime > DP3 and FrameTime < DP4 then
	DHitWarn:SetOpacity( .6 * DHopT )
	elseif FrameTime > DP4 and FrameTime < DP5 then
	DHitWarn:SetOpacity( .5 * DHopT )
	elseif FrameTime > DP5 and FrameTime < DP6 then
	DHitWarn:SetOpacity( .4 * DHopT )
	elseif FrameTime > DP6 and FrameTime < DP7 then
	DHitWarn:SetOpacity( .3 * DHopT )
	elseif FrameTime > DP7 and FrameTime < DP8 then
	DHitWarn:SetOpacity( .2 * DHopT )
	elseif FrameTime > DP8 and FrameTime < DP9 then
	DHitWarn:SetOpacity( .1 * DHopT )
	elseif FrameTime > DP9 and FrameTime < DP10 then
	DHitWarn:SetOpacity( 1 * DHopT )
	DHitWarn:SetVisible( false )
	DHitWarn:SetMouseVisible( false )
	DHitWarnFading = "0"
	elseif FrameTime > DP10 then 
	DHitWarn:SetOpacity( 1 * DHopT )
	DHitWarn:SetVisible( false )
	DHitWarn:SetMouseVisible( false )
	DHitWarnFading = "0"
	end
end

function MWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	MP0 = FrameTime
	MP1 = FrameTime + .05
	MP2 = FrameTime + .1
	MP3 = FrameTime + .15
	MP4 = FrameTime + .2
	MP5 = FrameTime + .25
	MP6 = FrameTime + .3
	MP7 = FrameTime + .35
	MP8 = FrameTime + .4
	MP9 = FrameTime + .45
	MP10 = FrameTime + .5
	MWarnFading = "1"
	MWarn:SetOpacity( 1 * MWopT )
end

function MWarn:FlashOutStart()
	if MWarnFlashOut == "0" then
	FrameTime = Turbine.Engine.GetGameTime()
	FMP0 = FrameTime
	FMP1 = FrameTime + .05
	FMP2 = FrameTime + .1
	FMP3 = FrameTime + .15
	FMP4 = FrameTime + .2
	FMP5 = FrameTime + .25
	FMP6 = FrameTime + .3
	FMP7 = FrameTime + .35
	FMP8 = FrameTime + .4
	FMP9 = FrameTime + .45
	FMP10 = FrameTime + .5
	MWarnFlashOut = "1"
	MWarn:SetOpacity( MWopT )
	end
end

function MWarn:FlashInStart()
	if MWarnFlashIn == "0" then
	FrameTime = Turbine.Engine.GetGameTime()
	FMP0 = FrameTime
	FMP1 = FrameTime + .05
	FMP2 = FrameTime + .1
	FMP3 = FrameTime + .15
	FMP4 = FrameTime + .2
	FMP5 = FrameTime + .25
	FMP6 = FrameTime + .3
	FMP7 = FrameTime + .35
	FMP8 = FrameTime + .4
	FMP9 = FrameTime + .45
	FMP10 = FrameTime + .5
	MWarnFlashIn = "1"
	end
end

function MWarn:FadeOut()
	if MWarn:IsVisible() == true then
		if FrameTime >= MP0 and FrameTime < MP1 then
		MWarn:SetOpacity( .9  * MWopT )
		elseif FrameTime > MP1 and FrameTime < MP2 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > MP2 and FrameTime < MP3 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > MP3 and FrameTime < MP4 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > MP4 and FrameTime < MP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > MP5 and FrameTime < MP6 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > MP6 and FrameTime < MP7 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > MP7 and FrameTime < MP8 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > MP8 and FrameTime < MP9 then
		MWarn:SetOpacity( .1 * MWopT )
		elseif FrameTime > MP9 and FrameTime < MP10 then
		MWarn:SetOpacity( 1 * MWopT )
		MWarn:SetVisible( false )
		MWarn:SetMouseVisible( false )
		MWarnFading = "0"
		elseif FrameTime > MP10 then
		MWarn:SetOpacity( 1 * MWopT )
		MWarn:SetVisible( false )
		MWarn:SetMouseVisible( false )
		MWarnFading = "0"
		end
	end
end

function MWarn:FlashOut()
		if FrameTime >= FMP0 and FrameTime < FMP1 then
		MWarn:SetOpacity( .9  * MWopT )
		elseif FrameTime > FMP1 and FrameTime < FMP2 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > FMP2 and FrameTime < FMP3 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > FMP3 and FrameTime < FMP4 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > FMP4 and FrameTime < FMP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > FMP5 and FrameTime < FMP6 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > FMP6 and FrameTime < FMP7 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > FMP7 and FrameTime < FMP8 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > FMP8 and FrameTime < FMP9 then
		MWarn:SetOpacity( .1 * MWopT )
		elseif FrameTime > FMP9 and FrameTime < FMP10 then
		MWarnFlashOut = "0"
		MWarn:FlashInStart()
		MWarn:SetOpacity( 0 * MWopT )
		elseif FrameTime > FMP10 then
		MWarnFlashOut = "0"
		MWarn:FlashInStart()
		MWarn:SetOpacity( 0 * MWopT )
		end
end

function MWarn:FlashIn()
		if FrameTime >= FMP0 and FrameTime < FMP1 then
		MWarn:SetOpacity( .1  * MWopT )
		elseif FrameTime > FMP1 and FrameTime < FMP2 then
		MWarn:SetOpacity( .2 * MWopT )
		elseif FrameTime > FMP2 and FrameTime < FMP3 then
		MWarn:SetOpacity( .3 * MWopT )
		elseif FrameTime > FMP3 and FrameTime < FMP4 then
		MWarn:SetOpacity( .4 * MWopT )
		elseif FrameTime > FMP4 and FrameTime < FMP5 then
		MWarn:SetOpacity( .5 * MWopT )
		elseif FrameTime > FMP5 and FrameTime < FMP6 then
		MWarn:SetOpacity( .6 * MWopT )
		elseif FrameTime > FMP6 and FrameTime < FMP7 then
		MWarn:SetOpacity( .7 * MWopT )
		elseif FrameTime > FMP7 and FrameTime < FMP8 then
		MWarn:SetOpacity( .8 * MWopT )
		elseif FrameTime > FMP8 and FrameTime < FMP9 then
		MWarn:SetOpacity( .9 * MWopT )
		elseif FrameTime > FMP9 and FrameTime < FMP10 then
		MWarnFlashIn = "0"
		MWarn:FlashOutStart()
		MWarn:SetOpacity( 1 * MWopT )
		elseif FrameTime > FMP10 then
		MWarnFlashIn = "0"
		MWarn:FlashOutStart()
		MWarn:SetOpacity( 1 * MWopT )
		end
end

function PWarn:FadeStart()
	FrameTime = Turbine.Engine.GetGameTime()
	PP0 = FrameTime
	PP1 = FrameTime + .05
	PP2 = FrameTime + .1
	PP3 = FrameTime + .15
	PP4 = FrameTime + .2
	PP5 = FrameTime + .25
	PP6 = FrameTime + .3
	PP7 = FrameTime + .35
	PP8 = FrameTime + .4
	PP9 = FrameTime + .45
	PP10 = FrameTime + .5
	PWarnFading = "1"
	PWarn:SetOpacity( 1 * PWopT )
end

function PWarn:FlashOutStart()
	if PWarnFlashOut == "0" then
	FrameTime = Turbine.Engine.GetGameTime()
	FPP0 = FrameTime
	FPP1 = FrameTime + .05
	FPP2 = FrameTime + .1
	FPP3 = FrameTime + .15
	FPP4 = FrameTime + .2
	FPP5 = FrameTime + .25
	FPP6 = FrameTime + .3
	FPP7 = FrameTime + .35
	FPP8 = FrameTime + .4
	FPP9 = FrameTime + .45
	FPP10 = FrameTime + .5
	PWarnFlashOut = "1"
	PWarn:SetOpacity( PWopT )
	end
end

function PWarn:FlashInStart()
	if PWarnFlashIn == "0" then
	FrameTime = Turbine.Engine.GetGameTime()
	FPP0 = FrameTime
	FPP1 = FrameTime + .05
	FPP2 = FrameTime + .1
	FPP3 = FrameTime + .15
	FPP4 = FrameTime + .2
	FPP5 = FrameTime + .25
	FPP6 = FrameTime + .3
	FPP7 = FrameTime + .35
	FPP8 = FrameTime + .4
	FPP9 = FrameTime + .45
	FPP10 = FrameTime + .5
	PWarnFlashIn = "1"
	end
end

function PWarn:FadeOut()
	if PWarn:IsVisible() == true then
		if FrameTime >= PP0 and FrameTime < PP1 then
		PWarn:SetOpacity( .9 * PWopT )
		elseif FrameTime > PP1 and FrameTime < PP2 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > PP2 and FrameTime < PP3 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > PP3 and FrameTime < PP4 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > PP4 and FrameTime < PP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > PP5 and FrameTime < PP6 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > PP6 and FrameTime < PP7 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > PP7 and FrameTime < PP8 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > PP8 and FrameTime < PP9 then
		PWarn:SetOpacity( .1 * PWopT )
		elseif FrameTime > PP9 and FrameTime < PP10 then
		PWarn:SetOpacity( 1 * PWopT )
		PWarn:SetVisible( false )
		PWarn:SetMouseVisible( false )
		PWarnFading = "0"
		elseif FrameTime > PP10 then
		PWarn:SetOpacity( 1 * PWopT )
		PWarn:SetVisible( false )
		PWarn:SetMouseVisible( false )
		PWarnFading = "0"
		end
	end
end

function PWarn:FlashOut()
		if FrameTime >= FPP0 and FrameTime < FPP1 then
		PWarn:SetOpacity( .9  * PWopT )
		elseif FrameTime > FPP1 and FrameTime < FPP2 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > FPP2 and FrameTime < FPP3 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > FPP3 and FrameTime < FPP4 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > FPP4 and FrameTime < FPP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > FPP5 and FrameTime < FPP6 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > FPP6 and FrameTime < FPP7 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > FPP7 and FrameTime < FPP8 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > FPP8 and FrameTime < FPP9 then
		PWarn:SetOpacity( .1 * PWopT )
		elseif FrameTime > FPP9 and FrameTime < FPP10 then
		PWarnFlashOut = "0"
		PWarn:FlashInStart()
		PWarn:SetOpacity( 0 * PWopT )
		elseif FrameTime > FPP10 then
		PWarnFlashOut = "0"
		PWarn:FlashInStart()
		PWarn:SetOpacity( 0 * PWopT )
		end
end

function PWarn:FlashIn()
		if FrameTime >= FPP0 and FrameTime < FPP1 then
		PWarn:SetOpacity( .1  * PWopT )
		elseif FrameTime > FPP1 and FrameTime < FPP2 then
		PWarn:SetOpacity( .2 * PWopT )
		elseif FrameTime > FPP2 and FrameTime < FPP3 then
		PWarn:SetOpacity( .3 * PWopT )
		elseif FrameTime > FPP3 and FrameTime < FPP4 then
		PWarn:SetOpacity( .4 * PWopT )
		elseif FrameTime > FPP4 and FrameTime < FPP5 then
		PWarn:SetOpacity( .5 * PWopT )
		elseif FrameTime > FPP5 and FrameTime < FPP6 then
		PWarn:SetOpacity( .6 * PWopT )
		elseif FrameTime > FPP6 and FrameTime < FPP7 then
		PWarn:SetOpacity( .7 * PWopT )
		elseif FrameTime > FPP7 and FrameTime < FPP8 then
		PWarn:SetOpacity( .8 * PWopT )
		elseif FrameTime > FPP8 and FrameTime < FPP9 then
		PWarn:SetOpacity( .9 * PWopT )
		elseif FrameTime > FPP9 and FrameTime < FPP10 then
		PWarnFlashIn = "0"
		PWarn:FlashOutStart()
		PWarn:SetOpacity( 1 * PWopT )
		elseif FrameTime > FPP10 then
		PWarnFlashIn = "0"
		PWarn:FlashOutStart()
		PWarn:SetOpacity( 1 * PWopT )
		end
end

function Primwin:FadeStart()
	AP0 = FrameTime
	AP1 = FrameTime + .05
	AP2 = FrameTime + .1
	AP3 = FrameTime + .15
	AP4 = FrameTime + .2
	AP5 = FrameTime + .25
	AP6 = FrameTime + .3
	AP7 = FrameTime + .35
	AP8 = FrameTime + .4
	AP9 = FrameTime + .45
	AP10 = FrameTime + .5
	AWarnFading = "1"
	Primwin:SetOpacity( 1 )
end

function Primwin:FadeOut()
	if Primwin:IsVisible() == true then
		if FrameTime >= AP0 and FrameTime < AP1 then
		Primwin:SetOpacity( .9 )
		MTWin:SetOpacity( .9 )
		PTWin:SetOpacity( .9 )
		PanicCD:SetOpacity( .9 )
		BubbleCD:SetOpacity( .9 )
		CorrCD:SetOpacity( .9 )
		IntCD:SetOpacity( .9 )
		C1CD:SetOpacity( .9 )
		C2CD:SetOpacity( .9 )
		MBarWin:SetOpacity( .9  * BopT )
		MeterWin:SetOpacity( .9  * MopT )
		PBarWin:SetOpacity( .9  * BopT )
		elseif FrameTime > AP1 and FrameTime < AP2 then
		Primwin:SetOpacity( .8 )
		PTWin:SetOpacity( .8 )
		MTWin:SetOpacity( .8 )
		PanicCD:SetOpacity( .8 )
		BubbleCD:SetOpacity( .8 )
		CorrCD:SetOpacity( .8 )
		IntCD:SetOpacity( .8 )
		C1CD:SetOpacity( .8 )
		C2CD:SetOpacity( .8 )
		MBarWin:SetOpacity( .8  * BopT )
		MeterWin:SetOpacity( .8  * MopT )
		PBarWin:SetOpacity( .8  * BopT )
		elseif FrameTime > AP2 and FrameTime < AP3 then
		Primwin:SetOpacity( .7 )
		PTWin:SetOpacity( .7 )
		MTWin:SetOpacity( .7 )
		PanicCD:SetOpacity( .7 )
		BubbleCD:SetOpacity( .7 )
		CorrCD:SetOpacity( .7 )
		IntCD:SetOpacity( .7 )
		C1CD:SetOpacity( .7 )
		C2CD:SetOpacity( .7 )
		MBarWin:SetOpacity( .7  * BopT )
		MeterWin:SetOpacity( .7  * MopT )
		PBarWin:SetOpacity( .7  * BopT )
		elseif FrameTime > AP3 and FrameTime < AP4 then
		Primwin:SetOpacity( .6 )
		PTWin:SetOpacity( .6 )
		MTWin:SetOpacity( .6 )
		PanicCD:SetOpacity( .6 )
		BubbleCD:SetOpacity( .6 )
		CorrCD:SetOpacity( .6 )
		IntCD:SetOpacity( .6 )
		C1CD:SetOpacity( .6 )
		C2CD:SetOpacity( .6 )
		MBarWin:SetOpacity( .6  * BopT )
		MeterWin:SetOpacity( .6  * MopT )
		PBarWin:SetOpacity( .6  * BopT )
		elseif FrameTime > AP4 and FrameTime < AP5 then
		Primwin:SetOpacity( .5 )
		PTWin:SetOpacity( .5 )
		MTWin:SetOpacity( .5 )
		PanicCD:SetOpacity( .5 )
		BubbleCD:SetOpacity( .5 )
		CorrCD:SetOpacity( .5 )
		IntCD:SetOpacity( .5 )
		C1CD:SetOpacity( .5 )
		C2CD:SetOpacity( .5 )
		MBarWin:SetOpacity( .5  * BopT )
		MeterWin:SetOpacity( .5  * MopT )
		PBarWin:SetOpacity( .5  * BopT )
		elseif FrameTime > AP5 and FrameTime < AP6 then
		Primwin:SetOpacity( .4 )
		PTWin:SetOpacity( .4 )
		MTWin:SetOpacity( .4 )
		PanicCD:SetOpacity( .4 )
		BubbleCD:SetOpacity( .4 )
		CorrCD:SetOpacity( .4 )
		IntCD:SetOpacity( .4 )
		C1CD:SetOpacity( .4 )
		C2CD:SetOpacity( .4 )
		MBarWin:SetOpacity( .4  * BopT )
		MeterWin:SetOpacity( .4  * MopT )
		PBarWin:SetOpacity( .4  * BopT )
		elseif FrameTime > AP6 and FrameTime < AP7 then
		Primwin:SetOpacity( .3 )
		PTWin:SetOpacity( .3 )
		MTWin:SetOpacity( .3 )
		PanicCD:SetOpacity( .3 )
		BubbleCD:SetOpacity( .3 )
		CorrCD:SetOpacity( .3 )
		IntCD:SetOpacity( .3 )
		C1CD:SetOpacity( .3 )
		C2CD:SetOpacity( .3 )
		MBarWin:SetOpacity( .3  * BopT )
		MeterWin:SetOpacity( .3  * MopT )
		PBarWin:SetOpacity( .3  * BopT )
		elseif FrameTime > AP7 and FrameTime < AP8 then
		Primwin:SetOpacity( .2 )
		PTWin:SetOpacity( .2 )
		MTWin:SetOpacity( .2 )
		PanicCD:SetOpacity( .2 )
		BubbleCD:SetOpacity( .2 )
		CorrCD:SetOpacity( .2 )
		IntCD:SetOpacity( .2 )
		C1CD:SetOpacity( .2 )
		C2CD:SetOpacity( .2 )
		MBarWin:SetOpacity( .2  * BopT )
		MeterWin:SetOpacity( .2  * MopT )
		PBarWin:SetOpacity( .2  * BopT )
		elseif FrameTime > AP8 and FrameTime < AP9 then
		Primwin:SetOpacity( .1 )
		PTWin:SetOpacity( .1 )
		MTWin:SetOpacity( .1 )
		PanicCD:SetOpacity( .1 )
		BubbleCD:SetOpacity( .1 )
		CorrCD:SetOpacity( .1 )
		IntCD:SetOpacity( .1 )
		C1CD:SetOpacity( .1 )
		C2CD:SetOpacity( .1 )
		MBarWin:SetOpacity( .1  * BopT )
		MeterWin:SetOpacity( .1  * MopT )
		PBarWin:SetOpacity( .1  * BopT )
		elseif FrameTime > AP9 and FrameTime < AP10 then
		Primwin:SetOpacity( 1 )
		PTWin:SetOpacity( 1 )
		MTWin:SetOpacity( 1 )
		PanicCD:SetOpacity( 1 )
		BubbleCD:SetOpacity( 1 )
		CorrCD:SetOpacity( 1 )
		IntCD:SetOpacity( 1 )
		C1CD:SetOpacity( 1 )
		C2CD:SetOpacity( 1 )
		MBarWin:SetOpacity( 1  * BopT )
		PBarWin:SetOpacity( 1  * BopT )
		MeterWin:SetOpacity( 1  * MopT )
		Primwin:SetVisible( false )
		Primwin:SetVisible( false )
		PanicCD:SetVisible( false )
		BubbleCD:SetVisible( false )
		CorrCD:SetVisible( false )
		IntCD:SetVisible( false )
		C1CD:SetVisible( false )
		C2CD:SetVisible( false )
		MBarWin:SetMouseVisible( false )
		MBarWin:SetVisible( false )
		PBarWin:SetMouseVisible( false )
		PBarWin:SetVisible( false )
		MBarRail:SetVisible( false )
		PBarRail:SetVisible( false )
		MTWin:SetVisible( false )
		MTWin:SetMouseVisible( false )
		PTWin:SetVisible( false )
		PTWin:SetMouseVisible( false )
		MeterWin:SetMouseVisible( false )
		MeterWin:SetVisible( false )
		MeterRail:SetVisible( false )
		AWarnFading = "0"
		elseif FrameTime > AP10 then
		Primwin:SetOpacity( 1 )
		PTWin:SetOpacity( 1 )
		MTWin:SetOpacity( 1 )
		PanicCD:SetOpacity( 1 )
		BubbleCD:SetOpacity( 1 )
		CorrCD:SetOpacity( 1 )
		IntCD:SetOpacity( 1 )
		C1CD:SetOpacity( 1 )
		C2CD:SetOpacity( 1 )
		MBarWin:SetOpacity( 1  * BopT )
		MeterWin:SetOpacity( 1  * MopT )
		PBarWin:SetOpacity( 1  * BopT )
		Primwin:SetVisible( false )
		PanicCD:SetVisible( false )
		BubbleCD:SetVisible( false )
		CorrCD:SetVisible( false )
		IntCD:SetVisible( false )
		C1CD:SetVisible( false )
		C2CD:SetVisible( false )
		MBarWin:SetMouseVisible( false )
		MBarWin:SetVisible( false )
		MBarRail:SetVisible( false )
		MeterWin:SetMouseVisible( false )
		MeterWin:SetVisible( false )
		MeterRail:SetVisible( false )
		PBarWin:SetMouseVisible( false )
		PBarWin:SetVisible( false )
		PBarRail:SetVisible( false )
		MTWin:SetVisible( false )
		MTWin:SetMouseVisible( false )
		PTWin:SetVisible( false )
		PTWin:SetMouseVisible( false )
		AWarnFading = "0"
		end
	end
end

function Turbine.Chat:Received( args )
	msg = args.Message
	if msg ~= nil then
		msg = string.gsub( msg, "-", "_" )
		if args.ChatType == Turbine.ChatType.EnemyCombat or args.ChatType == Turbine.ChatType.PlayerCombat or args.ChatType == Turbine.ChatType.EventCombat and msg ~= nil then
			if string.find( msg, string.gsub( Pantext:GetText(), "-", "_" ) ) ~= nil and PanCDing == "0" then
			PanicCD:SetBackground( "CajePlugins/HUDPlus/Resources/PanicCDWait.tga" )
			PanicCD:TimerStart()
			end
			if string.find( msg, string.gsub( Cortext:GetText(), "-", "_" ) ) ~= nil and CorrCDing == "0" then
			CorrCD:SetBackground( "CajePlugins/HUDPlus/Resources/CorruptionCDWait.tga" )
			CorrCD:TimerStart()
			end
			if string.find( msg, string.gsub( Bubtext:GetText(), "-", "_" ) ) ~= nil and BubCDing == "0" then
			BubbleCD:SetBackground( "CajePlugins/HUDPlus/Resources/BubbleCDWait.tga" )
			BubbleCD:TimerStart()
			end
			if string.find( msg, string.gsub( Inttext:GetText(), "-", "_" ) ) ~= nil and IntCDing == "0" then
			IntCD:SetBackground( "CajePlugins/HUDPlus/Resources/InterruptCDWait.tga" )
			IntCD:TimerStart()
			end
			if string.find( msg, string.gsub( C1text:GetText(), "-", "_" ) ) ~= nil and Cus1CDing == "0" then
			C1CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDWait.tga" )
			C1CD:TimerStart()
			end
			if string.find( msg, string.gsub( C2text:GetText(), "-", "_" ) ) ~= nil and Cus2CDing == "0" then
			C2CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDWait.tga" )
			C2CD:TimerStart()
			end
		end
	end
end

function MQSO:DragDrop()
	MShortcut = MQSO:GetShortcut()
	MItem = MShortcut:GetItem()
	if MItem:GetQuantity() ~= 1 then
	MSQty = MItem:GetQuantity()
	MLastPot = "0"
	HUDPlus:SaveFlags()
	end
end
function PQSO:DragDrop()
	PShortcut = PQSO:GetShortcut()
	PItem = PShortcut:GetItem()
	if PItem:GetQuantity() ~= 1 then
	PSQty = MItem:GetQuantity()
	PLastPot = "0"
	HUDPlus:SaveFlags()
	end
end
function PoQSO:DragDrop()
	PoShortcut = PoQSO:GetShortcut()
	PoItem = PoShortcut:GetItem()
	if PoItem:GetQuantity() ~= 1 then
	PoSQty = MItem:GetQuantity()
	PoLastPot = "0"
	HUDPlus:SaveFlags()
	end
end
function DQSO:DragDrop()
	DShortcut = DQSO:GetShortcut()
	DItem = DShortcut:GetItem()
	if DItem:GetQuantity() ~= 1 then
	DSQty = MItem:GetQuantity()
	DLastPot = "0"
	HUDPlus:SaveFlags()
	end
end
function WQSO:DragDrop()
	WShortcut = WQSO:GetShortcut()
	WItem = WShortcut:GetItem()
	if WItem:GetQuantity() ~= 1 then
	WSQty = MItem:GetQuantity()
	WLastPot = "0"
	HUDPlus:SaveFlags()
	end
end
function FQSO:DragDrop()
	FShortcut = FQSO:GetShortcut()
	FItem = FShortcut:GetItem()
	if FItem:GetQuantity() ~= 1 then
	FSQty = MItem:GetQuantity()
	FLastPot = "0"
	HUDPlus:SaveFlags()
	end
end

function Primwin:Update()
	if LOADED == "0" and loadwithman == "1" and QSLoadTime <= Turbine.Engine.GetLocalTime() then
		HUDPlus:LoadData()
		LOADED = "1"
	end
	if HUDVis == "1" then
	Primwin:SetOpacity( 1 )
	PanicCD:SetOpacity( 1 )
	BubbleCD:SetOpacity( 1 )
	CorrCD:SetOpacity( 1 )
	IntCD:SetOpacity( 1 )
	C1CD:SetOpacity( 1 )
	C2CD:SetOpacity( 1 )
	MBarWin:SetOpacity( BopT )
	PBarWin:SetOpacity( BopT )
	MBarRail:SetOpacity( BopT )
	PBarRail:SetOpacity( BopT )
	MeterWin:SetOpacity( MopT )
	MeterRail:SetOpacity( MopT )
	MWarn:SetOpacity( MWopT )
	PWarn:SetOpacity( MWopT )
	DHitWarn:SetOpacity( DHopT )
	SwindowMaster:SetOpacity( 1 )
	PTWin:SetOpacity( 1 )
	MTWin:SetOpacity( 1 )
	TTWin:SetOpacity( 1 )
	MQS:SetVisible( true )
	PQS:SetVisible( true )
	WQS:SetVisible( true )
	PoQS:SetVisible( true )
	FQS:SetVisible( true )
	DQS:SetVisible( true )
	MQSG:SetVisible( true )
	PQSG:SetVisible( true )
	WQSG:SetVisible( true )
	PoQSG:SetVisible( true )
	FQSG:SetVisible( true )
	DQSG:SetVisible( true )
	Colorwindow:SetOpacity( 1 )
	MWindow:SetOpacity( 1 )
	PWindow:SetOpacity( 1 )
	MTWindow:SetOpacity( 1 )
	PTWindow:SetOpacity( 1 )
	TWindow:SetOpacity( 1 )
	end
	LocTime = Turbine.Engine.GetLocalTime()
	FrameTime = Turbine.Engine.GetGameTime()
	MBar:ScanMorale()
	PBar:ScanPower()
	if MFull == "1" and PFull == "1" then
	Vit100 = "1"
	else Vit100 = "0"
	end
	MQSG:ScanMorale()
	PQSG:ScanPower()
	MRealLabel:ScanMorale()
	PRealLabel:ScanPower()
	Primwin:ScanEffects()
	DHitWarn:ScanMorale()

	if DHitWarnFading == "1" then
	DHitWarn:FadeOut()
	end
	if MWarnFading == "1" then
	MWarn:FadeOut()
	end
	if PWarnFading == "1" then
	PWarn:FadeOut()
	end
	if AWarnFading == "1" then
	Primwin:FadeOut()
	end
	if MWarnFlashOut == "1" then
	MWarn:FlashOut()
	end
	if MWarnFlashIn == "1" then
	MWarn:FlashIn()
	end
	if PWarnFlashOut == "1" then
	PWarn:FlashOut()
	end
	if PWarnFlashIn == "1" then
	PWarn:FlashIn()
	end
	if IndOnly == "1" then
	MQSG2:SetMouseVisible( true )
	MQL:SetVisible( false )
	PQSG2:SetMouseVisible( true )
	PQL:SetVisible( false )
	WQSG2:SetMouseVisible( true )
	WQL:SetVisible( false )
	DQSG2:SetMouseVisible( true )
	DQL:SetVisible( false )
	FQSG2:SetMouseVisible( true )
	FQL:SetVisible( false )
	PoQSG2:SetMouseVisible( true )
	PoQL:SetVisible( false )
	elseif IndOnly == "0" then
	MQSG2:SetMouseVisible( false )
	MQL:SetVisible( true )
	PQSG2:SetMouseVisible( false )
	PQL:SetVisible( true )
	WQSG2:SetMouseVisible( false )
	WQL:SetVisible( true )
	DQSG2:SetMouseVisible( false )
	DQL:SetVisible( true )
	FQSG2:SetMouseVisible( false )
	FQL:SetVisible( true )
	PoQSG2:SetMouseVisible( false )
	PoQL:SetVisible( true )
	end
	if Optoverride == "1" then
		Primwin:SetVisible( true )
		if quickslots == "1" then
		MQSG:SetVisible( true )
		MQSG:SetMouseVisible( true )
		MQS:SetVisible( false )
		PQSG:SetVisible( true )
		PQSG:SetMouseVisible( true )
		PQS:SetVisible( false )
		DQSG:SetVisible( true )
		DQSG:SetMouseVisible( true )
		DQS:SetVisible( false )
		WQSG:SetVisible( true )
		WQSG:SetMouseVisible( true )
		WQS:SetVisible( false )
		PoQSG:SetVisible( true )
		PoQSG:SetMouseVisible( true )
		PoQS:SetVisible( false )
		FQSG:SetVisible( true )
		FQSG:SetMouseVisible( true )
		FQS:SetVisible( false )
		end
		if Bars == "1" then
		MBar:SetVisible( true )
		MBarWin:SetVisible( true )
		MBarWin:SetMouseVisible( true )
		PBarWin:SetVisible( true )
		PBarWin:SetMouseVisible( true )
		PBar:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "1" then
		MeterBar:SetVisible( true )
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		MeterWin:SetMouseVisible( true )
		end
		if Moralewarn == "1" then
		MWarn:SetVisible( true )
		MWarn:SetOpacity( MWopT )
		MWarn:SetMouseVisible( true )
		end
		if Powerwarn == "1" then
		PWarn:SetVisible( true )
		PWarn:SetOpacity( PWopT )
		PWarn:SetMouseVisible( true )
		end
		if DHitWarning == "1" then
		DHitWarn:SetVisible( true )
		DHitWarn:SetOpacity( DHopT )
		DHitWarn:SetMouseVisible( true )
		end
		if InterruptCD == "1" then
		IntCD:SetVisible( true )
		IntCD:SetMouseVisible( true )
		end
		if CorruptionCD == "1" then
		CorrCD:SetVisible( true )
		CorrCD:SetMouseVisible( true )
		end
		if PanCD == "1" then
		PanicCD:SetVisible( true )
		PanicCD:SetMouseVisible( true )
		end
		if BubCD == "1" then
		BubbleCD:SetVisible( true )
		BubbleCD:SetMouseVisible( true )
		end
		if Cus1CD == "1" then
		C1CD:SetVisible( true )
		C1CD:SetMouseVisible( true )
		end
		if Cus2CD == "1" then
		C2CD:SetVisible( true )
		C2CD:SetMouseVisible( true )
		end
		if Text == "1" then
		MTWin:SetVisible( true )
		MTWin:SetMouseVisible( true )
		PTWin:SetVisible( true )
		PTWin:SetMouseVisible( true )
		TTWin:SetVisible( true )
		TTWin:SetMouseVisible( true )
		end
	end

	MShortcut = MQSO:GetShortcut()
	MSType = MShortcut:GetType()
	MSData = MShortcut:GetData()
	MSItem = MShortcut:GetItem()

	PShortcut = PQSO:GetShortcut()
	PSType = PShortcut:GetType()
	PSData = PShortcut:GetData()
	PSItem = PShortcut:GetItem()

	DShortcut = DQSO:GetShortcut()
	DSType = DShortcut:GetType()
	DSData = DShortcut:GetData()
	DSItem = DShortcut:GetItem()

	FShortcut = FQSO:GetShortcut()
	FSType = FShortcut:GetType()
	FSData = FShortcut:GetData()
	FSItem = FShortcut:GetItem()

	WShortcut = WQSO:GetShortcut()
	WSType = WShortcut:GetType()
	WSData = WShortcut:GetData()
	WSItem = WShortcut:GetItem()

	PoShortcut = PoQSO:GetShortcut()
	PoSType = PoShortcut:GetType()
	PoSData = PoShortcut:GetData()
	PoSItem = PoShortcut:GetItem()
	
	if WSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
			WShortcut = WQSO:GetShortcut()
			WSType = WShortcut:GetType()
			WSData = WShortcut:GetData()
			if WSQty == 1 then
				WLastPot = "1"
				HUDPlus:SaveFlags()
			end
			if WSData ~= "" and WLastPot ~= "1" then
				WSItem = WShortcut:GetItem()
				WSQty = WSItem:GetQuantity()
				WQL:SetText( WSQty )
			end
		end
	end
	if DSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
		DShortcut = DQSO:GetShortcut()
		DSType = DShortcut:GetType()
		DSData = DShortcut:GetData()
			if DSQty == 1 then
				DLastPot = "1"
				HUDPlus:SaveFlags()
			end
		if DSData ~= "" and DLastPot ~= "1" then
		DSItem = DShortcut:GetItem()
		DSQty = DSItem:GetQuantity()
		DQL:SetText( DSQty )
		end
		end
	end
	if FSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
		FShortcut = FQSO:GetShortcut()
		FSType = FShortcut:GetType()
		FSData = FShortcut:GetData()
			if FSQty == 1 then
				FLastPot = "1"
				HUDPlus:SaveFlags()
			end
		if FSData ~= "" and FLastPot ~= "1" then
		FSItem = FShortcut:GetItem()
		FSQty = FSItem:GetQuantity()
		FQL:SetText( FSQty )
		end
		end
	end
	if PoSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
		PoShortcut = PoQSO:GetShortcut()
		PoSType = PoShortcut:GetType()
		PoSData = PoShortcut:GetData()
			if PoSQty == 1 then
				PoLastPot = "1"
				HUDPlus:SaveFlags()
			end
		if PoSData ~= "" and PoLastPot ~= "1" then
		PoSItem = PoShortcut:GetItem()
		PoSQty = PoSItem:GetQuantity()
		PoQL:SetText( PoSQty )
		end
		end
	end
	if PSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
			PShortcut = PQSO:GetShortcut()
			PSType = PShortcut:GetType()
			PSData = PShortcut:GetData()
			if PSQty == 1 then
				PLastPot = "1"
				HUDPlus:SaveFlags()
			end
			if PSData ~= "" and PLastPot ~= "1" then
				PSItem = PShortcut:GetItem()
				PSQty = PSItem:GetQuantity()
				PQL:SetText( PSQty )
			end
		end
	end
	if MSType == Turbine.UI.Lotro.ShortcutType.Item then
		if LOADED == "1" or loadwithman == "0" then
			MShortcut = MQSO:GetShortcut()
			MSType = MShortcut:GetType()
			MSData = MShortcut:GetData()
			if MSQty == 1 then
				MLastPot = "1"
				HUDPlus:SaveFlags()
			end
			if MSData ~= "" and MLastPot == "0" then
				MSItem = MShortcut:GetItem()
				MSQty = MSItem:GetQuantity()
				MQL:SetText( MSQty )
			end
		end
	end

	if FrameTime >= PanRdytime and PanCDing == "1" then
		PanicCD:SetBackground( "CajePlugins/HUDPlus/Resources/PanicCDRdy.tga" )
		PanRdytime = 0
		PanCDing = "0" 
	end
	if FrameTime >= BubRdytime and BubCDing == "1" then
		BubbleCD:SetBackground( "CajePlugins/HUDPlus/Resources/BubbleCDRdy.tga" )
		BubRdytime = 0
		BubCDing = "0" 
	end
	if FrameTime >= CorrRdytime and CorrCDing == "1" then
		CorrCD:SetBackground( "CajePlugins/HUDPlus/Resources/CorruptionCDRdy.tga" )
		CorrRdytime = 0
		CorrCDing = "0" 
	end
	if FrameTime >= IntRdytime and IntCDing == "1" then
		IntCD:SetBackground( "CajePlugins/HUDPlus/Resources/InterruptCDRdy.tga" )
		IntRdytime = 0
		IntCDing = "0" 
	end
	if FrameTime >= C1Rdytime and Cus1CDing == "1" then
		C1CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )
		C1Rdytime = 0
		Cus1CDing = "0" 
	end
	if FrameTime >= C2Rdytime and Cus2CDing == "1" then
		C2CD:SetBackground( "CajePlugins/HUDPlus/Resources/CustomCDRdy.tga" )
		C2Rdytime = 0
		Cus2CDing = "0" 
	end

	if OOCcrit == "Out of Combat" then
		if Player:IsInCombat() == true then
		Primwin:SetVisible( true )
		if Bars == "1" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "1" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "1" then
		MTWin:SetVisible( true )
		PTWin:SetVisible( true )
		end
		if InterruptCD == "1" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "1" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "1" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "1" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "1" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "1" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and Primwin:IsVisible() == true and AWarnFading == "0" and Optoverride ~= "1" then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "Vitals 100%" then
		if Player:IsInCombat() == true or Vit100 == "0" then
		Primwin:SetVisible( true )
		if Bars == "1" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "1" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "1" then
		MTWin:SetVisible( true )
		PTWin:SetVisible( true )
		end
		if InterruptCD == "1" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "1" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "1" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "1" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "1" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "1" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and Vit100 == "1" and Primwin:IsVisible() == true and AWarnFading == "0" and Optoverride ~= "1" then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "100% Morale" then
		if Player:IsInCombat() == true or MFull == "0" then
		if Bars == "1" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "1" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "1" then
		MTWin:SetVisible( true )
		PTWin:SetVisilbe( true )
		end
		if InterruptCD == "1" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "1" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "1" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "1" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "1" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "1" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and MFull == "1" and Primwin:IsVisible() == true and AWarnFading == "0" and Optoverride ~= "1" then
		Primwin:FadeStart()
		end
	elseif OOCcrit == "100% Power" then
		if Player:IsInCombat() == true or PFull == "0" then
		if Bars == "1" then
		MBarWin:SetVisible( true )
		MBarRail:SetVisible( true )
		PBarWin:SetVisible( true )
		PBarRail:SetVisible( true )
		end
		if Meter == "1" then
		MeterWin:SetVisible( true )
		MeterRail:SetVisible( true )
		end
		if Text == "1" then
		MTWin:SetVisible( true )
		PTWin:SetVisilbe( true )
		end
		if InterruptCD == "1" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "1" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "1" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "1" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "1" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "1" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		elseif Player:IsInCombat() == false and PFull == "1" and Primwin:IsVisible() == true and AWarnFading == "0" and Optoverride ~= "1" then
		Primwin:FadeStart()
		end
	end

	if PlayerClass == Turbine.Gameplay.Class.Champion then
	MeterWin:ScanFervour()
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter then
	MeterWin:ScanFocus()
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper then
	MeterWin:ScanAttunement()
	else MeterWin:SetVisible( false )
	MeterRail:SetVisible( false )
	end
	
	--Drag sequences

	if MWarn.Dragging == "1" then
	MWarn:Drag()
	end
	if PWarn.Dragging == "1" then
	PWarn:Drag()
	end
	if DHitWarn.Dragging == "1" then
	DHitWarn:Drag()
	end
	if PanicCD.Dragging == "1" then
	PanicCD:Drag()
	end
	if BubbleCD.Dragging == "1" then
	BubbleCD:Drag()
	end
	if CorrCD.Dragging == "1" then
	CorrCD:Drag()
	end
	if IntCD.Dragging == "1" then
	IntCD:Drag()
	end
	if C1CD.Dragging == "1" then
	C1CD:Drag()
	end
	if C2CD.Dragging == "1" then
	C2CD:Drag()
	end
	if MQSG.Dragging == "1" then
	MQSG:Drag()
	end
	if PQSG.Dragging == "1" then
	PQSG:Drag()
	end
	if PoQSG.Dragging == "1" then
	PoQSG:Drag()
	end
	if FQSG.Dragging == "1" then
	FQSG:Drag()
	end
	if WQSG.Dragging == "1" then
	WQSG:Drag()
	end
	if DQSG.Dragging == "1" then
	DQSG:Drag()
	end
	if MBarWin.Dragging == "1" then
	MBarWin:Drag()
	MBarRail:SetLeft( MBarWin:GetLeft() )
	MBarRail:SetTop( MBarWin:GetTop() )
	end
	if PBarWin.Dragging == "1" then
	PBarWin:Drag()
	PBarRail:SetLeft( PBarWin:GetLeft() )
	PBarRail:SetTop( PBarWin:GetTop() )
	end
	if MTWin.Dragging == "1" then
	MTWin:Drag()
	end
	if PTWin.Dragging == "1" then
	PTWin:Drag()
	end
	if TTWin.Dragging == "1" then
	TTWin:Drag()
	end
	if MeterWin.Dragging == "1" then
	MeterWin:Drag()
	MeterRail:SetLeft( MeterWin:GetLeft() )
	MeterRail:SetTop( MeterWin:GetTop() )
	end

	if FrameTime <= Fadetime and LFading == "1" then
		Primwin:SetVisible( true )
		Primwin:SetOpacity( 1 )
		if quickslots == "1" then
			MQS:SetVisible( true )
			PQS:SetVisible( true )
			DQS:SetVisible( true )
			WQS:SetVisible( true )
			PoQS:SetVisible( true )
			FQS:SetVisible( true )
			MQSG:SetVisible( true )
			PQSG:SetVisible( true )
			DQSG:SetVisible( true )
			WQSG:SetVisible( true )
			PoQSG:SetVisible( true )
			FQSG:SetVisible( true )
		end
		if Bars == "1" then
			MBar:SetVisible( true )
			MBarWin:SetVisible( true )
			PBarWin:SetVisible( true )
			PBar:SetVisible( true )
			MBarRail:SetVisible( true )
			PBarRail:SetVisible( true )
			MBarWin:SetOpacity( BopT )
			MBarRail:SetOpacity( BopT )
			PBarWin:SetOpacity( BopT )
			PBarWin:SetOpacity( BopT )
		end
		if Meter == "1" then
			MeterBar:SetVisible( true )
			MeterWin:SetVisible( true )
			MeterRail:SetVisible( true )
			MeterWin:SetOpacity( MopT )
			MeterRail:SetOpacity( MopT )
		end
		if Moralewarn == "1" then
			MWarn:SetVisible( true )
			MWarn:SetOpacity( MWopT )
		end
		if Powerwarn == "1" then
			PWarn:SetVisible( true )
			PWarn:SetOpacity( PWopT )
		end
		if DHitWarning == "1" then
			DHitWarn:SetVisible( true )
			DHitWarn:SetOpacity( DHopT )
		end
		if InterruptCD == "1" then
			IntCD:SetVisible( true )
			IntCD:SetOpacity( 1 )
		end
		if CorruptionCD == "1" then
			CorrCD:SetVisible( true )
			CorrCD:SetOpacity( 1 )
		end
		if PanCD == "1" then
			PanicCD:SetVisible( true )
			PanicCD:SetOpacity( 1 )
		end
		if BubCD == "1" then
			BubbleCD:SetVisible( true )
			BubbleCD:SetOpacity( 1 )
		end
		if Cus1CD == "1" then
			C1CD:SetVisible( true )
			C1CD:SetOpacity( 1 )
		end
		if Cus2CD == "1" then
			C2CD:SetVisible( true )
			C2CD:SetOpacity( 1 )
		end
		if Text == "1" then
			MTWin:SetVisible( true )
			MTWin:SetOpacity( 1 )
			PTWin:SetVisible( true )
			PTWin:SetOpacity( 1 )
		end
	elseif FrameTime >= Fadetime and LFading == "1" then
			Primwin:FadeStart()
			LFading = "0"
			DHitWarn:FadeStart()
	end	
	if HUDVis == "0" then
	Primwin:SetOpacity( 0 )
	PanicCD:SetOpacity( 0 )
	BubbleCD:SetOpacity( 0 )
	CorrCD:SetOpacity( 0 )
	IntCD:SetOpacity( 0 )
	C1CD:SetOpacity( 0 )
	C2CD:SetOpacity( 0 )
	MBarWin:SetOpacity( 0 )
	PBarWin:SetOpacity( 0 )
	MBarRail:SetOpacity( 0 )
	PBarRail:SetOpacity( 0 )
	MeterWin:SetOpacity( 0 )
	MeterRail:SetOpacity( 0 )
	MWarn:SetOpacity( 0 )
	PWarn:SetOpacity( 0 )
	DHitWarn:SetOpacity( 0 )
	SwindowMaster:SetOpacity( 0 )
	MTWin:SetOpacity( 0 )
	TTWin:SetOpacity( 0 )
	PTWin:SetOpacity( 0 )
	MQS:SetVisible( false )
	PQS:SetVisible( false )
	WQS:SetVisible( false )
	PoQS:SetVisible( false )
	FQS:SetVisible( false )
	DQS:SetVisible( false )
	MQSG:SetVisible( false )
	PQSG:SetVisible( false )
	WQSG:SetVisible( false )
	PoQSG:SetVisible( false )
	FQSG:SetVisible( false )
	DQSG:SetVisible( false )
	Colorwindow:SetOpacity( 0 )
	MWindow:SetOpacity( 0 )
	PWindow:SetOpacity( 0 )
	PTWindow:SetOpacity( 0 )
	MTWindow:SetOpacity( 0 )
	TWindow:SetOpacity( 0 )
	end
end


function Primwin:KeyDown(args)
	if args.Action == 268435635 and HUDVis == "0" then
	HUDVis = "1"
	elseif args.Action == 268435635 and HUDVis == "1" then
	HUDVis = "0"
	end

	if args.Action == 268435579 and Optoverride == "0" then
	Optoverride = "1"
	elseif args.Action == 268435579 and Optoverride == "1" then
	Optoverride = "0"
	DHitWarn:FadeOut()
	end
end

import "CajePlugins.HUDPlus.OptionsMain"