SwindowMaster = Turbine.UI.Lotro.Window(); --main
SwindowMaster:SetSize( 550, 600 );
SwindowMaster:SetPosition( 100, 100 );
SwindowMaster:SetVisible( false );
SwindowMaster:SetMouseVisible( true );
SwindowMaster:SetText( "HUD Options" );
SwindowMaster:SetZOrder( 10 )

Swindowcontainer = Turbine.UI.Control(); --container
Swindowcontainer:SetParent( SwindowMaster );
Swindowcontainer:SetPosition( 0, 100 );
Swindowcontainer:SetMouseVisible( false );
Swindowcontainer:SetSize( 520, 450 );
Swindowcontainer:SetVisible( true );

Swindow = Turbine.UI.Control(); --slave
Swindow:SetParent( Swindowcontainer );
Swindow:SetVisible( true );
Swindow:SetSize( 520, 950 );
Swindow:SetPosition( 0, 0 );
Swindow:SetMouseVisible( false );

WindowScroll = class( Turbine.UI.Lotro.ScrollBar );
function WindowScroll:Constructor()
	Turbine.UI.Lotro.ScrollBar.Constructor( self )
	self:SetVisible( true )
	self:SetParent( SwindowMaster )
	self:SetSize( 10, 520 )
	self:SetOrientation( Turbine.UI.Orientation.Vertical )
end

Checkbox = class( Turbine.UI.Lotro.CheckBox );
function Checkbox:Constructor()
	Turbine.UI.Lotro.CheckBox.Constructor( self )
	self:SetSize( 90, 40 )
	self:SetEnabled( true )
	self:SetZOrder( -2 )
	self:SetVisible( true );
	self:SetParent( Swindow );
end

SettingsScroll = class( Turbine.UI.Lotro.ScrollBar );
function SettingsScroll:Constructor()
	Turbine.UI.Lotro.ScrollBar.Constructor( self )
	self:SetVisible( true )
	self:SetParent( Swindow )
	self:SetSize( 300, 10 )
	self:SetOrientation( Turbine.UI.Orientation.Horizontal )
end

ScrollLabel = class( Turbine.UI.Label );
function ScrollLabel:Constructor()
	Turbine.UI.Label.Constructor( self )
	self:SetVisible( true )
	self:SetParent( Swindow )
	self:SetSize( 200, 10 )
	self:SetMouseVisible( false )
end

Quickslot = class( Turbine.UI.Lotro.Quickslot );
function Quickslot:Constructor()
	Turbine.UI.Lotro.Quickslot.Constructor( self )
	self:SetSize( 30, 30 )
	self:SetParent( Swindow )
	self:SetVisible( true )
	self:SetMouseVisible( true )
end

Textbox = class( Turbine.UI.Lotro.TextBox );
function Textbox:Constructor()
	Turbine.UI.Lotro.TextBox.Constructor( self )
	self:SetVisible( true )
	self:SetZOrder( -1 )
	self:SetParent( Swindow )
	self:SetSize( 180, 30 )
end

Dropdownlabel = class( Turbine.UI.Label );
function Dropdownlabel:Constructor()
	Turbine.UI.Label.Constructor( self )
	self:SetVisible( false )
	self:SetZOrder( 1 )
	self:SetParent( Swindow )
	self:SetSize( 100, 20 )
	self:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
	self:SetFontStyle( Turbine.UI.FontStyle.None )
	self:SetMouseVisible( false )
	self:SetZOrder( 11 )
end

Scrollbar = WindowScroll();
Scrollbar:SetValue( 0 );
Scrollbar:SetPosition( 525, 40 );
Scrollbar:SetMaximum( 100 );

function Scrollbar:ValueChanged()
	Curval = Scrollbar:GetValue()
	Scrollpos = Swindow:GetTop()
	Swindow:SetTop( ( Curval ) * -5 )
end

Barcheck = Checkbox();
Barcheck:SetPosition( 20, 20 );
Barcheck:SetText( "Enable Bars" );


BOS = SettingsScroll();
BOS:SetPosition( 100, 20 );
BOS:SetMaximum( 100 );
BOS:SetMinimum( 0 );
BOS:SetSmallChange( 1 );
BOS:SetLargeChange( 10 );

BOSLabel = Turbine.UI.Label();
BOSLabel:SetParent( Swindow );
BOSLabel:SetSize( 250, 30 );
BOSLabel:SetMouseVisible( false );
BOSLabel:SetPosition( 398, 20 );

Colorbutton = Turbine.UI.Lotro.Button();
Colorbutton:SetSize( 80, 30 );
Colorbutton:SetText( "Color" );
Colorbutton:SetVisible( true );
Colorbutton:SetParent( Swindow );
Colorbutton:SetPosition( 100, 40 );
Colorbutton.MouseClick = function()
	if Colorwindow:IsVisible() == false then
	Colorwindow:SetVisible( true )
	elseif Colorwindow:IsVisible() == true then
	Colorwindow:SetVisible( false )
	end
end

Textcheck = Checkbox();
Textcheck:SetPosition( 200, 30 );
Textcheck:SetText( "Numbers Display" );

MWarncheck = Checkbox();
MWarncheck:SetPosition( 20, 80 );
MWarncheck:SetText( "Enable Morale Warning" );

LowScroll = SettingsScroll();
LowScroll:SetPosition( 100, 80 );
LowScroll:SetMaximum( 100 );
LowScroll:SetMinimum( 0 );
LowScroll:SetSmallChange( 1 );
LowScroll:SetLargeChange( 10 );

CriticalScroll = SettingsScroll();
CriticalScroll:SetPosition( 100, 100 );
CriticalScroll:SetMaximum( LowScroll:GetValue() );
CriticalScroll:SetMinimum( 0 );
CriticalScroll:SetSmallChange( 1 );
CriticalScroll:SetLargeChange( 10 );

LowScrollLabel = ScrollLabel()
LowScrollLabel:SetPosition( 398, 80 );
LowScrollLabel:SetSize( 250, 10 );

CriticalScrollLabel = ScrollLabel()
CriticalScrollLabel:SetPosition( 398, 100 );
CriticalScrollLabel:SetSize( 250, 10 );

MWOS = SettingsScroll();
MWOS:SetPosition( 100, 120 );
MWOS:SetMaximum( 100 );
MWOS:SetMinimum( 0 );
MWOS:SetSmallChange( 1 );
MWOS:SetLargeChange( 10 );

MWOSLabel = Turbine.UI.Label();
MWOSLabel:SetParent( Swindow );
MWOSLabel:SetSize( 250, 30 );
MWOSLabel:SetMouseVisible( false );
MWOSLabel:SetPosition( 398, 120 );

PWarncheck = Checkbox();
PWarncheck:SetPosition( 20, 160 );
PWarncheck:SetText( "Enable Power Warning" );

PLowScroll = SettingsScroll();
PLowScroll:SetPosition( 100, 160 );
PLowScroll:SetMaximum( 100 );
PLowScroll:SetMinimum( 0 );
PLowScroll:SetSmallChange( 1 );
PLowScroll:SetLargeChange( 10 );

PCriticalScroll = SettingsScroll();
PCriticalScroll:SetPosition( 100, 180 );
PCriticalScroll:SetMaximum( LowScroll:GetValue() );
PCriticalScroll:SetMinimum( 0 );
PCriticalScroll:SetSmallChange( 1 );
PCriticalScroll:SetLargeChange( 10 );

PLowScrollLabel = ScrollLabel()
PLowScrollLabel:SetPosition( 398, 160 );
PLowScrollLabel:SetSize( 250, 10 );

PCriticalScrollLabel = ScrollLabel()
PCriticalScrollLabel:SetPosition( 398, 180 );
PCriticalScrollLabel:SetSize( 250, 10 );

PWOS = SettingsScroll();
PWOS:SetPosition( 100, 200 );
PWOS:SetMaximum( 100 );
PWOS:SetMinimum( 0 );
PWOS:SetSmallChange( 1 );
PWOS:SetLargeChange( 10 );

PWOSLabel = Turbine.UI.Label();
PWOSLabel:SetParent( Swindow );
PWOSLabel:SetSize( 250, 30 );
PWOSLabel:SetMouseVisible( false );
PWOSLabel:SetPosition( 398, 200 );

DHitWarncheck = Checkbox();
DHitWarncheck:SetPosition( 20, 240 );
DHitWarncheck:SetText( "Enable Dev. Hit Warning" );

DHitScroll = SettingsScroll();
DHitScroll:SetPosition( 100, 240 );
DHitScroll:SetMaximum( 25000 );
DHitScroll:SetMinimum( 1 );
DHitScroll:SetSmallChange( 1 );
DHitScroll:SetLargeChange( 100 );

DHitScrollLabel = ScrollLabel()
DHitScrollLabel:SetPosition( 398, 240 );
DHitScrollLabel:SetSize( 250, 10 );

DHOS = SettingsScroll();
DHOS:SetPosition( 100, 260 );
DHOS:SetMaximum( 100 );
DHOS:SetMinimum( 0 );
DHOS:SetSmallChange( 1 );
DHOS:SetLargeChange( 10 );

DHOSLabel = Turbine.UI.Label();
DHOSLabel:SetParent( Swindow );
DHOSLabel:SetSize( 250, 30 );
DHOSLabel:SetMouseVisible( false );
DHOSLabel:SetPosition( 398, 260 );

QScheck = Checkbox();
QScheck:SetPosition( 15, 320 );
QScheck:SetText( "Enable Quickslots" );

MQSO = Quickslot();
MQSO:SetPosition( 100, 300 );
MQSO:SetBackColor( mgreen )

PQSO = Quickslot();
PQSO:SetPosition( 140, 300 );
PQSO:SetBackColor( pblue );

DQSO = Quickslot();
DQSO:SetPosition( 180, 300 );
DQSO:SetBackColor( yellow );

FQSO = Quickslot();
FQSO:SetPosition( 100, 340 );
FQSO:SetBackColor( purple );

WQSO = Quickslot();
WQSO:SetPosition( 140, 340 );
WQSO:SetBackColor( red );

PoQSO = Quickslot();
PoQSO:SetPosition( 180, 340 );
PoQSO:SetBackColor( green );

Quickslotlabel = Turbine.UI.Label();
Quickslotlabel:SetParent( Swindow );
Quickslotlabel:SetSize( 70, 30 );
Quickslotlabel:SetMouseVisible( false );
Quickslotlabel:SetText( "Condition Reactions" );
Quickslotlabel:SetPosition( 2200, 320 );

IndOnlycheck = Checkbox();
IndOnlycheck:SetPosition( 250, 310 );
IndOnlycheck:SetText( "Indicator Only Mode" );

PanCDcheck = Checkbox();
PanCDcheck:SetPosition( 20, 400 );
PanCDcheck:SetText( "Panic Cooldown" );

Pantext = Textbox();
Pantext:SetPosition( 100, 400 );
Pantext:SetVisible( true );

PanScroll = SettingsScroll();
PanScroll:SetPosition( 290, 410 );
PanScroll:SetWidth( 200 );
PanScroll:SetMaximum( 3600 );
PanScroll:SetMinimum( 0 );
PanScroll:SetSmallChange( 1 );
PanScroll:SetLargeChange( 100 );

PSL = ScrollLabel();
PSL:SetPosition( 490, 410 );
PSL:SetParent( Swindow );

BubCDcheck = Checkbox();
BubCDcheck:SetPosition( 20, 460 );
BubCDcheck:SetText( "Bubble Cooldown" );

Bubtext = Textbox();
Bubtext:SetPosition( 100, 460 );
Bubtext:SetVisible( true );

BubScroll = SettingsScroll();
BubScroll:SetPosition( 290, 470 );
BubScroll:SetWidth( 200 );
BubScroll:SetMaximum( 3600 );
BubScroll:SetMinimum( 0 );
BubScroll:SetSmallChange( 1 );
BubScroll:SetLargeChange( 100 );

BSL = ScrollLabel();
BSL:SetPosition( 490, 470 );
BSL:SetParent( Swindow );

InterruptCDcheck = Checkbox();
InterruptCDcheck:SetPosition( 20, 520 );
InterruptCDcheck:SetText( "Interrupt Cooldown" );

Inttext = Textbox();
Inttext:SetPosition( 100, 520 );
Inttext:SetVisible( true );

IntScroll = SettingsScroll();
IntScroll:SetPosition( 290, 530 );
IntScroll:SetWidth( 200 );
IntScroll:SetMaximum( 3600 );
IntScroll:SetMinimum( 0 );
IntScroll:SetSmallChange( 1 );
IntScroll:SetLargeChange( 100 );

ISL = ScrollLabel();
ISL:SetPosition( 490, 530 );
ISL:SetParent( Swindow );

CorruptionCDcheck = Checkbox();
CorruptionCDcheck:SetPosition( 15, 580 );
CorruptionCDcheck:SetText( "Corruption Cooldown" );

Cortext = Textbox();
Cortext:SetPosition( 100, 580 );
Cortext:SetVisible( true );

CorScroll = SettingsScroll();
CorScroll:SetPosition( 290, 590 );
CorScroll:SetWidth( 200 );
CorScroll:SetMaximum( 3600 );
CorScroll:SetMinimum( 0 );
CorScroll:SetSmallChange( 1 );
CorScroll:SetLargeChange( 100 );

CSL = ScrollLabel();
CSL:SetPosition( 490, 590 );
CSL:SetParent( Swindow );

C1check = Checkbox();
C1check:SetPosition( 20, 640 );
C1check:SetText( "Enable Custom 1" );

C1text = Textbox();
C1text:SetPosition( 100, 640 );
C1text:SetVisible( true );

C1Scroll = SettingsScroll();
C1Scroll:SetPosition( 290, 650 );
C1Scroll:SetWidth( 200 );
C1Scroll:SetMaximum( 3600 );
C1Scroll:SetMinimum( 0 );
C1Scroll:SetSmallChange( 1 );
C1Scroll:SetLargeChange( 10 );

C1SL = ScrollLabel();
C1SL:SetPosition( 490, 650 );
C1SL:SetParent( Swindow );

C2check = Checkbox();
C2check:SetPosition( 20, 700 );
C2check:SetText( "Enable Custom 2" );

C2text = Textbox();
C2text:SetPosition( 100, 700 );
C2text:SetVisible( true );

C2Scroll = SettingsScroll();
C2Scroll:SetPosition( 290, 710 );
C2Scroll:SetWidth( 200 );
C2Scroll:SetMaximum( 3600 );
C2Scroll:SetMinimum( 0 );
C2Scroll:SetSmallChange( 1 );
C2Scroll:SetLargeChange( 10 );

C2SL = ScrollLabel();
C2SL:SetPosition( 490, 710 );
C2SL:SetParent( Swindow );

MeterCheck = Checkbox();
MeterCheck:SetText( "Class Meter" );
MeterCheck:SetPosition( 20, 760 );

MOS = SettingsScroll();
MOS:SetPosition( 100, 770 );
MOS:SetMaximum( 100 );
MOS:SetMinimum( 0 );
MOS:SetSmallChange( 1 );
MOS:SetLargeChange( 10 );

MOSLabel = Turbine.UI.Label();
MOSLabel:SetParent( Swindow );
MOSLabel:SetSize( 250, 30 );
MOSLabel:SetMouseVisible( false );
MOSLabel:SetPosition( 398, 770 );

Managercheck = Checkbox();
Managercheck:SetText( "Load With Manager" );
Managercheck:SetPosition( 20, 800 );

Recenterbutton = Turbine.UI.Lotro.Button();
Recenterbutton:SetSize( 80, 30 );
Recenterbutton:SetText( "Recenter" );
Recenterbutton:SetVisible( true );
Recenterbutton:SetParent( Swindow );
Recenterbutton:SetPosition( 110, 810 );
Recenterbutton.MouseClick = function()
	Primwin:RecenterControls()
end

OOCcritbox = Turbine.UI.Control();
OOCcritbox:SetParent( Swindow );
OOCcritbox:SetSize( 150, 30 );
OOCcritbox:SetPosition( 200, 790 );
OOCcritbox:SetBackground( "CajePlugins/HUDPlus/Resources/Dropboxface.tga" );


OOCcritchoice1 = Turbine.UI.Control();
OOCcritchoice1:SetSize( 150, 30 );
OOCcritchoice1:SetPosition( 200, 820 );
OOCcritchoice1:SetBackground( "CajePlugins/HUDPlus/Resources/Dropboxmid.tga" );
OOCcritchoice1:SetParent( Swindow );
OOCcritchoice1:SetVisible( false );

OOCcritchoice2 = Turbine.UI.Control();
OOCcritchoice2:SetSize( 150, 30 );
OOCcritchoice2:SetPosition( 200, 850 );
OOCcritchoice2:SetBackground( "CajePlugins/HUDPlus/Resources/Dropboxmid.tga" );
OOCcritchoice2:SetParent( Swindow );
OOCcritchoice2:SetVisible( false );

OOCcritchoice3 = Turbine.UI.Control();
OOCcritchoice3:SetSize( 150, 30 );
OOCcritchoice3:SetPosition( 200, 880 );
OOCcritchoice3:SetBackground( "CajePlugins/HUDPlus/Resources/Dropboxmid.tga" );
OOCcritchoice3:SetParent( Swindow );
OOCcritchoice3:SetVisible( false );

OOCcritchoice4 = Turbine.UI.Control();
OOCcritchoice4:SetSize( 150, 30 );
OOCcritchoice4:SetPosition( 200, 910 );
OOCcritchoice4:SetBackground( "CajePlugins/HUDPlus/Resources/Dropboxend.tga" );
OOCcritchoice4:SetParent( Swindow );
OOCcritchoice4:SetVisible( false );

OOClabel1 = Dropdownlabel();
OOClabel1:SetPosition( 215, 800 );
OOClabel1:SetVisible( true );
OOClabel1:SetText( OOCcrit )

OOClabel2 = Dropdownlabel();
OOClabel2:SetPosition( 215, 830 );
OOClabel2:SetText( "Vitals 100%" )

OOClabel3 = Dropdownlabel();
OOClabel3:SetPosition( 215, 860 );
OOClabel3:SetText( "100% Morale" )

OOClabel4 = Dropdownlabel();
OOClabel4:SetPosition( 215, 890 );
OOClabel4:SetText( "100% Power" )

OOClabel5 = Dropdownlabel();
OOClabel5:SetPosition( 215, 920 );
OOClabel5:SetText( "Out of Combat" )

HText = Turbine.UI.Label();
HText:SetText( "Help:" );
HText:SetParent( SwindowMaster );
HText:SetPosition( 15, 35 );
HText:SetSize( 500, 80 );
