MeterWin = MeterWinClass();
MeterWin:SetPosition( 90 + Primwin:GetLeft(), 195 + Primwin:GetTop() );
MeterWin:SetBackground( "CajePlugins/HUDPlus/Resources/MeterBack.tga" );

MeterRail = Turbine.UI.Window();
MeterRail:SetSize( 255, 30 );
MeterRail:SetPosition( 90 + Primwin:GetLeft() , 195 + Primwin:GetTop() );
MeterRail:SetVisible( false );
MeterRail:SetMouseVisible( false );
MeterRail:SetOpacity( .3 );
MeterRail:SetZOrder( 2 );

MeterBar = Turbine.UI.Control();
MeterBar:SetParent( MeterWin );
MeterBar:SetSize( 255, 30 );
MeterBar:SetVisible( true );
MeterBar:SetMouseVisible( false );
MeterBar:SetZOrder( 0 );
MeterBar:SetOpacity( .3 );
MeterBar:SetBlendMode( Turbine.UI.BlendMode.Overlay );

function MeterWin:ScanFervour()
	CurFervour = ChmpAtts:GetFervor()
	MeterBar:SetPosition( ( CurFervour * 51 ) - 255, 0 )
end

function MeterWin:ScanFocus()
	CurFocus = HntAtts:GetFocus()
	MeterBar:SetPosition( ( CurFocus * 28.3333 ) - 255, 0 )
end

function MeterWin:ScanAttunement()
	CurAtt = RKAtts:GetAttunement()
	MeterBar:SetPosition( ( math.abs(CurAtt - 10) * 28.3333 ) - 255, 0 )
	if CurAtt < 10 then MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorCHMP.tga" )
	elseif CurAtt > 10 then MeterBar:SetBackground( "CajePlugins/HUDPlus/Resources/MeterColorRK.tga" )
	end
end