--OPTIONS WINDOW FUNCTIONS

function SwindowMaster:VisibleChanged()
	if SwindowMaster:IsVisible() == true then
	Optoverride = "1"
	elseif SwindowMaster:IsVisible() == false then
	Optoverride = "0"
	DHitWarn:FadeStart()
	Primwin:FadeStart()
	PanicCD:SetMouseVisible( false )
	IntCD:SetMouseVisible( false )
	CorrCD:SetMouseVisible( false )
	BubbleCD:SetMouseVisible( false )
	C1CD:SetMouseVisible( false )
	C2CD:SetMouseVisible( false )
	Colorwindow:SetVisible( false )
	end
end

function Barcheck:CheckedChanged()
	if Barcheck:IsChecked() == true then
	Bars = "1"
	else Bars = "0" 
	MBar:SetVisible( false )
	MBarWin:SetVisible( false )
	PBarWin:SetVisible( false )
	PBar:SetVisible( false )
	MBarRail:SetVisible( false )
	PBarRail:SetVisible( false )
	end
end

function QScheck:CheckedChanged()
	if QScheck:IsChecked() == true then
	quickslots = "1"
	else quickslots = "0"
	MQS:SetVisible( false )
	PQS:SetVisible( false )
	DQS:SetVisible( false )
	PoQS:SetVisible( false )
	FQS:SetVisible( false )
	WQS:SetVisible( false )
	PQSG:SetVisible( false )
	MQSG:SetVisible( false )
	DQSG:SetVisible( false )
	PoQSG:SetVisible( false )
	FQSG:SetVisible( false )
	WQSG:SetVisible( false )
	end
end

function MWarncheck:CheckedChanged()
	if MWarncheck:IsChecked() == true then
	Moralewarn = "1"
	else Moralewarn = "0"
	MWarn:SetVisible( false )
	end
end

function PWarncheck:CheckedChanged()
	if PWarncheck:IsChecked() == true then
	Powerwarn = "1" 
	else Powerwarn = "0"
	PWarn:SetVisible( false )
	end
end

function DHitWarncheck:CheckedChanged()
	if DHitWarncheck:IsChecked() == true then
	DHitWarning = "1" 
	else DHitWarning = "0"
	DHitWarn:SetVisible( false )
	end
end

function InterruptCDcheck:CheckedChanged()
	if InterruptCDcheck:IsChecked() == true then
	InterruptCD = "1"
	else InterruptCD = "0"
	IntCD:SetVisible( false )
	end
end

function CorruptionCDcheck:CheckedChanged()
	if CorruptionCDcheck:IsChecked() == true then
	CorruptionCD = "1"
	else CorruptionCD = "0"
	CorrCD:SetVisible( false )
	end
end

function PanCDcheck:CheckedChanged()
	if PanCDcheck:IsChecked() == true then
	PanCD = "1"
	else PanCD = "0"
	PanicCD:SetVisible( false )
	end
end

function BubCDcheck:CheckedChanged()
	if BubCDcheck:IsChecked() == true then
	BubCD = "1"
	else BubCD = "0"
	BubbleCD:SetVisible( false )
	end
end

function Textcheck:CheckedChanged()
	if Textcheck:IsChecked() == true then
	Text = "1"
	PTWin:SetVisible( true )
	MTWin:SetVisible( true )
	else Text = "0"
	PTWin:SetVisible( false )
	MTWin:SetVisible( false )
	end
end

function LowScroll:ValueChanged()
	LowLevel = LowScroll:GetValue()
	LowLevelT = ( LowLevel / 100 )
	LowScrollLabel:SetText( ( LowLevel ).."% - Low" )
	CriticalScroll:SetMaximum( LowLevel )
end

function CriticalScroll:ValueChanged()
	CritLevel = CriticalScroll:GetValue()
	CritLevelT = ( CritLevel / 100 )
	CriticalScrollLabel:SetText( ( CritLevel ).."% - Critical" )
end

--Shell commands

hudplusCommand = Turbine.ShellCommand();

function hudplusCommand:Execute(cmd, args)
	if (args == "options" ) then 
	SwindowMaster:SetVisible( true )
	elseif (args == "hide") then 
	SwindowMaster:SetVisible( false )
	elseif (args ~= nil) then
		hudplusCommand:GetHelp();
	end
end

function hudplusCommand:GetHelp()
	Turbine.Shell.WriteLine( "/hudplus options opens the settings window." )
	Turbine.Shell.WriteLine( "/hudplus hide hides the settings window if open." )
end

Turbine.Shell.AddCommand("hudplus", hudplusCommand)

function PLowScroll:ValueChanged()
	PLowLevel = PLowScroll:GetValue()
	PLowLevelT = ( PLowLevel / 100 )
	PLowScrollLabel:SetText( ( PLowLevel ).."% - Low" )
	PCriticalScroll:SetMaximum( PLowLevel )
end

function PCriticalScroll:ValueChanged()
	PCritLevel = PCriticalScroll:GetValue()
	PCritLevelT = ( PCritLevel / 100 )
	PCriticalScrollLabel:SetText( ( PCritLevel ).."% - Critical" )
end

function DHitScroll:ValueChanged()
	DHitLevel = DHitScroll:GetValue()
	DHitScrollLabel:SetText( DHitLevel.." - Hit Size" )
end

function MQSO:ShortcutChanged()
	MShortcut = MQSO:GetShortcut()
	MSType = MShortcut:GetType()
	MSData = MShortcut:GetData()
	if MSType == Turbine.UI.Lotro.ShortcutType.Item then
	MSItem = MShortcut:GetItem()
		if MSItem:GetQuantity() ~= nil then
		MQty = MSItem:GetQuantity()
		MQL:SetText( MQty )
		elseif MSItem:GetQuantity() == nil then
		MQty = 0 
		MQL:SetText( 0 )
		elseif MSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		MQty = "N/A"
		MQL:SetText( " " )
		MSItem = nil
		end
	elseif MSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		MQty = ""
		MQL:SetText( "" )
		MSItem = nil
	end
	MQS:SetShortcut( MShortcut )
end

function PQSO:ShortcutChanged()
	PShortcut = PQSO:GetShortcut()
	PSType = PShortcut:GetType()
	PSData = PShortcut:GetData()
	if PSType == Turbine.UI.Lotro.ShortcutType.Item then
	PSItem = PShortcut:GetItem()
		if PSItem:GetQuantity() ~= nil then
		PQty = PSItem:GetQuantity()
		PQL:SetText( PQty )
		elseif PSItem:GetQuantity() == nil then
		PQty = 0 
		PQL:SetText( 0 )
		elseif PSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		PQty = "N/A"
		PQL:SetText( " " )
		PSItem = nil
		end
	elseif PSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		PQty = ""
		PQL:SetText( "" )
		PSItem = nil
	end
	PQS:SetShortcut( PShortcut )
end

function DQSO:ShortcutChanged()
	DShortcut = DQSO:GetShortcut()
	DSType = DShortcut:GetType()
	DSData = DShortcut:GetData()
	if DSType == Turbine.UI.Lotro.ShortcutType.Item then
	DSItem = DShortcut:GetItem()
		if DSItem:GetQuantity() ~= nil then
		DQty = DSItem:GetQuantity()
		DQL:SetText( DQty )
		elseif DSItem:GetQuantity() == nil then
		DQty = 0 
		DQL:SetText( 0 )
		end
	elseif DSType ~= Turbine.UI.Lotro.ShortcutType.Item then
	DQty = "N/A"
	DQL:SetText( " " )
	DSItem = nil
	end
	DQS:SetShortcut( DShortcut )
end

function PoQSO:ShortcutChanged()
	PoShortcut = PoQSO:GetShortcut()
	PoSType = PoShortcut:GetType()
	PoSData = PoShortcut:GetData()
	if PoSType == Turbine.UI.Lotro.ShortcutType.Item then
	PoSItem = PoShortcut:GetItem()
		if PoSItem:GetQuantity() ~= nil then
		PoQty = PoSItem:GetQuantity()
		PoQL:SetText( PoQty )
		elseif PoSItem:GetQuantity() == nil then
		PoQty = 0 
		PoQL:SetText( 0 )
		elseif PoSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		PoQty = "N/A"
		PoQL:SetText( " " )
		PoSItem = nil
		end
	elseif PoSType ~= Turbine.UI.Lotro.ShortcutType.Item then
	PoQty = "N/A"
	PoQL:SetText( " " )
	PoSItem = nil
	end
	PoQS:SetShortcut( PoShortcut )
end

function FQSO:ShortcutChanged()
	FShortcut = FQSO:GetShortcut()
	FSType = FShortcut:GetType()
	FSData = FShortcut:GetData()
	if FSType == Turbine.UI.Lotro.ShortcutType.Item then
	FSItem = FShortcut:GetItem()
		if FSItem:GetQuantity() ~= nil then
		FQty = FSItem:GetQuantity()
		FQL:SetText( FQty )
		elseif FSItem:GetQuantity() == nil then
		FQty = 0 
		FQL:SetText( 0 )
		elseif FSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		FQty = "N/A"
		FQL:SetText( " " )
		FSItem = nil
		end
	elseif FSType ~= Turbine.UI.Lotro.ShortcutType.Item then
	FQty = "N/A"
	FQL:SetText( " " )
	FSItem = nil
	end
	FQS:SetShortcut( FShortcut )
end

function WQSO:ShortcutChanged()
	WShortcut = WQSO:GetShortcut()
	WSType = WShortcut:GetType()
	WSData = WShortcut:GetData()
	if WSType == Turbine.UI.Lotro.ShortcutType.Item then
	WSItem = WShortcut:GetItem()
		if WSItem:GetQuantity() ~= nil then
		WQty = WSItem:GetQuantity()
		WQL:SetText( WQty )
		elseif WSItem:GetQuantity() == nil then
		WQty = 0 
		WQL:SetText( 0 )
		elseif WSType ~= Turbine.UI.Lotro.ShortcutType.Item then
		WQty = "N/A"
		WQL:SetText( " " )
		WSItem = nil
		end
	elseif WSType ~= Turbine.UI.Lotro.ShortcutType.Item then
	WQty = "N/A"
	WQL:SetText( " " )
	WSItem = nil
	end
	WQS:SetShortcut( WShortcut )
end

function BOS:ValueChanged()
	BOpF = BOS:GetValue()
	BOSLabel:SetText( BOpF.."% Bar Opacity" )
	BopT = (BOpF / 100)
	MBarWin:SetOpacity( BopT )
	MBarRail:SetOpacity( BopT )
	PBarRail:SetOpacity( BopT )
	PBarWin:SetOpacity( BopT )
end

function MOS:ValueChanged()
	MopF = MOS:GetValue()
	MOSLabel:SetText( MopF.."% Opacity" )
	MopT = (MopF / 100)
	MeterWin:SetOpacity( MopT )
	MeterRail:SetOpacity( MopT )
end

function MWOS:ValueChanged()
	MWopF = MWOS:GetValue()
	MWOSLabel:SetText( MWopF.."% Opacity" )
	MWopT = (MWopF / 100)
	MWarn:SetOpacity( MWopT )
end

function PWOS:ValueChanged()
	PWopF = PWOS:GetValue()
	PWOSLabel:SetText( PWopF.."% Opacity" )
	PWopT = (PWopF / 100)
	PWarn:SetOpacity( PWopT )
end

function DHOS:ValueChanged()
	DHopF = DHOS:GetValue()
	DHOSLabel:SetText( DHopF.."% Opacity" )
	DHopT = (DHopF / 100)
	DHitWarn:SetOpacity( DHopT )
end

function PanScroll:ValueChanged()
	PaniCD = ( 60 * PanScroll:GetValue() )
	PSL:SetText( PanScroll:GetValue() )
end

function BubScroll:ValueChanged()
	BubbCD = ( 60 * BubScroll:GetValue() )
	BSL:SetText( BubScroll:GetValue() )
end

function IntScroll:ValueChanged()
	IntrCD = ( 60 * IntScroll:GetValue() )
	ISL:SetText( IntScroll:GetValue() )
end

function CorScroll:ValueChanged()
	CorruCD = ( 60 * CorScroll:GetValue() )
	CSL:SetText( CorScroll:GetValue() )
end

function C1Scroll:ValueChanged()
	C1SL:SetText( C1Scroll:GetValue() )
end

function C2Scroll:ValueChanged()
	C2SL:SetText( C2Scroll:GetValue() )
end

function IndOnlycheck:CheckedChanged()
	if IndOnlycheck:IsChecked() == true then
	IndOnly = "1" 
	else IndOnly = "0"
	end
end

function PanicCD:TimerStart()
	PanRdytime = ( FrameTime + ( PanScroll:GetValue() ) )
	PanCDing = "1"
end

function BubbleCD:TimerStart()
	BubRdytime = ( FrameTime + ( BubScroll:GetValue() ) )
	BubCDing = "1"
end

function IntCD:TimerStart()
	IntRdytime = ( FrameTime + ( IntScroll:GetValue() ) )
	IntCDing = "1"
end

function CorrCD:TimerStart()
	CorrRdytime = ( FrameTime + ( CorScroll:GetValue() ) )
	CorrCDing = "1"
end

function C1CD:TimerStart()
	C1Rdytime = ( FrameTime + ( C1Scroll:GetValue() ) )
	Cus1CDing = "1"
end

function C2CD:TimerStart()
	C2Rdytime = ( FrameTime + ( C2Scroll:GetValue() ) )
	Cus2CDing = "1"
end

function C1check:CheckedChanged()
	if C1check:IsChecked() == true then
	Cus1CD = "1"
	else Cus1CD = "0"
	C1CD:SetVisible( false )
	end
end

function C2check:CheckedChanged()
	if C2check:IsChecked() == true then
	Cus2CD = "1"
	else Cus2CD = "0"
	C2CD:SetVisible( false )
	end
end

function OOCcritbox:MouseClick()
	if OOCcritchoice1:IsVisible() == false then
	OOCcritchoice1:SetVisible( true )
	OOCcritchoice2:SetVisible( true )
	OOCcritchoice3:SetVisible( true )
	OOCcritchoice4:SetVisible( true )
	OOClabel2:SetVisible( true )
	OOClabel3:SetVisible( true )
	OOClabel4:SetVisible( true )
	OOClabel5:SetVisible( true )
	elseif OOCcritchoice1:IsVisible() == true then
	OOCcritchoice1:SetVisible( false )
	OOCcritchoice2:SetVisible( false )
	OOCcritchoice3:SetVisible( false )
	OOCcritchoice4:SetVisible( false )
	OOClabel2:SetVisible( false )
	OOClabel3:SetVisible( false )
	OOClabel4:SetVisible( false )
	OOClabel5:SetVisible( false )
	end
end

function OOCcritchoice1:MouseClick()
	OOCcrit = "Vitals 100%"
	OOClabel1:SetText( OOCcrit )
	OOCcritchoice1:SetVisible( false )
	OOCcritchoice2:SetVisible( false )
	OOCcritchoice3:SetVisible( false )
	OOCcritchoice4:SetVisible( false )
	OOClabel2:SetVisible( false )
	OOClabel3:SetVisible( false )
	OOClabel4:SetVisible( false )
	OOClabel5:SetVisible( false )
end
function OOCcritchoice2:MouseClick()
	OOCcrit = "100% Morale"
	OOClabel1:SetText( OOCcrit )
	OOCcritchoice1:SetVisible( false )
	OOCcritchoice2:SetVisible( false )
	OOCcritchoice3:SetVisible( false )
	OOCcritchoice4:SetVisible( false )
	OOClabel2:SetVisible( false )
	OOClabel3:SetVisible( false )
	OOClabel4:SetVisible( false )
	OOClabel5:SetVisible( false )
end
function OOCcritchoice3:MouseClick()
	OOCcrit = "100% Power"
	OOClabel1:SetText( OOCcrit )
	OOCcritchoice1:SetVisible( false )
	OOCcritchoice2:SetVisible( false )
	OOCcritchoice3:SetVisible( false )
	OOCcritchoice4:SetVisible( false )
	OOClabel2:SetVisible( false )
	OOClabel3:SetVisible( false )
	OOClabel4:SetVisible( false )
	OOClabel5:SetVisible( false )
end
function OOCcritchoice4:MouseClick()
	OOCcrit = "Out of Combat"
	OOClabel1:SetText( OOCcrit )
	OOCcritchoice1:SetVisible( false )
	OOCcritchoice2:SetVisible( false )
	OOCcritchoice3:SetVisible( false )
	OOCcritchoice4:SetVisible( false )
	OOClabel2:SetVisible( false )
	OOClabel3:SetVisible( false )
	OOClabel4:SetVisible( false )
	OOClabel5:SetVisible( false )
end

function Managercheck:CheckedChanged()
	if Managercheck:IsChecked() == true then
	loadwithman = "1"
	else loadwithman = "0"
	end
end

function MeterCheck:CheckedChanged()
	if MeterCheck:IsChecked() == true then
	Meter = "1"
	else Meter = "0" 
	MeterBar:SetVisible( false )
	MeterWin:SetVisible( false )
	MeterRail:SetVisible( false )
	end
end

Savebutton = Turbine.UI.Lotro.Button();
Savebutton:SetSize( 80, 30 );
Savebutton:SetText( "Save" );
Savebutton:SetVisible( true );
Savebutton:SetParent( SwindowMaster );
Savebutton:SetPosition( 235, 570 );

function Savebutton:MouseClick()
	HUDPlus:SaveData()
	Turbine.Shell.WriteLine( "HUDPlus configuration saved." )
end

--Help tooltips

function Barcheck:MouseEnter()
	HText:SetText( "Help: Enables the morale and power bar display." )
end

function Barcheck:MouseLeave()
	HText:SetText( "Help: " )
end

function QScheck:MouseEnter()
	HText:SetText( "Help: Enables the condition indicator quickslots." )
end

function QScheck:MouseLeave()
	HText:SetText( "Help: " )
end

function MWarncheck:MouseEnter()
	HText:SetText( "Help: Enables the low morale warning." )
end

function MWarncheck:MouseLeave()
	HText:SetText( "Help: " )
end

function PWarncheck:MouseEnter()
	HText:SetText( "Help: Enables the low power warning." )
end

function PWarncheck:MouseLeave()
	HText:SetText( "Help: " )
end

function DHitWarncheck:MouseEnter()
	HText:SetText( "Help: Enables the devastating hit warning." )
end

function DHitWarncheck:MouseLeave()
	HText:SetText( "Help: " )
end

function InterruptCDcheck:MouseEnter()
	HText:SetText( "Help: Enables the interruption cooldown status indicator." )
end

function InterruptCDcheck:MouseLeave()
	HText:SetText( "Help: " )
end
function BubCDcheck:MouseEnter()
	HText:SetText( "Help: Enables the bubble cooldown status indicator." )
end

function BubCDcheck:MouseLeave()
	HText:SetText( "Help: " )
end
function PanCDcheck:MouseEnter()
	HText:SetText( "Help: Enables the panic cooldown status indicator." )
end

function PanCDcheck:MouseLeave()
	HText:SetText( "Help: " )
end
function CorruptionCDcheck:MouseEnter()
	HText:SetText( "Help: Enables the corruption removal cooldown status indicator." )
end

function CorruptionCDcheck:MouseLeave()
	HText:SetText( "Help: " )
end
function Textcheck:MouseEnter()
	HText:SetText( "Help: Enables the morale and power values and percentages display." )
end

function Textcheck:MouseLeave()
	HText:SetText( "Help: " )
end
function LowScroll:MouseEnter()
	HText:SetText( "Help: This determines the level of health, in percent, at which the plugin will consider your health 'low'. This affects how some UI elements behave." )
end

function LowScroll:MouseLeave()
	HText:SetText( "Help: " )
end
function CriticalScroll:MouseEnter()
	HText:SetText( "Help: This determines the level of health, in percent, at which the plugin will consider your health 'critical'. This affects how some UI elements behave." )
end

function CriticalScroll:MouseLeave()
	HText:SetText( "Help: " )
end
function PLowScroll:MouseEnter()
	HText:SetText( "Help: This determines the level of power, in percent, at which the plugin will consider your power 'low'. This affects how some UI elements behave." )
end

function PLowScroll:MouseLeave()
	HText:SetText( "Help: " )
end
function PCriticalScroll:MouseEnter()
	HText:SetText( "Help: This determines the level of power, in percent, at which the plugin will consider your power 'critical'. This affects how some UI elements behave." )
end

function PCriticalScroll:MouseLeave()
	HText:SetText( "Help: " )
end
function DHitScroll:MouseEnter()
	HText:SetText( "Help: This determines the amount of damage you must take in one hit in order for the devastating hit warning to appear." )
end

function DHitScroll:MouseLeave()
	HText:SetText( "Help: " )
end

function DQSO:MouseEnter()
	HText:SetText( "Help: Drag your disease cure potion here. This will place it in the indicator quickslot on the HUD." )
end

function DQSO:MouseLeave()
	HText:SetText( "Help: " )
end

function MQSO:MouseEnter()
	HText:SetText( "Help: Drag your morale potion here. This will place it in the indicator quickslot on the HUD." )
end

function MQSO:MouseLeave()
	HText:SetText( "Help: " )
end

function PQSO:MouseEnter()
	HText:SetText( "Help: Drag your power potion here. This will place it in the indicator quickslot on the HUD." )
end

function PQSO:MouseLeave()
	HText:SetText( "Help: " )
end

function PoQSO:MouseEnter()
	HText:SetText( "Help: Drag your poison cure potion here. This will place it in the indicator quickslot on the HUD." )
end

function PoQSO:MouseLeave()
	HText:SetText( "Help: " )
end

function WQSO:MouseEnter()
	HText:SetText( "Help: Drag your wound cure potion here. This will place it in the indicator quickslot on the HUD." )
end

function WQSO:MouseLeave()
	HText:SetText( "Help: " )
end

function FQSO:MouseEnter()
	HText:SetText( "Help: Drag your fear cure potion here. This will place it in the indicator quickslot on the HUD." )
end

function FQSO:MouseLeave()
	HText:SetText( "Help: " )
end
function IndOnlycheck:MouseEnter()
	HText:SetText( "Help: Toggles condition indicators between quickslots and solely indicators." )
end

function IndOnlycheck:MouseLeave()
	HText:SetText( "Help: " )
end
function BOS:MouseEnter()
	HText:SetText( "Help: Sets the opacity [transparency] of the morale and power bars, in percent. A value of 100% is completely opaque, a value of 0% is transparent and invisible." )
end

function BOS:MouseLeave()
	HText:SetText( "Help: " )
end
function MWOS:MouseEnter()
	HText:SetText( "Help: Sets the opacity [transparency] of the low morale warning, in percent. A value of 100% is completely opaque, a value of 0% is transparent and invisible." )
end

function MWOS:MouseLeave()
	HText:SetText( "Help: " )
end
function PWOS:MouseEnter()
	HText:SetText( "Help: Sets the opacity [transparency] of the low power warning, in percent. A value of 100% is completely opaque, a value of 0% is transparent and invisible." )
end

function PWOS:MouseLeave()
	HText:SetText( "Help: " )
end
function DHOS:MouseEnter()
	HText:SetText( "Help: Sets the opacity [transparency] of the devastating hit warning, in percent. A value of 100% is completely opaque, a value of 0% is transparent and invisible." )
end

function DHOS:MouseLeave()
	HText:SetText( "Help: " )
end

function Pantext:MouseEnter()
	HText:SetText( "Help: Type the name of your desired panic skill into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function Pantext:MouseLeave()
	HText:SetText( "Help: " )
end

function Bubtext:MouseEnter()
	HText:SetText( "Help: Type the name of your desired bubble skill into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function Bubtext:MouseLeave()
	HText:SetText( "Help: " )
end

function Inttext:MouseEnter()
	HText:SetText( "Help: Type the name of your desired interrupt skill into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function Inttext:MouseLeave()
	HText:SetText( "Help: " )
end

function Cortext:MouseEnter()
	HText:SetText( "Help: Type the name of your desired corruption removal skill into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function Cortext:MouseLeave()
	HText:SetText( "Help: " )
end

function C1text:MouseEnter()
	HText:SetText( "Help: Type the name of your desired skill or item into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function C1text:MouseLeave()
	HText:SetText( "Help: " )
end

function C2text:MouseEnter()
	HText:SetText( "Help: Type the name of your desired skill or item into this box. It must be typed exactly as is in-game, capitals included. NOTE: Special characters must be copied directly from the chat log or created using keyboard commands. Do not include any part of the skill name after a parenthese. NOTE: DO NOT LEAVE THIS FIELD BLANK." )
end

function C2text:MouseLeave()
	HText:SetText( "Help: " )
end

function PanScroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your panic skill in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function PanScroll:MouseLeave()
	HText:SetText( "Help: " )
end

function BubScroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your bubble skill in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function BubScroll:MouseLeave()
	HText:SetText( "Help: " )
end

function IntScroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your interrupt skill in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function IntScroll:MouseLeave()
	HText:SetText( "Help: " )
end

function CorScroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your corruption removal skill in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function CorScroll:MouseLeave()
	HText:SetText( "Help: " )
end

function C1Scroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your skill or item in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function C1Scroll:MouseLeave()
	HText:SetText( "Help: " )
end

function C2Scroll:MouseEnter()
	HText:SetText( "Help: This is the cooldown of your skill or item in seconds. Upon usage of the skill, the on-screen indicator will time your cooldown to show whether it is ready to use or not. Note that this will not work properly if the skill name is not correctly typed in." )
end

function C2Scroll:MouseLeave()
	HText:SetText( "Help: " )
end

function C1check:MouseEnter()
	HText:SetText( "Help: This enables the custom cooldown status indicator. [LEFT]" )
end

function C1check:MouseLeave()
	HText:SetText( "Help: " )
end

function C2check:MouseEnter()
	HText:SetText( "Help: This enables the custom cooldown status indicator. [RIGHT]" )
end

function C2check:MouseLeave()
	HText:SetText( "Help: " )
end
function Managercheck:MouseEnter()
	HText:SetText( "Help: Check this if you load this plugin using the LotRO Plugin Manager. This ensures your quickslots will load properly and not be reset. Uncheck if not using manager." )
end

function Managercheck:MouseLeave()
	HText:SetText( "Help: " )
end
function OOCcritbox:MouseEnter()
	HText:SetText( "Help: Governs the conditions under which the plugin considers you 'out of combat'. When 'out of combat', the HUD fades off the screen." )
end

function OOCcritbox:MouseLeave()
	HText:SetText( "Help: " )
end

function Recenterbutton:MouseEnter()
	HText:SetText( "Help: Places all UI elements back to their original positions." )
end

function Recenterbutton:MouseLeave()
	HText:SetText( "Help: " )
end
function MeterCheck:MouseEnter()
	HText:SetText( "Help: This enables the fervour/focus/attunement meter for the applicable classes. Disabled for non-applicable classes." )
end

function MeterCheck:MouseLeave()
	HText:SetText( "Help: " )
end
function Colorbutton:MouseEnter()
	HText:SetText( "Help: Change the colors of the text and bars." )
end

function Colorbutton:MouseLeave()
	HText:SetText( "Help: " )
end